/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "grammar.y"


#include <ctype.h>
#include <string.h>

#define import_spp
#define import_libc
#define import_stdio
#include <iraf.h>

#include "config.h"
#include "mem.h"
#include "operand.h"
#include "param.h"
#include "grammar.h"
#include "opcodes.h"
#include "clmodes.h"
#include "task.h"
#include "construct.h"
#include "errs.h"
#include "proto.h"


/* CL parser, written as a yacc grammar:
 *   build up an (rpn) instruction sequence begining at the base of the
 *   operand stack as the grammar is recognized.
 *
 * The parser may be called during parameter initialization (initiated by
 * the CALL meta-code instruction), and to parse the executable portion
 * (from the EXEC instruction).
 *
 * CONSTANT's are put on the dictionary by addconst() rather than the operand
 *   stack to avoid conflict with the code being created.  They are accessed
 *   by using the yylval of IDENT and CONSTANT as dictionary indices that
 *   point to struct operands.  This is facilitated with the stkop() macro.
 *   Make sure that topd and topcs are restored on return to discard these
 *   temporaries.
 * When building offsets for branches, such as BIFF and GOTO, allow
 *   for the advancement of the pc by the size of the instruction (in ints).
 *   See opcodes.c for the code executed by the branch instructions.
 */

extern	int cldebug;
#define	lint			/* turns off sccsid in Yacc parser	*/

/* shorthand way to get at operands in dictionary. x will be values returned
 * from addconst() by way of $n's from CONSTANT and IDENT tokens; see gram.c
 * and its uses in grammar.l. also see pushop() for a description of the stack.
 */
#define	stkop(x)	(reference (operand, (x)))

int	dobkg = 0;		/* set when want to do code in bkground	*/
int	npipes = 0;		/* number of pipes in a command		*/
XINT	pipe_pc;		/* pc of last ADDPIPE instruction	*/
int	posit = 0;		/* positional argument count		*/
int	inarglist = 0;		/* set when in argument list		*/
int	parenlevel = 0;		/* level of paren nesting in command	*/
int	index_cnt;		/* Index counter in array ref's		*/
char	curr_param[SZ_FNAME];	/* Parameter name of ref's		*/
char	curr_task[SZ_FNAME];	/* ltaskname of command 		*/
XINT	stmt_pc;		/* PC at beginning of current statement */
int	varlist;		/* Declaration is list directed.	*/
int	vartype;		/* Type of declaration.			*/
int	do_params;		/* Are param definitions legal here?	*/
int	errcnt;			/* Syntax error count.			*/
int	inited;			/* Was variable already initialized.	*/
struct	param *pp;		/* Pointer to param being compiled.	*/
int	n_aval;			/* Number of array init values.		*/
int	lastref;		/* Was last ref an array?		*/
int	for_expr;		/* Was there an expression in FOR?	*/
char	*ifseen;		/* Have we just processed an IF?	*/

/* context-sensitive switches. technique is ok, but beware of nesting!
 */
static	int absmode = 0;	/* set by first absolute mode arg in cmd*/
static	int newstdout = 0;	/* set if stdout redirected in arg	*/
static	int bracelevel = 0;	/* set while in s_list to inhibit &	*/
static	int tbrace = 0;		/* fake braces for declarations		*/
static	int dobrace = 0;	/* handling braces.			*/
static	int sawnl = 0;		/* set when EOST was \n, else 0		*/
static	int printstmt = 0;	/* set when parsing FPRINT statement	*/
static	int scanstmt = 0;	/* set when parsing SCAN statement	*/

/* printf-format error messages.
 */
char	*posfirst = "All positional arguments must be first\n";
/* char	*look_parm= "Error searching for parameter `%s'."; */
char	*inval_arr= "Invalid array type for `%s'.";
char	*inv_index= "Invalid index definition for `%s'.";
char	*arrdeferr= "Error in array initialization for `%s'.";
/* char	*arrinbrack="Array initialization must be in brackets for `%s'."; */
char	*badparm =  "Parameter definition of `%s' is illegal here.";
char	*illegalvar="Illegal variable declarations.";
char	*locallist= "Local list variables are not permitted.";
char	*twoinits = "Two initializations for parameter `%s'.";
char	*exlimits = "Explicit range required for loop in external param.\n";

extern	char	cmdblk[SZ_CMDBLK+1];	/* Command buffer in history.c */
extern	char	*ip_cmdblk;		/* Pointer to current char in command.*/
extern	char	*err_cmdblk;		/* ip_cmdblk when error detected. */

/* arbitrary large number for bracelevel in a procedure script 
 */
#define MAX_ERR    10
#define EYYERROR  { err_cmdblk = ip_cmdblk; YYERROR; }


#line 179 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    Y_SCAN = 258,                  /* Y_SCAN  */
    Y_SCANF = 259,                 /* Y_SCANF  */
    Y_FSCAN = 260,                 /* Y_FSCAN  */
    Y_FSCANF = 261,                /* Y_FSCANF  */
    Y_OSESC = 262,                 /* Y_OSESC  */
    Y_APPEND = 263,                /* Y_APPEND  */
    Y_ALLAPPEND = 264,             /* Y_ALLAPPEND  */
    Y_ALLREDIR = 265,              /* Y_ALLREDIR  */
    Y_GSREDIR = 266,               /* Y_GSREDIR  */
    Y_ALLPIPE = 267,               /* Y_ALLPIPE  */
    D_D = 268,                     /* D_D  */
    D_PEEK = 269,                  /* D_PEEK  */
    Y_NEWLINE = 270,               /* Y_NEWLINE  */
    Y_CONSTANT = 271,              /* Y_CONSTANT  */
    Y_IDENT = 272,                 /* Y_IDENT  */
    Y_WHILE = 273,                 /* Y_WHILE  */
    Y_IF = 274,                    /* Y_IF  */
    Y_ELSE = 275,                  /* Y_ELSE  */
    Y_FOR = 276,                   /* Y_FOR  */
    Y_BREAK = 277,                 /* Y_BREAK  */
    Y_NEXT = 278,                  /* Y_NEXT  */
    Y_SWITCH = 279,                /* Y_SWITCH  */
    Y_CASE = 280,                  /* Y_CASE  */
    Y_DEFAULT = 281,               /* Y_DEFAULT  */
    Y_RETURN = 282,                /* Y_RETURN  */
    Y_GOTO = 283,                  /* Y_GOTO  */
    Y_PROCEDURE = 284,             /* Y_PROCEDURE  */
    Y_BEGIN = 285,                 /* Y_BEGIN  */
    Y_END = 286,                   /* Y_END  */
    Y_BOOL = 287,                  /* Y_BOOL  */
    Y_INT = 288,                   /* Y_INT  */
    Y_REAL = 289,                  /* Y_REAL  */
    Y_STRING = 290,                /* Y_STRING  */
    Y_FILE = 291,                  /* Y_FILE  */
    Y_STRUCT = 292,                /* Y_STRUCT  */
    Y_GCUR = 293,                  /* Y_GCUR  */
    Y_IMCUR = 294,                 /* Y_IMCUR  */
    Y_UKEY = 295,                  /* Y_UKEY  */
    Y_PSET = 296,                  /* Y_PSET  */
    YOP_AOADD = 297,               /* YOP_AOADD  */
    YOP_AOSUB = 298,               /* YOP_AOSUB  */
    YOP_AOMUL = 299,               /* YOP_AOMUL  */
    YOP_AODIV = 300,               /* YOP_AODIV  */
    YOP_AOCAT = 301,               /* YOP_AOCAT  */
    YOP_OR = 302,                  /* YOP_OR  */
    YOP_AND = 303,                 /* YOP_AND  */
    YOP_EQ = 304,                  /* YOP_EQ  */
    YOP_NE = 305,                  /* YOP_NE  */
    YOP_LE = 306,                  /* YOP_LE  */
    YOP_GE = 307,                  /* YOP_GE  */
    YOP_CONCAT = 308,              /* YOP_CONCAT  */
    YOP_NOT = 309,                 /* YOP_NOT  */
    UMINUS = 310,                  /* UMINUS  */
    YOP_POW = 311                  /* YOP_POW  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define Y_SCAN 258
#define Y_SCANF 259
#define Y_FSCAN 260
#define Y_FSCANF 261
#define Y_OSESC 262
#define Y_APPEND 263
#define Y_ALLAPPEND 264
#define Y_ALLREDIR 265
#define Y_GSREDIR 266
#define Y_ALLPIPE 267
#define D_D 268
#define D_PEEK 269
#define Y_NEWLINE 270
#define Y_CONSTANT 271
#define Y_IDENT 272
#define Y_WHILE 273
#define Y_IF 274
#define Y_ELSE 275
#define Y_FOR 276
#define Y_BREAK 277
#define Y_NEXT 278
#define Y_SWITCH 279
#define Y_CASE 280
#define Y_DEFAULT 281
#define Y_RETURN 282
#define Y_GOTO 283
#define Y_PROCEDURE 284
#define Y_BEGIN 285
#define Y_END 286
#define Y_BOOL 287
#define Y_INT 288
#define Y_REAL 289
#define Y_STRING 290
#define Y_FILE 291
#define Y_STRUCT 292
#define Y_GCUR 293
#define Y_IMCUR 294
#define Y_UKEY 295
#define Y_PSET 296
#define YOP_AOADD 297
#define YOP_AOSUB 298
#define YOP_AOMUL 299
#define YOP_AODIV 300
#define YOP_AOCAT 301
#define YOP_OR 302
#define YOP_AND 303
#define YOP_EQ 304
#define YOP_NE 305
#define YOP_LE 306
#define YOP_GE 307
#define YOP_CONCAT 308
#define YOP_NOT 309
#define UMINUS 310
#define YOP_POW 311

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Y_SCAN = 3,                     /* Y_SCAN  */
  YYSYMBOL_Y_SCANF = 4,                    /* Y_SCANF  */
  YYSYMBOL_Y_FSCAN = 5,                    /* Y_FSCAN  */
  YYSYMBOL_Y_FSCANF = 6,                   /* Y_FSCANF  */
  YYSYMBOL_Y_OSESC = 7,                    /* Y_OSESC  */
  YYSYMBOL_Y_APPEND = 8,                   /* Y_APPEND  */
  YYSYMBOL_Y_ALLAPPEND = 9,                /* Y_ALLAPPEND  */
  YYSYMBOL_Y_ALLREDIR = 10,                /* Y_ALLREDIR  */
  YYSYMBOL_Y_GSREDIR = 11,                 /* Y_GSREDIR  */
  YYSYMBOL_Y_ALLPIPE = 12,                 /* Y_ALLPIPE  */
  YYSYMBOL_D_D = 13,                       /* D_D  */
  YYSYMBOL_D_PEEK = 14,                    /* D_PEEK  */
  YYSYMBOL_Y_NEWLINE = 15,                 /* Y_NEWLINE  */
  YYSYMBOL_Y_CONSTANT = 16,                /* Y_CONSTANT  */
  YYSYMBOL_Y_IDENT = 17,                   /* Y_IDENT  */
  YYSYMBOL_Y_WHILE = 18,                   /* Y_WHILE  */
  YYSYMBOL_Y_IF = 19,                      /* Y_IF  */
  YYSYMBOL_Y_ELSE = 20,                    /* Y_ELSE  */
  YYSYMBOL_Y_FOR = 21,                     /* Y_FOR  */
  YYSYMBOL_Y_BREAK = 22,                   /* Y_BREAK  */
  YYSYMBOL_Y_NEXT = 23,                    /* Y_NEXT  */
  YYSYMBOL_Y_SWITCH = 24,                  /* Y_SWITCH  */
  YYSYMBOL_Y_CASE = 25,                    /* Y_CASE  */
  YYSYMBOL_Y_DEFAULT = 26,                 /* Y_DEFAULT  */
  YYSYMBOL_Y_RETURN = 27,                  /* Y_RETURN  */
  YYSYMBOL_Y_GOTO = 28,                    /* Y_GOTO  */
  YYSYMBOL_Y_PROCEDURE = 29,               /* Y_PROCEDURE  */
  YYSYMBOL_Y_BEGIN = 30,                   /* Y_BEGIN  */
  YYSYMBOL_Y_END = 31,                     /* Y_END  */
  YYSYMBOL_Y_BOOL = 32,                    /* Y_BOOL  */
  YYSYMBOL_Y_INT = 33,                     /* Y_INT  */
  YYSYMBOL_Y_REAL = 34,                    /* Y_REAL  */
  YYSYMBOL_Y_STRING = 35,                  /* Y_STRING  */
  YYSYMBOL_Y_FILE = 36,                    /* Y_FILE  */
  YYSYMBOL_Y_STRUCT = 37,                  /* Y_STRUCT  */
  YYSYMBOL_Y_GCUR = 38,                    /* Y_GCUR  */
  YYSYMBOL_Y_IMCUR = 39,                   /* Y_IMCUR  */
  YYSYMBOL_Y_UKEY = 40,                    /* Y_UKEY  */
  YYSYMBOL_Y_PSET = 41,                    /* Y_PSET  */
  YYSYMBOL_42_ = 42,                       /* '='  */
  YYSYMBOL_YOP_AOADD = 43,                 /* YOP_AOADD  */
  YYSYMBOL_YOP_AOSUB = 44,                 /* YOP_AOSUB  */
  YYSYMBOL_YOP_AOMUL = 45,                 /* YOP_AOMUL  */
  YYSYMBOL_YOP_AODIV = 46,                 /* YOP_AODIV  */
  YYSYMBOL_YOP_AOCAT = 47,                 /* YOP_AOCAT  */
  YYSYMBOL_YOP_OR = 48,                    /* YOP_OR  */
  YYSYMBOL_YOP_AND = 49,                   /* YOP_AND  */
  YYSYMBOL_YOP_EQ = 50,                    /* YOP_EQ  */
  YYSYMBOL_YOP_NE = 51,                    /* YOP_NE  */
  YYSYMBOL_52_ = 52,                       /* '<'  */
  YYSYMBOL_53_ = 53,                       /* '>'  */
  YYSYMBOL_YOP_LE = 54,                    /* YOP_LE  */
  YYSYMBOL_YOP_GE = 55,                    /* YOP_GE  */
  YYSYMBOL_YOP_CONCAT = 56,                /* YOP_CONCAT  */
  YYSYMBOL_57_ = 57,                       /* '+'  */
  YYSYMBOL_58_ = 58,                       /* '-'  */
  YYSYMBOL_59_ = 59,                       /* '*'  */
  YYSYMBOL_60_ = 60,                       /* '/'  */
  YYSYMBOL_61_ = 61,                       /* '%'  */
  YYSYMBOL_YOP_NOT = 62,                   /* YOP_NOT  */
  YYSYMBOL_UMINUS = 63,                    /* UMINUS  */
  YYSYMBOL_YOP_POW = 64,                   /* YOP_POW  */
  YYSYMBOL_65_ = 65,                       /* '.'  */
  YYSYMBOL_66_ = 66,                       /* '~'  */
  YYSYMBOL_67_ = 67,                       /* '{'  */
  YYSYMBOL_68_ = 68,                       /* ';'  */
  YYSYMBOL_69_ = 69,                       /* '}'  */
  YYSYMBOL_70_ = 70,                       /* '['  */
  YYSYMBOL_71_ = 71,                       /* ']'  */
  YYSYMBOL_72_ = 72,                       /* ':'  */
  YYSYMBOL_73_ = 73,                       /* '|'  */
  YYSYMBOL_74_ = 74,                       /* ','  */
  YYSYMBOL_75_ = 75,                       /* '('  */
  YYSYMBOL_76_ = 76,                       /* ')'  */
  YYSYMBOL_YYACCEPT = 77,                  /* $accept  */
  YYSYMBOL_block = 78,                     /* block  */
  YYSYMBOL_79_1 = 79,                      /* $@1  */
  YYSYMBOL_debug = 80,                     /* debug  */
  YYSYMBOL_81_2 = 81,                      /* $@2  */
  YYSYMBOL_D_XXX = 82,                     /* D_XXX  */
  YYSYMBOL_script_params = 83,             /* script_params  */
  YYSYMBOL_script_body = 84,               /* script_body  */
  YYSYMBOL_85_3 = 85,                      /* $@3  */
  YYSYMBOL_proc_stmt = 86,                 /* proc_stmt  */
  YYSYMBOL_87_4 = 87,                      /* $@4  */
  YYSYMBOL_bparam_list = 88,               /* bparam_list  */
  YYSYMBOL_param_list = 89,                /* param_list  */
  YYSYMBOL_xparam_list = 90,               /* xparam_list  */
  YYSYMBOL_var_decls = 91,                 /* var_decls  */
  YYSYMBOL_var_decl_block = 92,            /* var_decl_block  */
  YYSYMBOL_var_decl_line = 93,             /* var_decl_line  */
  YYSYMBOL_var_decl_stmt = 94,             /* var_decl_stmt  */
  YYSYMBOL_95_5 = 95,                      /* $@5  */
  YYSYMBOL_typedefs = 96,                  /* typedefs  */
  YYSYMBOL_var_decl_list = 97,             /* var_decl_list  */
  YYSYMBOL_var_decl_plus = 98,             /* var_decl_plus  */
  YYSYMBOL_var_decl = 99,                  /* var_decl  */
  YYSYMBOL_100_6 = 100,                    /* $@6  */
  YYSYMBOL_var_def = 101,                  /* var_def  */
  YYSYMBOL_102_7 = 102,                    /* $@7  */
  YYSYMBOL_var_name = 103,                 /* var_name  */
  YYSYMBOL_init_index_list = 104,          /* init_index_list  */
  YYSYMBOL_init_index_range = 105,         /* init_index_range  */
  YYSYMBOL_init_list = 106,                /* init_list  */
  YYSYMBOL_init_elem = 107,                /* init_elem  */
  YYSYMBOL_const = 108,                    /* const  */
  YYSYMBOL_number = 109,                   /* number  */
  YYSYMBOL_sign = 110,                     /* sign  */
  YYSYMBOL_options_list = 111,             /* options_list  */
  YYSYMBOL_options = 112,                  /* options  */
  YYSYMBOL_option = 113,                   /* option  */
  YYSYMBOL_begin_stmt = 114,               /* begin_stmt  */
  YYSYMBOL_expr = 115,                     /* expr  */
  YYSYMBOL_expr0 = 116,                    /* expr0  */
  YYSYMBOL_expr1 = 117,                    /* expr1  */
  YYSYMBOL_118_8 = 118,                    /* $@8  */
  YYSYMBOL_119_9 = 119,                    /* $@9  */
  YYSYMBOL_120_10 = 120,                   /* $@10  */
  YYSYMBOL_121_11 = 121,                   /* $@11  */
  YYSYMBOL_122_12 = 122,                   /* $@12  */
  YYSYMBOL_intrinsx = 123,                 /* intrinsx  */
  YYSYMBOL_scanfmt = 124,                  /* scanfmt  */
  YYSYMBOL_scanarg = 125,                  /* scanarg  */
  YYSYMBOL_intrarg = 126,                  /* intrarg  */
  YYSYMBOL_stmt = 127,                     /* stmt  */
  YYSYMBOL_c_stmt = 128,                   /* c_stmt  */
  YYSYMBOL_c_blk = 129,                    /* c_blk  */
  YYSYMBOL_130_13 = 130,                   /* $@13  */
  YYSYMBOL_131_14 = 131,                   /* $@14  */
  YYSYMBOL_s_list = 132,                   /* s_list  */
  YYSYMBOL_assign = 133,                   /* assign  */
  YYSYMBOL_134_15 = 134,                   /* $@15  */
  YYSYMBOL_equals = 135,                   /* equals  */
  YYSYMBOL_assign_oper = 136,              /* assign_oper  */
  YYSYMBOL_cmdlist = 137,                  /* cmdlist  */
  YYSYMBOL_138_16 = 138,                   /* $@16  */
  YYSYMBOL_cmdpipe = 139,                  /* cmdpipe  */
  YYSYMBOL_140_17 = 140,                   /* $@17  */
  YYSYMBOL_pipe = 141,                     /* pipe  */
  YYSYMBOL_command = 142,                  /* command  */
  YYSYMBOL_143_18 = 143,                   /* $@18  */
  YYSYMBOL_144_19 = 144,                   /* $@19  */
  YYSYMBOL_args = 145,                     /* args  */
  YYSYMBOL_146_20 = 146,                   /* $@20  */
  YYSYMBOL_arglist = 147,                  /* arglist  */
  YYSYMBOL_arg = 148,                      /* arg  */
  YYSYMBOL_file = 149,                     /* file  */
  YYSYMBOL_immed = 150,                    /* immed  */
  YYSYMBOL_inspect = 151,                  /* inspect  */
  YYSYMBOL_osesc = 152,                    /* osesc  */
  YYSYMBOL_popstk = 153,                   /* popstk  */
  YYSYMBOL_if = 154,                       /* if  */
  YYSYMBOL_if_stat = 155,                  /* if_stat  */
  YYSYMBOL_156_21 = 156,                   /* $@21  */
  YYSYMBOL_ifelse = 157,                   /* ifelse  */
  YYSYMBOL_158_22 = 158,                   /* $@22  */
  YYSYMBOL_while = 159,                    /* while  */
  YYSYMBOL_160_23 = 160,                   /* $@23  */
  YYSYMBOL_161_24 = 161,                   /* $@24  */
  YYSYMBOL_for = 162,                      /* for  */
  YYSYMBOL_163_25 = 163,                   /* $@25  */
  YYSYMBOL_164_26 = 164,                   /* $@26  */
  YYSYMBOL_165_27 = 165,                   /* $@27  */
  YYSYMBOL_xassign = 166,                  /* xassign  */
  YYSYMBOL_xexpr = 167,                    /* xexpr  */
  YYSYMBOL_switch = 168,                   /* switch  */
  YYSYMBOL_169_28 = 169,                   /* $@28  */
  YYSYMBOL_case = 170,                     /* case  */
  YYSYMBOL_171_29 = 171,                   /* $@29  */
  YYSYMBOL_172_30 = 172,                   /* $@30  */
  YYSYMBOL_default = 173,                  /* default  */
  YYSYMBOL_174_31 = 174,                   /* $@31  */
  YYSYMBOL_next = 175,                     /* next  */
  YYSYMBOL_break = 176,                    /* break  */
  YYSYMBOL_return = 177,                   /* return  */
  YYSYMBOL_end_stmt = 178,                 /* end_stmt  */
  YYSYMBOL_label_stmt = 179,               /* label_stmt  */
  YYSYMBOL_180_32 = 180,                   /* $@32  */
  YYSYMBOL_goto = 181,                     /* goto  */
  YYSYMBOL_nullstmt = 182,                 /* nullstmt  */
  YYSYMBOL_xstmt = 183,                    /* xstmt  */
  YYSYMBOL_184_33 = 184,                   /* $@33  */
  YYSYMBOL_const_expr_list = 185,          /* const_expr_list  */
  YYSYMBOL_const_expr = 186,               /* const_expr  */
  YYSYMBOL_opnl = 187,                     /* opnl  */
  YYSYMBOL_ref = 188,                      /* ref  */
  YYSYMBOL_189_34 = 189,                   /* $@34  */
  YYSYMBOL_index_list = 190,               /* index_list  */
  YYSYMBOL_191_35 = 191,                   /* $@35  */
  YYSYMBOL_index = 192,                    /* index  */
  YYSYMBOL_intrins = 193,                  /* intrins  */
  YYSYMBOL_param = 194,                    /* param  */
  YYSYMBOL_tasknam = 195,                  /* tasknam  */
  YYSYMBOL_EOST = 196,                     /* EOST  */
  YYSYMBOL_DELIM = 197,                    /* DELIM  */
  YYSYMBOL_BARG = 198,                     /* BARG  */
  YYSYMBOL_EARG = 199,                     /* EARG  */
  YYSYMBOL_LP = 200,                       /* LP  */
  YYSYMBOL_RP = 201,                       /* RP  */
  YYSYMBOL_NL = 202                        /* NL  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   937

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  77
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  126
/* YYNRULES -- Number of rules.  */
#define YYNRULES  260
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  427

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   311


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    61,     2,     2,
      75,    76,    59,    57,    74,    58,    65,    60,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    72,    68,
      52,    42,    53,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    70,     2,    71,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    67,    73,    69,    66,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    54,    55,    56,    62,
      63,    64
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   136,   136,   159,   171,   171,   191,   202,   214,   255,
     256,   256,   266,   269,   278,   283,   293,   293,   318,   318,
     340,   343,   349,   352,   355,   360,   367,   368,   371,   372,
     375,   376,   377,   414,   414,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   463,   464,   467,   485,   503,
     507,   507,   515,   520,   520,   539,   543,   554,   558,   559,
     563,   586,   603,   604,   607,   615,   636,   637,   643,   657,
     658,   660,   670,   678,   681,   682,   685,   692,   700,   701,
     714,   715,   719,   727,   731,   735,   741,   743,   747,   751,
     755,   759,   763,   772,   776,   780,   784,   788,   792,   796,
     800,   804,   808,   812,   817,   817,   830,   830,   847,   847,
     861,   861,   882,   882,   899,   900,   908,   914,   921,   927,
     933,   941,   944,   948,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   982,   983,   986,   988,   986,   993,
     994,  1000,  1005,  1016,  1016,  1028,  1033,  1034,  1035,  1036,
    1037,  1040,  1040,  1051,  1052,  1052,  1097,  1100,  1105,  1129,
    1105,  1138,  1138,  1149,  1152,  1153,  1157,  1167,  1175,  1221,
    1226,  1238,  1243,  1248,  1252,  1257,  1262,  1267,  1272,  1278,
    1283,  1294,  1299,  1306,  1313,  1319,  1326,  1337,  1337,  1370,
    1370,  1393,  1400,  1393,  1438,  1442,  1458,  1438,  1487,  1488,
    1491,  1494,  1520,  1519,  1537,  1545,  1537,  1564,  1564,  1582,
    1597,  1621,  1625,  1637,  1649,  1649,  1683,  1705,  1706,  1713,
    1713,  1759,  1760,  1816,  1817,  1820,  1836,  1837,  1840,  1877,
    1877,  1892,  1895,  1895,  1901,  1905,  1912,  1933,  1967,  1972,
    1977,  1982,  1983,  1991,  1994,  1995,  1998,  1999,  2005,  2008,
    2011
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Y_SCAN", "Y_SCANF",
  "Y_FSCAN", "Y_FSCANF", "Y_OSESC", "Y_APPEND", "Y_ALLAPPEND",
  "Y_ALLREDIR", "Y_GSREDIR", "Y_ALLPIPE", "D_D", "D_PEEK", "Y_NEWLINE",
  "Y_CONSTANT", "Y_IDENT", "Y_WHILE", "Y_IF", "Y_ELSE", "Y_FOR", "Y_BREAK",
  "Y_NEXT", "Y_SWITCH", "Y_CASE", "Y_DEFAULT", "Y_RETURN", "Y_GOTO",
  "Y_PROCEDURE", "Y_BEGIN", "Y_END", "Y_BOOL", "Y_INT", "Y_REAL",
  "Y_STRING", "Y_FILE", "Y_STRUCT", "Y_GCUR", "Y_IMCUR", "Y_UKEY",
  "Y_PSET", "'='", "YOP_AOADD", "YOP_AOSUB", "YOP_AOMUL", "YOP_AODIV",
  "YOP_AOCAT", "YOP_OR", "YOP_AND", "YOP_EQ", "YOP_NE", "'<'", "'>'",
  "YOP_LE", "YOP_GE", "YOP_CONCAT", "'+'", "'-'", "'*'", "'/'", "'%'",
  "YOP_NOT", "UMINUS", "YOP_POW", "'.'", "'~'", "'{'", "';'", "'}'", "'['",
  "']'", "':'", "'|'", "','", "'('", "')'", "$accept", "block", "$@1",
  "debug", "$@2", "D_XXX", "script_params", "script_body", "$@3",
  "proc_stmt", "$@4", "bparam_list", "param_list", "xparam_list",
  "var_decls", "var_decl_block", "var_decl_line", "var_decl_stmt", "$@5",
  "typedefs", "var_decl_list", "var_decl_plus", "var_decl", "$@6",
  "var_def", "$@7", "var_name", "init_index_list", "init_index_range",
  "init_list", "init_elem", "const", "number", "sign", "options_list",
  "options", "option", "begin_stmt", "expr", "expr0", "expr1", "$@8",
  "$@9", "$@10", "$@11", "$@12", "intrinsx", "scanfmt", "scanarg",
  "intrarg", "stmt", "c_stmt", "c_blk", "$@13", "$@14", "s_list", "assign",
  "$@15", "equals", "assign_oper", "cmdlist", "$@16", "cmdpipe", "$@17",
  "pipe", "command", "$@18", "$@19", "args", "$@20", "arglist", "arg",
  "file", "immed", "inspect", "osesc", "popstk", "if", "if_stat", "$@21",
  "ifelse", "$@22", "while", "$@23", "$@24", "for", "$@25", "$@26", "$@27",
  "xassign", "xexpr", "switch", "$@28", "case", "$@29", "$@30", "default",
  "$@31", "next", "break", "return", "end_stmt", "label_stmt", "$@32",
  "goto", "nullstmt", "xstmt", "$@33", "const_expr_list", "const_expr",
  "opnl", "ref", "$@34", "index_list", "$@35", "index", "intrins", "param",
  "tasknam", "EOST", "DELIM", "BARG", "EARG", "LP", "RP", "NL", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-261)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-250)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     574,     0,  -261,     0,     0,    40,  -261,  -261,   773,  -261,
    -261,  -261,     6,  -261,  -261,  -261,    47,     0,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,     3,
     785,  -261,  -261,  -261,  -261,  -261,  -261,  -261,   -31,  -261,
      35,  -261,   731,    -6,  -261,  -261,  -261,    33,     0,  -261,
      -6,     6,  -261,     0,  -261,  -261,   821,  -261,     6,    -6,
     -17,    29,    48,    18,  -261,   679,  -261,  -261,    32,   -17,
    -261,  -261,  -261,   -25,   -31,   -31,   -31,  -261,  -261,     0,
    -261,    38,    64,    84,  -261,  -261,     0,  -261,  -261,     0,
      -6,    64,    -6,  -261,    -6,    -6,    -6,    -6,  -261,   103,
    -261,  -261,  -261,  -261,  -261,  -261,    -6,    -6,    -6,  -261,
      -6,  -261,    79,    54,  -261,    47,  -261,  -261,  -261,    33,
      37,  -261,    55,     0,  -261,  -261,  -261,  -261,     6,     0,
    -261,    64,     0,   -31,   128,     0,   -31,   -31,   -31,   -31,
    -261,    56,  -261,  -261,  -261,  -261,  -261,  -261,    64,    64,
     842,  -261,  -261,   -31,  -261,  -261,    64,  -261,  -261,  -261,
    -261,  -261,   842,    21,    23,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,   322,    64,    76,   -31,
    -261,  -261,   -31,   106,  -261,  -261,   -17,  -261,  -261,  -261,
     134,    90,   -17,  -261,    83,    98,  -261,  -261,  -261,    64,
     486,     6,     0,  -261,    87,   -17,  -261,  -261,  -261,  -261,
     158,   116,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -261,   486,
       0,    -2,     0,  -261,  -261,  -261,  -261,  -261,    64,    10,
      17,    25,  -261,  -261,    98,    98,    37,  -261,   113,   170,
     -17,  -261,   -47,  -261,   114,   731,   486,  -261,  -261,   122,
      79,    64,     0,   128,   731,   178,    64,   178,   -17,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,  -261,   626,     0,     0,  -261,
     731,   842,   -22,  -261,    41,    46,   136,   131,   515,    32,
    -261,  -261,   -17,  -261,  -261,    83,  -261,    98,    98,  -261,
    -261,     0,     0,    64,   816,  -261,  -261,  -261,   -17,    32,
     842,   -17,    32,  -261,   858,   873,   565,   565,   169,   169,
     169,   169,   257,   152,   152,   116,   116,   116,  -261,   842,
     -60,   132,  -261,  -261,   191,  -261,  -261,   -17,    64,    64,
      64,    64,    64,    64,   207,    32,   -17,  -261,   115,   127,
    -261,  -261,  -261,  -261,     0,   731,  -261,    32,   731,   178,
    -261,   178,  -261,    64,    64,  -261,  -261,  -261,  -261,    25,
     227,  -261,   130,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
     429,    64,  -261,  -261,   429,   731,  -261,    64,     0,  -261,
    -261,    32,   -17,   842,  -261,  -261,   252,   410,   -17,  -261,
     842,   147,  -261,  -261,   178,     0,   731,    32,  -261,  -261,
    -261,     6,    32,     0,  -261,   821,  -261
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,    18,     0,     0,     4,     6,     7,     0,    16,
     260,     8,     0,    77,     3,     1,     9,     0,    35,    43,
      37,    36,    38,    44,    39,    40,    41,    42,   252,     0,
       0,    28,    31,    33,    30,   251,   149,   249,    20,    12,
       0,    14,     0,     0,    32,    15,    29,     0,   236,   258,
       0,    22,    13,     0,   231,     5,     0,    10,     0,     0,
      45,    47,    49,    52,    55,     0,   237,    19,     0,    23,
      24,   232,   194,   250,     0,     0,     0,   220,   219,   236,
     214,     0,   221,     0,   155,   146,   227,   230,   124,   144,
       0,   195,     0,   161,     0,     0,     0,     0,   131,   196,
     132,   133,   134,   135,   136,   137,     0,     0,     0,   142,
       0,   143,   153,   238,   168,     9,    56,    34,   253,     0,
       0,    50,     0,     0,    17,   150,   259,    21,     0,   236,
     201,     0,   236,     0,     0,   236,     0,     0,     0,     0,
      81,   249,   115,   116,    82,    83,    84,    85,     0,     0,
     222,    78,    80,     0,    79,   114,     0,   226,   149,   228,
     145,   125,     0,    78,    79,   126,   163,   127,   128,   129,
     130,   199,   138,   139,   141,   140,     0,   193,     0,   254,
      11,    46,    66,     0,    69,    70,    72,    62,    64,    67,
       0,     0,    73,    74,     0,    57,   223,    25,   224,     0,
       0,   209,   236,   235,     0,   233,   217,   104,   106,   108,
       0,   103,   102,   236,   236,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,   236,   236,   236,   112,     0,
     236,   162,   236,   156,   157,   158,   159,   160,     0,    78,
      79,     0,   169,   255,     0,     0,     0,    68,     0,     0,
      51,    66,     0,    58,    60,     0,     0,   197,   208,     0,
     153,     0,   236,     0,     0,   118,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   121,    86,     0,   236,   236,   164,
       0,   154,    81,   246,    80,    79,     0,   241,   176,     0,
      76,    63,    71,    48,    75,     0,    54,     0,     0,   225,
     202,   236,   236,     0,   236,   215,   234,   218,   119,     0,
     117,     0,     0,   110,   100,   101,    98,    99,    94,    95,
      96,    97,    93,    87,    88,    89,    90,    92,    91,   122,
       0,     0,   167,   166,     0,   200,   240,     0,     0,     0,
       0,     0,     0,     0,    78,   256,   173,   174,    79,   238,
     171,    65,    59,    61,   236,     0,   204,     0,     0,   118,
     105,   118,   109,     0,     0,   113,   148,   250,   165,     0,
      78,   186,   238,   187,   185,   188,   183,   184,   170,   257,
     176,     0,   181,   182,   176,     0,   198,   211,   236,   216,
     120,     0,     0,   123,   243,   175,    78,    79,   172,   203,
     210,     0,   212,   107,   118,   236,     0,     0,   205,   213,
     111,   209,     0,   236,   206,     0,   207
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -261,  -261,  -261,   105,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,   188,     4,  -261,  -261,
     102,  -261,  -261,  -261,  -261,  -261,  -261,  -261,   -76,    42,
    -233,  -189,  -261,  -261,  -261,    -9,   -11,   212,   120,   -43,
    -236,  -261,  -261,  -261,  -261,  -261,  -261,  -130,  -260,  -261,
    -180,  -261,  -261,  -261,  -261,    88,  -197,  -261,  -109,  -261,
    -261,  -261,  -261,  -261,  -261,   -97,  -261,  -261,  -261,  -261,
    -146,  -138,   101,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -168,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,   -41,  -261,    -7,  -261,
     -53,   -48,  -261,  -125,  -261,  -261,  -261,   -12,  -261,   321,
     -58,  -261,  -261,    -1,  -123,   406
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     5,    16,    42,   115,    43,     6,     7,    36,     8,
      12,    50,    68,    69,    29,    30,    31,    54,    47,    33,
      59,    60,    61,   194,    62,   122,    63,   252,   253,   186,
     187,   188,   189,   190,   191,   192,   193,     9,   162,   151,
     152,   265,   266,   267,   373,   284,   153,   321,   319,   340,
      87,    88,    89,   158,   341,    48,    90,   176,    91,   238,
      92,   166,   231,   344,   289,    93,   179,   298,   355,   394,
     356,   357,   381,    94,    95,    96,    97,    98,    99,   311,
     100,   232,   101,   199,   364,   102,   397,   421,   425,   259,
     411,   103,   416,   104,   134,   368,   105,   264,   106,   107,
     108,   124,   109,   255,   110,   111,   125,    56,   204,   205,
      65,   154,   178,   296,   347,   297,   155,   113,   114,    34,
     249,   242,   388,   156,   127,    66
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      38,    55,   119,   177,   258,   294,   254,   322,   112,    10,
     287,   128,    32,   301,   118,    10,   126,  -249,  -249,  -249,
    -249,  -249,  -249,    37,   306,  -151,   133,   118,   136,   137,
     138,   139,  -152,     3,    32,    64,  -191,    51,  -192,    70,
      15,   292,   141,   164,    49,  -249,   116,   129,   163,  -247,
      37,    52,  -247,   182,   183,   299,   300,   118,   142,   143,
      39,    40,    28,   144,   145,   146,   147,   136,   137,   138,
     139,   288,   301,   130,   131,   132,   198,   257,  -151,   201,
     140,   141,   206,   148,   293,  -152,  -151,   149,   -53,  -191,
     121,  -192,    58,  -152,   184,   185,   120,   142,   143,   182,
      49,   157,   144,   145,   146,   147,   285,    64,   126,   400,
     135,   401,  -244,    41,   251,  -244,   197,  -245,   254,   363,
    -245,    84,   148,   171,  -239,   195,   149,  -178,   246,   240,
    -178,  -248,   202,   310,   239,   207,   208,   209,   210,    49,
     184,   185,  -190,   294,   203,  -190,   241,   263,   245,   261,
     247,   313,   228,   260,   417,   184,   185,   391,   248,   262,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   268,   361,   286,   243,   290,
     227,   244,   303,  -178,   392,   393,   308,   183,  -178,  -178,
     312,  -178,   305,   295,   307,   318,   370,  -239,  -190,   372,
    -239,   376,   150,  -190,  -190,  -242,  -190,   346,   377,   315,
     323,   224,   225,   226,   309,   415,   227,   375,    46,  -177,
     180,   181,  -177,   317,   258,   221,   222,   223,   224,   225,
     226,   362,   389,   227,   342,   343,   250,   302,   304,  -189,
     360,    45,  -189,   402,   398,   426,   230,   378,   408,   345,
     358,   200,   405,   422,   404,   354,   316,     0,   365,   366,
     369,   367,     0,   371,  -179,   240,     0,  -179,   211,   212,
     239,     0,     0,     0,     0,  -177,   229,     0,   413,     0,
    -177,  -177,   374,  -177,     0,     0,   359,     0,     0,   379,
       0,     0,     0,     0,   420,  -189,     0,     0,   390,   423,
    -189,  -189,     0,  -189,     0,   380,   380,   380,   380,   380,
     380,   395,     0,     0,   222,   223,   224,   225,   226,   256,
    -179,   227,     0,     0,   396,  -179,  -179,   399,  -179,     0,
       0,   295,     0,     0,     0,     0,   382,   382,   382,   382,
     382,   382,   358,   407,   414,   412,   358,   354,   406,     0,
     390,   354,     0,     0,   409,     0,     0,     0,   291,     0,
       0,     0,   418,     0,    57,   233,   234,   235,   236,   237,
     424,    67,     0,   260,     0,   419,     0,   112,   359,     0,
     117,   314,   359,     0,     0,     0,   320,     0,     0,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,     0,     0,    11,     0,    13,
      14,   161,     0,   165,    35,   167,   168,   169,   170,     0,
       0,     0,  -180,    44,     0,  -180,     0,   172,   173,   174,
       0,   175,   136,   137,   138,   139,    35,   348,   349,   350,
     351,     0,     0,     0,     0,   140,   141,     0,     0,    35,
     383,   384,   385,   386,   387,     0,    35,     0,     0,    71,
       0,     0,   142,   143,     0,    35,     0,   144,   145,   146,
     147,     0,     0,     0,     0,     0,     0,     0,  -180,     0,
       0,   352,   353,  -180,  -180,     0,  -180,   148,     0,     0,
       0,   149,   159,   320,   403,   160,    35,     0,    35,     0,
      35,    35,    35,    35,    49,     0,     0,     0,     0,     0,
       0,     0,    35,    35,    35,     0,    35,   410,   136,   137,
     138,   139,     0,   348,   349,   350,   351,     0,     0,   196,
       0,   140,   141,     0,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   142,   143,
     227,     0,     0,   144,   145,   146,   147,     0,     0,     0,
       0,     0,   126,     0,     0,     0,     0,   352,   353,     0,
       0,     0,     0,   148,    -2,     1,     0,   149,     0,     0,
       0,    -2,     0,     0,     0,     0,     0,    -2,    -2,   118,
      49,    -2,    -2,    -2,     0,    -2,    -2,    -2,    -2,    -2,
      -2,    -2,    -2,     2,     3,     0,    -2,    -2,    -2,    -2,
      -2,    -2,    -2,    -2,    -2,    -2,    -2,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    53,     0,   227,
       0,     0,     0,  -229,     0,     0,     0,     0,     0,     4,
      -2,    -2,    -2,  -229,  -229,  -229,     0,  -229,  -229,  -229,
    -229,  -229,  -229,  -229,  -229,     0,     0,     0,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,  -229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      53,     0,     0,     0,     0,     0,  -229,     0,     0,     0,
       0,     0,     0,  -229,  -229,  -147,  -229,  -229,  -229,     0,
    -229,  -229,  -229,  -229,  -229,  -229,  -229,  -229,     0,     0,
     123,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,  -229,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,     0,     0,     0,  -229,     0,
       0,     0,     0,     0,     0,     0,  -229,  -229,  -229,  -229,
    -229,     0,  -229,  -229,  -229,  -229,  -229,  -229,  -229,  -229,
       0,     0,     0,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,  -229,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    17,     0,    10,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -229,  -229,
      10,     0,     0,   -26,     0,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,   -27,     0,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,    72,     0,
       0,    10,     0,     0,     0,     0,     0,     0,    73,    74,
      75,    28,    76,    77,    78,    79,    80,    81,    82,    83,
       0,     0,     0,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    84,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,     0,     0,
     227,     0,     0,     0,     0,     0,     0,     0,    85,    86,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,     0,     0,   227,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
       0,     0,   227,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,     0,     0,   227
};

static const yytype_int16 yycheck[] =
{
      12,    42,    60,   112,   201,   241,   195,   267,    56,    15,
      12,    69,     8,   246,    74,    15,    76,    42,    43,    44,
      45,    46,    47,    17,    71,    15,    79,    74,     3,     4,
       5,     6,    15,    30,    30,    47,    15,    38,    15,    51,
       0,    16,    17,    91,    75,    70,    58,    72,    91,    71,
      17,    16,    74,    16,    17,   244,   245,    74,    33,    34,
      13,    14,    68,    38,    39,    40,    41,     3,     4,     5,
       6,    73,   305,    74,    75,    76,   129,   200,    68,   132,
      16,    17,   135,    58,    59,    68,    76,    62,    70,    68,
      42,    68,    59,    76,    57,    58,    67,    33,    34,    16,
      75,    17,    38,    39,    40,    41,   229,   119,    76,   369,
      72,   371,    71,    66,    16,    74,   128,    71,   307,   308,
      74,    42,    58,    20,    70,    70,    62,    12,   186,   177,
      15,    75,   133,   256,   177,   136,   137,   138,   139,    75,
      57,    58,    12,   379,    16,    15,    70,   205,    42,   202,
      16,   260,   153,   201,   414,    57,    58,    42,    68,    72,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,    17,   299,   230,   179,   232,
      64,   182,    69,    68,    57,    58,    72,    17,    73,    74,
      68,    76,   250,   241,   252,    17,   319,    70,    68,   322,
      70,    69,    82,    73,    74,    74,    76,    71,    17,   262,
     268,    59,    60,    61,   255,    68,    64,   340,    30,    12,
     115,   119,    15,   264,   421,    56,    57,    58,    59,    60,
      61,   307,   355,    64,   287,   288,   194,   246,   249,    12,
     298,    29,    15,   373,   367,   425,   158,   344,   394,   290,
     298,   131,   390,   421,   379,   298,   263,    -1,   311,   312,
     318,   314,    -1,   321,    12,   313,    -1,    15,   148,   149,
     313,    -1,    -1,    -1,    -1,    68,   156,    -1,   401,    -1,
      73,    74,   340,    76,    -1,    -1,   298,    -1,    -1,   347,
      -1,    -1,    -1,    -1,   417,    68,    -1,    -1,   356,   422,
      73,    74,    -1,    76,    -1,   348,   349,   350,   351,   352,
     353,   364,    -1,    -1,    57,    58,    59,    60,    61,   199,
      68,    64,    -1,    -1,   365,    73,    74,   368,    76,    -1,
      -1,   379,    -1,    -1,    -1,    -1,   348,   349,   350,   351,
     352,   353,   390,   391,   402,   398,   394,   390,   391,    -1,
     408,   394,    -1,    -1,   395,    -1,    -1,    -1,   238,    -1,
      -1,    -1,   415,    -1,    43,    43,    44,    45,    46,    47,
     423,    50,    -1,   421,    -1,   416,    -1,   425,   390,    -1,
      59,   261,   394,    -1,    -1,    -1,   266,    -1,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,    -1,     1,    -1,     3,
       4,    90,    -1,    92,     8,    94,    95,    96,    97,    -1,
      -1,    -1,    12,    17,    -1,    15,    -1,   106,   107,   108,
      -1,   110,     3,     4,     5,     6,    30,     8,     9,    10,
      11,    -1,    -1,    -1,    -1,    16,    17,    -1,    -1,    43,
     349,   350,   351,   352,   353,    -1,    50,    -1,    -1,    53,
      -1,    -1,    33,    34,    -1,    59,    -1,    38,    39,    40,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    52,    53,    73,    74,    -1,    76,    58,    -1,    -1,
      -1,    62,    86,   373,   374,    89,    90,    -1,    92,    -1,
      94,    95,    96,    97,    75,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   106,   107,   108,    -1,   110,   397,     3,     4,
       5,     6,    -1,     8,     9,    10,    11,    -1,    -1,   123,
      -1,    16,    17,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    33,    34,
      64,    -1,    -1,    38,    39,    40,    41,    -1,    -1,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    52,    53,    -1,
      -1,    -1,    -1,    58,     0,     1,    -1,    62,    -1,    -1,
      -1,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,    74,
      75,    17,    18,    19,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,     1,    -1,    64,
      -1,    -1,    -1,     7,    -1,    -1,    -1,    -1,    -1,    65,
      66,    67,    68,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,     7,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,    69,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,     7,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
      15,    -1,    -1,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,     7,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    68,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    -1,    -1,    64,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      -1,    -1,    64,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    64
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    29,    30,    65,    78,    83,    84,    86,   114,
      15,   202,    87,   202,   202,     0,    79,     1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    68,    91,
      92,    93,    94,    96,   196,   202,    85,    17,   194,    13,
      14,    66,    80,    82,   202,   114,    93,    95,   132,    75,
      88,   200,    16,     1,    94,   183,   184,   196,    59,    97,
      98,    99,   101,   103,   194,   187,   202,   196,    89,    90,
     194,   202,     7,    17,    18,    19,    21,    22,    23,    24,
      25,    26,    27,    28,    42,    67,    68,   127,   128,   129,
     133,   135,   137,   142,   150,   151,   152,   153,   154,   155,
     157,   159,   162,   168,   170,   173,   175,   176,   177,   179,
     181,   182,   188,   194,   195,    81,   194,   196,    74,   197,
      67,    42,   102,    31,   178,   183,    76,   201,   197,    72,
     200,   200,   200,   187,   171,    72,     3,     4,     5,     6,
      16,    17,    33,    34,    38,    39,    40,    41,    58,    62,
     115,   116,   117,   123,   188,   193,   200,    17,   130,   202,
     202,   196,   115,   116,   188,   196,   138,   196,   196,   196,
     196,    20,   196,   196,   196,   196,   134,   135,   189,   143,
      80,    97,    16,    17,    57,    58,   106,   107,   108,   109,
     110,   111,   112,   113,   100,    70,   202,   194,   187,   160,
     115,   187,   200,    16,   185,   186,   187,   200,   200,   200,
     200,   115,   115,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    64,   200,   115,
     132,   139,   158,    43,    44,    45,    46,    47,   136,   116,
     188,    70,   198,   200,   200,    42,   197,    16,    68,   197,
     106,    16,   104,   105,   108,   180,   115,   201,   133,   166,
     188,   187,    72,   197,   174,   118,   119,   120,    17,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   187,   122,   201,   187,    12,    73,   141,
     187,   115,    16,    59,   117,   188,   190,   192,   144,   108,
     108,   107,   112,    69,   113,   197,    71,   197,    72,   183,
     201,   156,    68,   135,   115,   187,   185,   183,    17,   125,
     115,   124,   125,   197,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     126,   131,   187,   187,   140,   183,    71,   191,     8,     9,
      10,    11,    52,    53,   116,   145,   147,   148,   188,   194,
     197,   201,   105,   108,   161,   187,   187,   187,   172,   197,
     201,   197,   201,   121,   197,   201,    69,    17,   142,   197,
     116,   149,   194,   149,   149,   149,   149,   149,   199,   201,
     197,    42,    57,    58,   146,   187,   183,   163,   201,   183,
     125,   125,   124,   115,   190,   148,   116,   188,   147,   183,
     115,   167,   187,   201,   197,    68,   169,   125,   187,   183,
     201,   164,   166,   201,   187,   165,   127
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    77,    78,    78,    79,    78,    78,    78,    78,    80,
      81,    80,    82,    82,    82,    83,    85,    84,    87,    86,
      88,    88,    89,    89,    90,    90,    91,    91,    92,    92,
      93,    93,    93,    95,    94,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    97,    97,    98,    98,    99,
     100,    99,   101,   102,   101,   103,   103,   104,   104,   104,
     105,   105,   106,   106,   107,   107,   108,   108,   109,   110,
     110,   111,   111,   111,   112,   112,   113,   114,   115,   115,
     116,   116,   116,   116,   116,   116,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   118,   117,   119,   117,   120,   117,
     121,   117,   122,   117,   123,   123,   123,   124,   125,   125,
     125,   126,   126,   126,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   128,   128,   130,   131,   129,   132,
     132,   133,   133,   134,   133,   135,   136,   136,   136,   136,
     136,   138,   137,   139,   140,   139,   141,   141,   143,   144,
     142,   146,   145,   145,   147,   147,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   149,
     149,   150,   150,   151,   152,   153,   154,   156,   155,   158,
     157,   160,   161,   159,   163,   164,   165,   162,   166,   166,
     167,   167,   169,   168,   171,   172,   170,   174,   173,   175,
     176,   177,   177,   178,   180,   179,   181,   182,   182,   184,
     183,   183,   183,   185,   185,   186,   187,   187,   188,   189,
     188,   190,   191,   190,   192,   192,   192,   192,   193,   194,
     195,   196,   196,   197,   198,   198,   199,   199,   200,   201,
     202
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     0,     4,     1,     1,     2,     0,
       0,     4,     1,     2,     1,     3,     0,     5,     0,     5,
       0,     3,     0,     1,     1,     3,     0,     1,     1,     2,
       1,     1,     2,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     5,     1,
       0,     4,     1,     0,     5,     1,     2,     0,     1,     3,
       1,     3,     1,     3,     1,     4,     1,     1,     2,     1,
       1,     3,     1,     1,     1,     3,     3,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     2,     2,     0,     5,     0,     7,     0,     5,
       0,     9,     0,     5,     1,     1,     1,     1,     0,     1,
       3,     0,     1,     3,     1,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     1,     1,     1,     2,     0,     0,     6,     0,
       3,     3,     3,     0,     4,     1,     1,     1,     1,     1,
       1,     0,     3,     0,     0,     4,     2,     2,     0,     0,
       6,     0,     3,     1,     1,     3,     0,     1,     1,     3,
       3,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     2,     2,     2,     1,     1,     1,     0,     7,     0,
       5,     0,     0,     8,     0,     0,     0,    16,     1,     0,
       1,     0,     0,    10,     0,     0,     7,     0,     5,     1,
       1,     1,     2,     2,     0,     5,     2,     1,     2,     0,
       2,     1,     2,     1,     3,     1,     0,     1,     1,     0,
       5,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     0,     1,     1,     1,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* block: %empty  */
#line 136 "grammar.y"
                            {
		    /* Done once on entry but after at least one call to
		     * yylex().  Good for initing parser flags.
		     * Note: this does not get called in procedure scripts.
		     */
		    if (cldebug)
			eprintf ("parse init (block)...\n");

		    errcnt     = 0;
		    err_cmdblk = 0;
		    dobkg      = 0;
		    inarglist  = 0;
		    parenlevel = 0;
		    bracelevel = 0;
		    tbrace     = 0;
		    dobrace    = 0;
		    do_params  = YES;
		    last_parm  = NULL;
		    ifseen     = NULL;
		    label1     = NULL;
		    parse_pfile= currentask->t_pfp;
		}
#line 1975 "y.tab.c"
    break;

  case 3: /* block: '.' NL  */
#line 159 "grammar.y"
                       {
		    /* Prepare to rerun whatever was compiled last.
		     * Does not work for the debug commands builtin here.
		     */
		    if (parse_state != PARSE_FREE) {
			eprintf ("Illegal parser state.\n");
			EYYERROR;
		    }
		    rerun();
		    YYACCEPT;
		}
#line 1991 "y.tab.c"
    break;

  case 4: /* $@1: %empty  */
#line 171 "grammar.y"
                      {
		    if (parse_state == PARSE_PARAMS) {
			eprintf ("Illegal parser state.\n");
			EYYERROR;
		    }
		}
#line 2002 "y.tab.c"
    break;

  case 5: /* block: block $@1 debug xstmt  */
#line 177 "grammar.y"
                            {
		    if (sawnl && bracelevel == 0) {
			if (!errcnt)
			    compile (END);
			if (ifseen) {
			    /* Simulate an unput of what has been read
			     * from the current line.
			     */
			    ip_cmdblk = ifseen;
			}
			YYACCEPT;
		    }
		}
#line 2020 "y.tab.c"
    break;

  case 6: /* block: script_params  */
#line 191 "grammar.y"
                              {
		    /* Parse the parameters in a script file.  This will
		     * normally be done on a call by pfileread().
		     */
		    if (parse_state != PARSE_PARAMS) {
			eprintf ("Illegal parser state.\n");
			errcnt++;
		    }
		    YYACCEPT;
		}
#line 2035 "y.tab.c"
    break;

  case 7: /* block: script_body  */
#line 202 "grammar.y"
                            {
		    /* Parse the executable statements in a script.
		     */
		    if (parse_state != PARSE_BODY) {
			eprintf ("Illegal parser state.\n");
			errcnt++;
		    }
		    if (!errcnt)
			compile (END);
		    YYACCEPT;
		}
#line 2051 "y.tab.c"
    break;

  case 8: /* block: error NL  */
#line 214 "grammar.y"
                         {
		    /* This catches errors that the two other error lines
		     * can't get, e.g. a missing `}' at the end of a script, 
		     * or errors occuring in interactive input.
		     */
		    yyerrok;

		    /* Discard everything and compile a null statement.
		     */
		    if (!errcnt) {
			do_params = YES;
			pc = currentask->t_bascode;
			if (parse_state != PARSE_PARAMS)
			    compile (END);

			topd = currentask->t_topd;
			topcs = currentask->t_topcs;

			/* Unlink any added parms.  Resetting of topd will
			 * already have reclaimed space.
			 */
			if (last_parm) {
			    last_parm->p_np = NULL;
			    currentask->t_pfp->pf_lastpp = last_parm;
			    last_parm = NULL;
			}
	 	    }

		    /* Print cmdblk and show position of error.
		     */
		    p_position();
		    if (currentask->t_flags & T_SCRIPT) 
			cl_error (E_UERR, "syntax error, line %d",
			    currentask->t_scriptln);
		    else
			cl_error (E_UERR, "syntax error");

		    YYACCEPT;
		}
#line 2095 "y.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 256 "grammar.y"
                           {
		    /* debug are those debugging functions that
		     * should be run directly and not through a
		     * builtin task due to stack or other changes,
		     * ie, don't change what we are trying to show.
		     */
		    printf ("\n");
		}
#line 2108 "y.tab.c"
    break;

  case 12: /* D_XXX: D_D  */
#line 266 "grammar.y"
                    {
		    d_d(); /* show dictionary/stack pointers */
		}
#line 2116 "y.tab.c"
    break;

  case 13: /* D_XXX: D_PEEK Y_CONSTANT  */
#line 269 "grammar.y"
                                  { /* show a dictionary location	*/
		    if (stkop(yyvsp[0])->o_type & OT_INT) {
			int	idx;
			idx = stkop(yyvsp[0])->o_val.v_i;
			eprintf ("%d:\t%d (0%o)\n", idx, stack[idx],
				stack[idx]);
		    } else
			eprintf ("usage: D_PEEK <d. index>\n");
		}
#line 2130 "y.tab.c"
    break;

  case 14: /* D_XXX: '~'  */
#line 278 "grammar.y"
                    {
		    d_stack (pc, 0);		/* show compiled code	*/
		}
#line 2138 "y.tab.c"
    break;

  case 15: /* script_params: proc_stmt var_decls begin_stmt  */
#line 285 "grammar.y"
                           { 
			/* Check for required params.
			 */
			if (!errcnt)
			    proc_params(n_procpar);
		}
#line 2149 "y.tab.c"
    break;

  case 16: /* $@3: %empty  */
#line 293 "grammar.y"
                           {
			/* Initialize parser for procedure body.
			 */
			if (cldebug)
			    eprintf ("parse init (script_body)...\n");

			errcnt     = 0;
			err_cmdblk = 0;
			dobkg      = 0;
			inarglist  = 0;
			parenlevel = 0;
			dobrace    = 0;
			bracelevel = PBRACE; /* disable lexmodes; force "end" */
			tbrace     = 0;
 			do_params  = NO;
			last_parm  = NULL;
			ifseen     = NULL;
			label1     = NULL;
			parse_pfile= currentask->t_pfp;
		}
#line 2174 "y.tab.c"
    break;

  case 18: /* $@4: %empty  */
#line 318 "grammar.y"
                            {  
			/* Initialize parser for procedure parameters.
			 */
			if (cldebug)
			    eprintf ("parse init (proc_stmt)...\n");

			errcnt     = 0;
			err_cmdblk = 0;
			dobkg      = 0;
			inarglist  = 0;
			parenlevel = 0;
			bracelevel = PBRACE;
			tbrace     = 0;
		        dobrace    = 0;
			do_params  = YES;
		        last_parm  = NULL;
			label1     = NULL;
		}
#line 2197 "y.tab.c"
    break;

  case 20: /* bparam_list: %empty  */
#line 340 "grammar.y"
                {
		    n_procpar = 0;
		}
#line 2205 "y.tab.c"
    break;

  case 22: /* param_list: %empty  */
#line 349 "grammar.y"
                            {
		    n_procpar = 0;
		}
#line 2213 "y.tab.c"
    break;

  case 24: /* xparam_list: param  */
#line 355 "grammar.y"
                      { 
		    n_procpar = 1;
		    if (!errcnt)
			push (stkop(yyvsp[0]));
		}
#line 2223 "y.tab.c"
    break;

  case 25: /* xparam_list: xparam_list DELIM param  */
#line 360 "grammar.y"
                                        {
		    n_procpar++;
		    if (!errcnt)
			push (stkop(yyvsp[0]));
		}
#line 2233 "y.tab.c"
    break;

  case 32: /* var_decl_line: error NL  */
#line 377 "grammar.y"
                         {
		    /* This catches errors in the parameter declarations
		     * of a procedure script.
		     */
		    yyerrok;

		    /* Discard everything and compile a null statement.
		     */
		    if (!errcnt) {
			do_params = YES;
			pc = currentask->t_bascode;
			if (parse_state != PARSE_PARAMS)
			    compile (END);

			topd = currentask->t_topd;
			topcs = currentask->t_topcs;

			/* Unlink any added parms.  Resetting of topd will
			 * already have reclaimed space.
			 */
			if (last_parm) {
			    last_parm->p_np = NULL;
			    currentask->t_pfp->pf_lastpp = last_parm;
			    last_parm = NULL;
			}
	 	    }

		    /* Print cmdblk and show position of error.  We know
		     * we're parsing a procedure script, so print the line
		     * number too.
		     */
		    p_position();
		    cl_error (E_UERR, "syntax error, line %d", 
			currentask->t_scriptln);
		}
#line 2273 "y.tab.c"
    break;

  case 33: /* $@5: %empty  */
#line 414 "grammar.y"
                         {
	 	        /* For in-line definitions we don't want
			 * to freeze stuff on the dictionary, so
			 * only allow additions if the dictionary
			 * is the same as at the beginning of the task.
			 */
			if (!errcnt) {
			    if (parse_state != PARSE_PARAMS) {
				if (currentask->t_topd != topd)
				    cl_error (E_UERR, illegalvar);
				last_parm = currentask->t_pfp->pf_lastpp;
			    }
			}

		        /* Increment bracelevel temporarily to defeat command
			 * mode, in case this is an in-line declaration and
			 * lexmodes=yes.
			 */
			bracelevel += PBRACE;
			tbrace++;

		}
#line 2300 "y.tab.c"
    break;

  case 34: /* var_decl_stmt: typedefs $@5 var_decl_list EOST  */
#line 435 "grammar.y"
                                     {
		      	/* Update dictionary to include these definitions.
			 */
			if (!errcnt) {
			    if (parse_state != PARSE_PARAMS) {
				currentask->t_topd = topd;
				last_parm = 0;
			    }
			}

			/* Restore command mode */
			bracelevel -= PBRACE;
			tbrace--;
		}
#line 2319 "y.tab.c"
    break;

  case 35: /* typedefs: Y_BOOL  */
#line 451 "grammar.y"
                                { vartype = V_BOOL; }
#line 2325 "y.tab.c"
    break;

  case 36: /* typedefs: Y_STRING  */
#line 452 "grammar.y"
                                { vartype = V_STRING; }
#line 2331 "y.tab.c"
    break;

  case 37: /* typedefs: Y_REAL  */
#line 453 "grammar.y"
                                { vartype = V_REAL; }
#line 2337 "y.tab.c"
    break;

  case 38: /* typedefs: Y_FILE  */
#line 454 "grammar.y"
                                { vartype = V_FILE; }
#line 2343 "y.tab.c"
    break;

  case 39: /* typedefs: Y_GCUR  */
#line 455 "grammar.y"
                                { vartype = V_GCUR; }
#line 2349 "y.tab.c"
    break;

  case 40: /* typedefs: Y_IMCUR  */
#line 456 "grammar.y"
                                { vartype = V_IMCUR; }
#line 2355 "y.tab.c"
    break;

  case 41: /* typedefs: Y_UKEY  */
#line 457 "grammar.y"
                                { vartype = V_UKEY; }
#line 2361 "y.tab.c"
    break;

  case 42: /* typedefs: Y_PSET  */
#line 458 "grammar.y"
                                { vartype = V_PSET; }
#line 2367 "y.tab.c"
    break;

  case 43: /* typedefs: Y_INT  */
#line 459 "grammar.y"
                                { vartype = V_INT; }
#line 2373 "y.tab.c"
    break;

  case 44: /* typedefs: Y_STRUCT  */
#line 460 "grammar.y"
                                { vartype = V_STRUCT; }
#line 2379 "y.tab.c"
    break;

  case 47: /* var_decl_plus: var_decl  */
#line 467 "grammar.y"
                         {
			if (!errcnt) {
			    if (pp != NULL) {
				if (n_aval > 1)
				    pp->p_type |= PT_ARRAY;

				if (pp->p_type & PT_ARRAY)
				    do_arrayinit (pp, n_aval, index_cnt);
		      		else
		 		    do_scalarinit (pp, inited);
			    }
			}
		}
#line 2397 "y.tab.c"
    break;

  case 48: /* var_decl_plus: var_decl '{' options_list ';' '}'  */
#line 485 "grammar.y"
                                                   {
			if (!errcnt) {
			    if (pp != NULL) {
				if (!do_params)
				    cl_error (E_UERR, badparm, pp->p_name);

				if (n_aval > 1)
				    pp->p_type |= PT_ARRAY;

				if (pp->p_type & PT_ARRAY)
				    do_arrayinit (pp, n_aval, index_cnt);
		      		else
		 		    do_scalarinit (pp, n_aval);
			    }
			}
		}
#line 2418 "y.tab.c"
    break;

  case 49: /* var_decl: var_def  */
#line 503 "grammar.y"
                        {
			inited = NO;
			n_aval = 0;
		}
#line 2427 "y.tab.c"
    break;

  case 50: /* $@6: %empty  */
#line 507 "grammar.y"
                            {
			n_aval = 0;
		}
#line 2435 "y.tab.c"
    break;

  case 51: /* var_decl: var_def '=' $@6 init_list  */
#line 510 "grammar.y"
                          {
			inited = YES;
		}
#line 2443 "y.tab.c"
    break;

  case 52: /* var_def: var_name  */
#line 515 "grammar.y"
                         {
		    index_cnt = 0;
		    if (!errcnt)
			pp = initparam (stkop(yyvsp[0]), do_params, vartype, varlist);
		}
#line 2453 "y.tab.c"
    break;

  case 53: /* $@7: %empty  */
#line 520 "grammar.y"
                         {
		    int  itemp;

		    if (!errcnt) {
			pp = initparam (stkop(yyvsp[0]), do_params, vartype, varlist);

			if (pp != NULL) {
			    itemp = (pp->p_type & OT_BASIC) == pp->p_type;
			    itemp = itemp && !varlist;
			    if (itemp)
				pp->p_type |= PT_ARRAY;
			    else
				cl_error (E_UERR, inval_arr, pp->p_name);
			}
		    }
		}
#line 2474 "y.tab.c"
    break;

  case 55: /* var_name: param  */
#line 539 "grammar.y"
                      {
			varlist = NO;
			index_cnt = 0;
		}
#line 2483 "y.tab.c"
    break;

  case 56: /* var_name: '*' param  */
#line 543 "grammar.y"
                          {
			if (!do_params) {
			    eprintf (locallist);
			    EYYERROR;
			}
			varlist = YES;
			index_cnt = 0;
			yyval = yyvsp[0];
		}
#line 2497 "y.tab.c"
    break;

  case 60: /* init_index_range: const  */
#line 563 "grammar.y"
                      {
		    if (!errcnt) {
			if (pp != NULL) {
			    if (stkop(yyvsp[0])->o_type == OT_INT) {
				push (stkop(yyvsp[0])->o_val.v_i);
				push (1);
			    } else if (maybeindex) {
				/* Confusion between sexagesimal and index
				 * range.  Maybeindex is set only when operand
				 * is real.
			 	 */
				int  i1,i2;
				sexa_to_index (stkop(yyvsp[0])->o_val.v_r, &i1, &i2);
				push (i2-i1+1);
				push (i1);
			    } else {
				eprintf (inv_index, pp->p_name);
				EYYERROR;
			    }
			    index_cnt++;
			}
		    }
		}
#line 2525 "y.tab.c"
    break;

  case 61: /* init_index_range: const ':' const  */
#line 586 "grammar.y"
                                {
			if (!errcnt) {
			    if (pp != NULL) {
				if (stkop(yyvsp[-2])->o_type != OT_INT  ||
				    stkop(yyvsp[0])->o_type != OT_INT)
				    cl_error (E_UERR, inv_index, pp->p_name);
				else {
				    push (stkop(yyvsp[0])->o_val.v_i -
				          stkop(yyvsp[-2])->o_val.v_i + 1);
				    push (stkop(yyvsp[-2])->o_val.v_i);
			        }
			        index_cnt++;
			    }
			}
		}
#line 2545 "y.tab.c"
    break;

  case 64: /* init_elem: const  */
#line 607 "grammar.y"
                      {
			if (!errcnt) {
			    if (pp != NULL) {
				push (stkop(yyvsp[0]) );
				n_aval++;
			    }
			}
		}
#line 2558 "y.tab.c"
    break;

  case 65: /* init_elem: Y_CONSTANT LP const RP  */
#line 616 "grammar.y"
                {
			int   cnt;
			
			if (!errcnt)
			    if (pp != NULL) {
			    	if (stkop(yyvsp[-3])->o_type != OT_INT)
				    cl_error (E_UERR, arrdeferr, pp->p_name);

			        cnt = stkop(yyvsp[-3])->o_val.v_i;
			        if (cnt <= 0)
				    cl_error (E_UERR, arrdeferr, pp->p_name);

			        while (cnt-- > 0) {
				    push (stkop(yyvsp[-1]));
				    n_aval++;
			        }
			    }
		}
#line 2581 "y.tab.c"
    break;

  case 68: /* number: sign Y_CONSTANT  */
#line 643 "grammar.y"
                                {
		      	if (stkop(yyvsp[0])->o_type == OT_INT) {
			    stkop(yyvsp[0])->o_val.v_i *= yyvsp[-1];
			    yyval = yyvsp[0];
			} else if (stkop(yyvsp[0])->o_type == OT_REAL) {
			    stkop(yyvsp[0])->o_val.v_r *= yyvsp[-1];
			    yyval = yyvsp[0];
			} else {
			    eprintf ("Invalid constant in declaration.\n");
			    EYYERROR;
			}
		}
#line 2598 "y.tab.c"
    break;

  case 69: /* sign: '+'  */
#line 657 "grammar.y"
                        { yyval =  1; }
#line 2604 "y.tab.c"
    break;

  case 70: /* sign: '-'  */
#line 658 "grammar.y"
                        { yyval = -1; }
#line 2610 "y.tab.c"
    break;

  case 71: /* options_list: init_list DELIM options  */
#line 660 "grammar.y"
                                        {
			/* Check if we already had an initialization. 
			 */
		      	if (!errcnt) {
			    if (inited && pp != NULL) {
				eprintf (twoinits, pp->p_name);
				EYYERROR;
			    }
			}
		}
#line 2625 "y.tab.c"
    break;

  case 72: /* options_list: init_list  */
#line 670 "grammar.y"
                          {
		      	if (!errcnt) {
			    if (inited && pp != NULL) {
			        eprintf (twoinits, pp->p_name);
				EYYERROR;
			    }
			}
		}
#line 2638 "y.tab.c"
    break;

  case 76: /* option: Y_IDENT '=' const  */
#line 685 "grammar.y"
                                  {
			if (!errcnt)
			    if (pp != NULL)
			    	do_option (pp, stkop(yyvsp[-2]), stkop(yyvsp[0]));
		}
#line 2648 "y.tab.c"
    break;

  case 79: /* expr: ref  */
#line 701 "grammar.y"
                    {
		    if (!errcnt)
		        compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
		}
#line 2657 "y.tab.c"
    break;

  case 81: /* expr0: Y_CONSTANT  */
#line 715 "grammar.y"
                           {
		    if  (!errcnt)
		        compile (PUSHCONST, stkop(yyvsp[0]));
		}
#line 2666 "y.tab.c"
    break;

  case 82: /* expr0: Y_GCUR  */
#line 719 "grammar.y"
                       {
		    /* "gcur" is both a keyword and a CL global parameter,
		     * and must be built into the grammar here to permit
		     * reference of the parameter in expressions.
		     */
		    if (!errcnt)
			compile (PUSHPARAM, "gcur");
		}
#line 2679 "y.tab.c"
    break;

  case 83: /* expr0: Y_IMCUR  */
#line 727 "grammar.y"
                        {
		    if (!errcnt)
			compile (PUSHPARAM, "imcur");
		}
#line 2688 "y.tab.c"
    break;

  case 84: /* expr0: Y_UKEY  */
#line 731 "grammar.y"
                       {
		    if (!errcnt)
			compile (PUSHPARAM, "ukey");
		}
#line 2697 "y.tab.c"
    break;

  case 85: /* expr0: Y_PSET  */
#line 735 "grammar.y"
                       {
		    if (!errcnt)
			compile (PUSHPARAM, "pset");
		}
#line 2706 "y.tab.c"
    break;

  case 87: /* expr1: expr '+' opnl expr  */
#line 743 "grammar.y"
                                   {
		    if (!errcnt)
			compile (ADD);
		}
#line 2715 "y.tab.c"
    break;

  case 88: /* expr1: expr '-' opnl expr  */
#line 747 "grammar.y"
                                   {
		    if (!errcnt)
			compile (SUB);
		}
#line 2724 "y.tab.c"
    break;

  case 89: /* expr1: expr '*' opnl expr  */
#line 751 "grammar.y"
                                   {
		    if (!errcnt)
			compile (MUL);
		}
#line 2733 "y.tab.c"
    break;

  case 90: /* expr1: expr '/' opnl expr  */
#line 755 "grammar.y"
                                   {
		    if (!errcnt)
			compile (DIV);
		}
#line 2742 "y.tab.c"
    break;

  case 91: /* expr1: expr YOP_POW opnl expr  */
#line 759 "grammar.y"
                                       {
		    if (!errcnt)
			compile (POW);
		}
#line 2751 "y.tab.c"
    break;

  case 92: /* expr1: expr '%' opnl expr  */
#line 763 "grammar.y"
                                   {
		    struct	operand o;
		    if (!errcnt) {
			o.o_type = OT_INT;
			o.o_val.v_i = 2;
			compile (PUSHCONST, &o);
			compile (INTRINSIC, "mod");
		    }
		}
#line 2765 "y.tab.c"
    break;

  case 93: /* expr1: expr YOP_CONCAT opnl expr  */
#line 772 "grammar.y"
                                          {
		    if (!errcnt)
			compile (CONCAT);
		}
#line 2774 "y.tab.c"
    break;

  case 94: /* expr1: expr '<' opnl expr  */
#line 776 "grammar.y"
                                   {
		    if (!errcnt)
			compile (LT);
		}
#line 2783 "y.tab.c"
    break;

  case 95: /* expr1: expr '>' opnl expr  */
#line 780 "grammar.y"
                                   {
		    if (!errcnt)
			compile (GT);
		}
#line 2792 "y.tab.c"
    break;

  case 96: /* expr1: expr YOP_LE opnl expr  */
#line 784 "grammar.y"
                                      {
		    if (!errcnt)
			compile (LE);
		}
#line 2801 "y.tab.c"
    break;

  case 97: /* expr1: expr YOP_GE opnl expr  */
#line 788 "grammar.y"
                                      {
		    if (!errcnt)
			compile (GE);
		}
#line 2810 "y.tab.c"
    break;

  case 98: /* expr1: expr YOP_EQ opnl expr  */
#line 792 "grammar.y"
                                      {
		    if (!errcnt)
			compile (EQ);
		}
#line 2819 "y.tab.c"
    break;

  case 99: /* expr1: expr YOP_NE opnl expr  */
#line 796 "grammar.y"
                                      {
		    if (!errcnt)
			compile (NE);
		}
#line 2828 "y.tab.c"
    break;

  case 100: /* expr1: expr YOP_OR opnl expr  */
#line 800 "grammar.y"
                                      {
		    if (!errcnt)
			compile (OR);
		}
#line 2837 "y.tab.c"
    break;

  case 101: /* expr1: expr YOP_AND opnl expr  */
#line 804 "grammar.y"
                                       {
		    if (!errcnt)
			compile (AND);
		}
#line 2846 "y.tab.c"
    break;

  case 102: /* expr1: YOP_NOT expr  */
#line 808 "grammar.y"
                             {
		    if (!errcnt)
			compile (NOT);
		}
#line 2855 "y.tab.c"
    break;

  case 103: /* expr1: '-' expr  */
#line 812 "grammar.y"
                                      {
		    if (!errcnt)
			compile (CHSIGN);
		}
#line 2864 "y.tab.c"
    break;

  case 104: /* $@8: %empty  */
#line 817 "grammar.y"
                          {
		    /* Free format scan. */
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 2874 "y.tab.c"
    break;

  case 105: /* expr1: Y_SCAN LP $@8 scanarg RP  */
#line 821 "grammar.y"
                             {
		    if (!errcnt) {
			struct	operand o;
			o.o_type = OT_INT;
		        o.o_val.v_i = pop();	/* get total number of args*/
			compile (PUSHCONST, &o);
			compile (SCAN);
		    }
		}
#line 2888 "y.tab.c"
    break;

  case 106: /* $@9: %empty  */
#line 830 "grammar.y"
                           {
		    /* Formatted scan. */
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 2898 "y.tab.c"
    break;

  case 107: /* expr1: Y_SCANF LP $@9 scanfmt DELIM scanarg RP  */
#line 834 "grammar.y"
                                           {
		    if (!errcnt) {
			struct	operand o;

			/* Compile number of arguments. */
			o.o_type = OT_INT;
		        o.o_val.v_i = pop();
			compile (PUSHCONST, &o);

			compile (SCANF);
		    }
		}
#line 2915 "y.tab.c"
    break;

  case 108: /* $@10: %empty  */
#line 847 "grammar.y"
                           {
		    /* Free format scan from a parameter.  */
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 2925 "y.tab.c"
    break;

  case 109: /* expr1: Y_FSCAN LP $@10 scanarg RP  */
#line 851 "grammar.y"
                             {
		    if (!errcnt) {
			struct	operand o;
			o.o_type = OT_INT;
			o.o_val.v_i = pop();	/* get total number of args*/
			compile (PUSHCONST, &o);
			compile (FSCAN);
		    }
		}
#line 2939 "y.tab.c"
    break;

  case 110: /* $@11: %empty  */
#line 861 "grammar.y"
                                          {
		    /* Formatted scan from a parameter.
		     * fscanf (param, format, arg1, ...)
		     */
		    if (!errcnt) {
			compile (PUSHCONST, stkop (yyvsp[-1]));
		        push (1);	/* use control stack to count args */
		    }
		}
#line 2953 "y.tab.c"
    break;

  case 111: /* expr1: Y_FSCANF LP Y_IDENT DELIM $@11 scanfmt DELIM scanarg RP  */
#line 869 "grammar.y"
                                           {
		    if (!errcnt) {
			struct	operand o;

			/* Compile number of arguments. */
			o.o_type = OT_INT;
			o.o_val.v_i = pop();
			compile (PUSHCONST, &o);

			compile (FSCANF);
		    }
		}
#line 2970 "y.tab.c"
    break;

  case 112: /* $@12: %empty  */
#line 882 "grammar.y"
                            {
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 2979 "y.tab.c"
    break;

  case 113: /* expr1: intrinsx LP $@12 intrarg RP  */
#line 885 "grammar.y"
                             {
		    if (!errcnt) {
			struct	operand o;
			o.o_type = OT_INT;
			o.o_val.v_i = pop();
			compile (PUSHCONST, &o);
			compile (INTRINSIC, stkop(yyvsp[-4])->o_val.v_s);
		    }
		}
#line 2993 "y.tab.c"
    break;

  case 115: /* intrinsx: Y_INT  */
#line 900 "grammar.y"
                      {
			/* The YACC value of this must match normal intrinsics
			 * so we must generate an operand with the proper
			 * string. 
			 */
			if (!errcnt)
			    yyval = addconst ("int", OT_STRING);
		}
#line 3006 "y.tab.c"
    break;

  case 116: /* intrinsx: Y_REAL  */
#line 908 "grammar.y"
                       {
			if (!errcnt)
			    yyval = addconst ("real", OT_STRING);
		}
#line 3015 "y.tab.c"
    break;

  case 117: /* scanfmt: expr  */
#line 914 "grammar.y"
                     {
		    if (!errcnt) {
		        push (pop() + 1);		/* inc num args	*/
		    }
		}
#line 3025 "y.tab.c"
    break;

  case 119: /* scanarg: Y_IDENT  */
#line 927 "grammar.y"
                        {
                    if (!errcnt) {
                        compile (PUSHCONST, stkop (yyvsp[0]));
                        push (pop() + 1);               /* inc num args */
                    }
		}
#line 3036 "y.tab.c"
    break;

  case 120: /* scanarg: Y_IDENT DELIM scanarg  */
#line 933 "grammar.y"
                                      {
                    if (!errcnt) {
                        compile (PUSHCONST, stkop (yyvsp[-2]));
                        push (pop() + 1);               /* inc num args */
                    }
		}
#line 3047 "y.tab.c"
    break;

  case 122: /* intrarg: expr  */
#line 944 "grammar.y"
                     {
		    if (!errcnt)
			push (pop() + 1);		/* inc num args	*/
		}
#line 3056 "y.tab.c"
    break;

  case 123: /* intrarg: intrarg DELIM expr  */
#line 948 "grammar.y"
                                   {
		    if (!errcnt)
			push (pop() + 1);		/* inc num args	*/
		}
#line 3065 "y.tab.c"
    break;

  case 146: /* $@13: %empty  */
#line 986 "grammar.y"
                    {
		    bracelevel++;
		}
#line 3073 "y.tab.c"
    break;

  case 147: /* $@14: %empty  */
#line 988 "grammar.y"
                              {
		    --bracelevel;
		}
#line 3081 "y.tab.c"
    break;

  case 151: /* assign: ref equals expr0  */
#line 1000 "grammar.y"
                                 {
			--parenlevel;
 			if (!errcnt)
		      	    compile (ASSIGN, stkop(yyvsp[-2])->o_val.v_s);
		}
#line 3091 "y.tab.c"
    break;

  case 152: /* assign: ref equals ref  */
#line 1005 "grammar.y"
                               {
			/* Old code pushed a constant rather than a param
			 * when not within braces.  This doesn't seem
			 * to be what most people want.
			 */
			--parenlevel;
			if (!errcnt) {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
		            compile (ASSIGN, stkop(yyvsp[-2])->o_val.v_s);
		    	}
		}
#line 3107 "y.tab.c"
    break;

  case 153: /* $@15: %empty  */
#line 1016 "grammar.y"
                    {
			parenlevel++;
		}
#line 3115 "y.tab.c"
    break;

  case 154: /* assign: ref $@15 assign_oper expr  */
#line 1019 "grammar.y"
                                 {
		      	--parenlevel;
			if (!errcnt)
		  	    compile (yyvsp[-1], stkop(yyvsp[-3])->o_val.v_s);
		}
#line 3125 "y.tab.c"
    break;

  case 155: /* equals: '='  */
#line 1028 "grammar.y"
                    {
			parenlevel++;
		}
#line 3133 "y.tab.c"
    break;

  case 156: /* assign_oper: YOP_AOADD  */
#line 1033 "grammar.y"
                                { yyval = ADDASSIGN; }
#line 3139 "y.tab.c"
    break;

  case 157: /* assign_oper: YOP_AOSUB  */
#line 1034 "grammar.y"
                                { yyval = SUBASSIGN; }
#line 3145 "y.tab.c"
    break;

  case 158: /* assign_oper: YOP_AOMUL  */
#line 1035 "grammar.y"
                                { yyval = MULASSIGN; }
#line 3151 "y.tab.c"
    break;

  case 159: /* assign_oper: YOP_AODIV  */
#line 1036 "grammar.y"
                                { yyval = DIVASSIGN; }
#line 3157 "y.tab.c"
    break;

  case 160: /* assign_oper: YOP_AOCAT  */
#line 1037 "grammar.y"
                                { yyval = CATASSIGN; }
#line 3163 "y.tab.c"
    break;

  case 161: /* $@16: %empty  */
#line 1040 "grammar.y"
                        {
		    npipes = 0;
		}
#line 3171 "y.tab.c"
    break;

  case 162: /* cmdlist: command $@16 cmdpipe  */
#line 1042 "grammar.y"
                          {
		    if (!errcnt) {
			compile (EXEC);
			if (npipes > 0)
			    compile (RMPIPES, npipes);
		    }
		}
#line 3183 "y.tab.c"
    break;

  case 164: /* $@17: %empty  */
#line 1052 "grammar.y"
                             {
		    /* Pipefiles must be allocated at run time using a stack
		     * to permit pipe commands within loops, and to permit
		     * scripts called in a pipe to themselves contain pipe
		     * commands.  ADDPIPE allocates a new pipefile on the
		     * pipe stack and pushes its name on the operand stack.
		     * GETPIPE pushes the pipefile at the top of the pipe
		     * stack onto the operand stack.  RMPIPES removes N pipes
		     * from the pipe stack, and deletes the physical pipefiles.
		     */

		    if (!newstdout) {
			/* When the runtime code creates the pipe it needs to
			 * know the identity of the two tasks sharing the pipe
			 * to determine what type of pipe to create (text or
			 * binary).  Save the pc of the ADDPIPE instruction
			 * so that we can backpatch it below with a pointer to
			 * the name of the second task in the pipe (ADDPIPE
			 * will be called during startup of the first task
			 * hence will know its name).
			 */
			pipe_pc = compile (ADDPIPE, NULL);

			if (yyvsp[0] == 1)
			    compile (REDIR);
			else
			    compile (ALLREDIR);
			compile (EXEC);

		    } else {
			eprintf ("multiple redirection\n");
			YYERROR;
		    }

		}
#line 3223 "y.tab.c"
    break;

  case 165: /* cmdpipe: cmdpipe pipe $@17 command  */
#line 1086 "grammar.y"
                          {
		    /* Compile the GETPIPE instruction with the name of the
		     * second task in the current pipe, and backpatch the
		     * matching ADDPIPE instruction with the PC of the GETPIPE.
		     */
		    (coderef(pipe_pc))->c_args = compile (GETPIPE, curr_task);
		    compile (REDIRIN);
		    npipes++;		/* Overflow checking is in ADDPIPE */
		}
#line 3237 "y.tab.c"
    break;

  case 166: /* pipe: '|' opnl  */
#line 1097 "grammar.y"
                         {
		    yyval = 1;
		}
#line 3245 "y.tab.c"
    break;

  case 167: /* pipe: Y_ALLPIPE opnl  */
#line 1100 "grammar.y"
                               {
		    yyval = 2;
		}
#line 3253 "y.tab.c"
    break;

  case 168: /* $@18: %empty  */
#line 1105 "grammar.y"
                        {
		    char    *ltname;

		    ltname = stkop(yyvsp[0])->o_val.v_s;
		    compile (CALL, ltname);
		    strcpy (curr_task, ltname);

		    /* The FPRINT task is special; the first arg
		     * is the destination and must be compiled as
		     * a string constant no matter what.  Set flag
		     * so that 'arg' compiles PUSHCONST.
		     */
		    printstmt = (strcmp (ltname, "fprint") == 0);

		    /* Ditto with SCAN; all the arguments are call by
		     * reference and must be compiled as string constants.
		     */
		    scanstmt = (strcmp (ltname, "scan") == 0 ||
				strcmp (ltname, "scanf") == 0);

		    absmode = 0;
		    posit = 0;
		    newstdout = 0;
		    parenlevel = 0;
		}
#line 3283 "y.tab.c"
    break;

  case 169: /* $@19: %empty  */
#line 1129 "grammar.y"
                       {
		    inarglist = 1;
		}
#line 3291 "y.tab.c"
    break;

  case 170: /* command: tasknam $@18 BARG $@19 args EARG  */
#line 1131 "grammar.y"
                            {
		    inarglist = 0;
		    parenlevel = 0;
		    scanstmt = 0;
		}
#line 3301 "y.tab.c"
    break;

  case 171: /* $@20: %empty  */
#line 1138 "grammar.y"
                      {
		    /* (,x) equates to nargs == 2.  Call posargset with
		     * negative dummy argument to bump nargs.
		     */
		    if (!errcnt) {
			compile (POSARGSET, -1);
			posit++;
			printstmt = 0;
			scanstmt = 0;
		    }
		}
#line 3317 "y.tab.c"
    break;

  case 176: /* arg: %empty  */
#line 1157 "grammar.y"
                {
		    if (!errcnt) {
			if (posit > 0) {		/* not first time */
			    compile (POSARGSET, -posit);
			    printstmt = 0;
			    scanstmt = 0;
			}
			posit++;
		    }
		}
#line 3332 "y.tab.c"
    break;

  case 177: /* arg: expr0  */
#line 1167 "grammar.y"
                      {
		    if (absmode) {
			eprintf (posfirst);
			EYYERROR;
		    } else
			if (!errcnt)
			    compile (POSARGSET, posit++);
		}
#line 3345 "y.tab.c"
    break;

  case 178: /* arg: ref  */
#line 1175 "grammar.y"
                    {
		    if (absmode) {
			eprintf (posfirst);
			EYYERROR;
		    } else if (!errcnt) {
			if (scanstmt) {
			    char    pname[SZ_FNAME];
			    char    *pk, *t, *p, *f;
			    struct  pfile *pfp;
			    struct  operand o;

			    /* If no task name specified check the pfile for
			     * the task containing the scan statement for the
			     * named parameter.
			     */
			    breakout (stkop(yyvsp[0])->o_val.v_s, &pk, &t, &p, &f);
			    pfp = currentask->t_pfp;
			    if (*pk == '\0' && *t == '\0' &&
				pfp && paramfind(pfp,p,0,1)) {

				sprintf (pname, "%s.%s",
				    currentask->t_ltp->lt_lname, p);
				if (*f) {
				    strcat (pname, ".");
				    strcat (pname, f);
				}
			    } else
				strcpy (pname, stkop(yyvsp[0])->o_val.v_s);

			    o = *(stkop(yyvsp[0]));
			    o.o_val.v_s = pname;
			    compile (PUSHCONST, &o);
			    compile (INDIRPOSSET, posit++);

			} else if (parenlevel == 0 || printstmt) {
			    compile (PUSHCONST, stkop(yyvsp[0]));
			    compile (INDIRPOSSET, posit++);
			    /* only first arg of fprint stmt is special. */
			    printstmt = 0;

			} else {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			    compile (POSARGSET, posit++);
			}
		    }
		}
#line 3396 "y.tab.c"
    break;

  case 179: /* arg: ref '=' expr0  */
#line 1221 "grammar.y"
                              {
		    absmode++;
		    if (!errcnt)
			compile (ABSARGSET, stkop(yyvsp[-2])->o_val.v_s); 
		}
#line 3406 "y.tab.c"
    break;

  case 180: /* arg: ref '=' ref  */
#line 1226 "grammar.y"
                            {
		    absmode++;
		    if (!errcnt) {
			if (parenlevel == 0) {
			    compile (PUSHCONST, stkop(yyvsp[0]));
			    compile (INDIRABSSET, stkop(yyvsp[-2])->o_val.v_s); 
			} else {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			    compile (ABSARGSET, stkop(yyvsp[-2])->o_val.v_s);
			}
		    }
		}
#line 3423 "y.tab.c"
    break;

  case 181: /* arg: param '+'  */
#line 1238 "grammar.y"
                          {
		    absmode++;
		    if (!errcnt)
			compile (SWON, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3433 "y.tab.c"
    break;

  case 182: /* arg: param '-'  */
#line 1243 "grammar.y"
                          {
		    absmode++;
		    if (!errcnt)
			compile (SWOFF, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3443 "y.tab.c"
    break;

  case 183: /* arg: '<' file  */
#line 1248 "grammar.y"
                         {
		    if (!errcnt)
			compile (REDIRIN);
		}
#line 3452 "y.tab.c"
    break;

  case 184: /* arg: '>' file  */
#line 1252 "grammar.y"
                         {
		    newstdout++;
		    if (!errcnt)
			compile (REDIR);
		}
#line 3462 "y.tab.c"
    break;

  case 185: /* arg: Y_ALLREDIR file  */
#line 1257 "grammar.y"
                                {
		    newstdout++;
		    if (!errcnt)
			compile (ALLREDIR);
		}
#line 3472 "y.tab.c"
    break;

  case 186: /* arg: Y_APPEND file  */
#line 1262 "grammar.y"
                              {
		    newstdout++;
		    if (!errcnt)
			compile (APPENDOUT);
		}
#line 3482 "y.tab.c"
    break;

  case 187: /* arg: Y_ALLAPPEND file  */
#line 1267 "grammar.y"
                                 {
		    newstdout++;
		    if (!errcnt)
			compile (ALLAPPEND);
		}
#line 3492 "y.tab.c"
    break;

  case 188: /* arg: Y_GSREDIR file  */
#line 1272 "grammar.y"
                               {
		    if (!errcnt)
			compile (GSREDIR, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3501 "y.tab.c"
    break;

  case 189: /* file: expr0  */
#line 1278 "grammar.y"
                      {
		    absmode++;
		    /* constant already pushed by expr0.
		     */
		}
#line 3511 "y.tab.c"
    break;

  case 190: /* file: param  */
#line 1283 "grammar.y"
                      {
		    absmode++;
		    if (!errcnt) {
			if (parenlevel == 0)
			    compile (PUSHCONST, stkop(yyvsp[0]));
			else
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			}
		}
#line 3525 "y.tab.c"
    break;

  case 191: /* immed: equals expr0  */
#line 1294 "grammar.y"
                             {
			--parenlevel;
			if (!errcnt)
			    compile (IMMED);
		}
#line 3535 "y.tab.c"
    break;

  case 192: /* immed: equals ref  */
#line 1299 "grammar.y"
                           {
		      	--parenlevel;
			if (!errcnt)
			    compile (INSPECT, stkop(yyvsp[0])->o_val.v_s);
		}
#line 3545 "y.tab.c"
    break;

  case 193: /* inspect: ref equals  */
#line 1306 "grammar.y"
                           {
			--parenlevel;
			if (!errcnt)
			    compile (INSPECT, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3555 "y.tab.c"
    break;

  case 194: /* osesc: Y_OSESC  */
#line 1313 "grammar.y"
                        {
		    if (!errcnt)
			compile (OSESC, stkop(yyvsp[0])->o_val.v_s);
		}
#line 3564 "y.tab.c"
    break;

  case 195: /* popstk: equals  */
#line 1319 "grammar.y"
                       {
		    --parenlevel;
		    if (!errcnt)
			compile (IMMED);
		}
#line 3574 "y.tab.c"
    break;

  case 196: /* if: if_stat  */
#line 1326 "grammar.y"
                        {
		    /* pop BIFF addr and set branch to just after statement
		     */
		    XINT   biffaddr;
		    if (!errcnt) {
			biffaddr = pop();
		    	coderef (biffaddr)->c_args = pc - biffaddr - 3;
		    }
		}
#line 3588 "y.tab.c"
    break;

  case 197: /* $@21: %empty  */
#line 1337 "grammar.y"
                                {
			/* save BIFF addr so branch can be filled in 
			 */
			if (!errcnt)
			    push (compile (BIFF, 0));
		}
#line 3599 "y.tab.c"
    break;

  case 198: /* if_stat: Y_IF LP expr RP $@21 opnl xstmt  */
#line 1342 "grammar.y"
                             {
			/* The shift/reduce conflict in the IF-IF/ELSE
			 * construct can cause errors in compilation
			 * because the IF statement can also be a
			 * terminal symbol, i.e. it may be all that
			 * is parsed in one call to the parser.
			 * The parser must look ahead one token
			 * to find if there is an else statement
			 * following.  If there is no following
			 * token an EOF may be detected prematurely.
			 * When the IF statement is being parsed not
			 * inside any braces, then when the next token
			 * is not an ELSE care must be taken that this
			 * token is seen on a subsequent invocation
			 * of the parser.  The `ifseen' flag is
			 * used within the support for the lexical
			 * analyzer located in `history.c'.
			 */
			if (cldebug) 
			    eprintf ("ytab: setting ifseen=yes\n");

			if (currentask->t_flags & T_INTERACTIVE)
			    ifseen = ip_cmdblk;
			else
			    ifseen = cmdblk;
		}
#line 3630 "y.tab.c"
    break;

  case 199: /* $@22: %empty  */
#line 1370 "grammar.y"
                               {
		    XINT  biffaddr;

		    ifseen = NULL;
		    if (!errcnt) {
			/* Pop and save BIFF address, compile and push addr 
			 * of GOTO, and set BIFF branch to just after GOTO.
			 */
			biffaddr = pop();
			push (compile (GOTO, 0));
			coderef (biffaddr)->c_args = pc - biffaddr - 3;
		    }
		}
#line 3648 "y.tab.c"
    break;

  case 200: /* ifelse: if_stat Y_ELSE $@22 opnl xstmt  */
#line 1382 "grammar.y"
                             {
		    XINT  gotoaddr;
		    if (!errcnt) {
			/* Pop GOTO addr and set branch to just after statement
			 */
			gotoaddr = pop();
			coderef (gotoaddr)->c_args = pc - gotoaddr - 3;
		    }
		}
#line 3662 "y.tab.c"
    break;

  case 201: /* $@23: %empty  */
#line 1393 "grammar.y"
                           {
		    /* Save starting addr of while expression.
		     */
		    if (!errcnt) {
			push (pc);
			loopincr();
		    }
		}
#line 3675 "y.tab.c"
    break;

  case 202: /* $@24: %empty  */
#line 1400 "grammar.y"
                          {
		    /* Save BIFF addr so branch can be filled in.
		     */
		    if (!errcnt)
			push (compile (BIFF, 0));
		}
#line 3686 "y.tab.c"
    break;

  case 203: /* while: Y_WHILE LP $@23 expr RP $@24 opnl xstmt  */
#line 1405 "grammar.y"
                             {
		    XINT  biffaddr;

		    if (!errcnt) {
			/* Pop and save addr of BIFF instruction.	   */
			biffaddr = pop();
			/* Pop addr of expression and build a goto there.  */
			compile (GOTO, pop() - pc - 3);
			/* Now can set BIFF branch to just after statement.*/
			coderef (biffaddr)->c_args = pc - biffaddr - 3;
			loopdecr();
		    }
		}
#line 3704 "y.tab.c"
    break;

  case 204: /* $@25: %empty  */
#line 1438 "grammar.y"
                                               {
			if (!errcnt)
			    push(pc);				/* Loop1: */
		}
#line 3713 "y.tab.c"
    break;

  case 205: /* $@26: %empty  */
#line 1442 "grammar.y"
                               {
			if (!errcnt) {
			    if (for_expr)
				ppush (compile(BIFF, 0));	/* if (!e2) */

			    /* Add 3 to skip following GOTO. 
			     */
			    ppush (pc+3);			/* Loop2: */
			    ppush (compile(GOTO,0));		/* goto Loop3 */

			    /* Save current location as the destination
			     * for NEXT statements.
			     */
			    loopincr();
			}
		}
#line 3734 "y.tab.c"
    break;

  case 206: /* $@27: %empty  */
#line 1458 "grammar.y"
                                {
			XINT  stmtaddr;

			if (!errcnt) {
			    stmtaddr = pop();
			    compile (GOTO, stmtaddr-pc-3); 	/* Goto loop1 */
			    stmtaddr = pop();
			    coderef(stmtaddr)->c_args = pc - stmtaddr - 3;
			}
		}
#line 3749 "y.tab.c"
    break;

  case 207: /* for: Y_FOR LP opnl xassign ';' opnl $@25 xexpr ';' opnl $@26 xassign RP opnl $@27 stmt  */
#line 1468 "grammar.y"
                     {
			XINT  stmtaddr;

			if (!errcnt) {
			    stmtaddr = pop();
			    compile (GOTO, stmtaddr-pc-3); /* goto loop2 */

			    if (for_expr) {
				stmtaddr = pop();
				coderef(stmtaddr)->c_args = pc - stmtaddr - 3;
			    }
			    loopdecr();
			}
		}
#line 3768 "y.tab.c"
    break;

  case 210: /* xexpr: expr  */
#line 1491 "grammar.y"
                     {
			for_expr = YES;
		}
#line 3776 "y.tab.c"
    break;

  case 211: /* xexpr: %empty  */
#line 1494 "grammar.y"
                            {
			for_expr = NO;
		}
#line 3784 "y.tab.c"
    break;

  case 212: /* $@28: %empty  */
#line 1520 "grammar.y"
                {
			if (!errcnt) {
			    push (compile(SWITCH));

			    /* Compile GOTO which will branch past end of
			     * switch.  This is needed if there is no DEFAULT.
			     */
			    compile (GOTO, 0);
			}
		}
#line 3799 "y.tab.c"
    break;

  case 213: /* switch: Y_SWITCH opnl LP opnl expr opnl RP opnl $@28 xstmt  */
#line 1529 "grammar.y"
                        {
			/* Set up jumptable and pop space on stack.
			 */
			if (!errcnt)
			    setswitch();
		}
#line 3810 "y.tab.c"
    break;

  case 214: /* $@29: %empty  */
#line 1537 "grammar.y"
                       {
			if (!errcnt) {
			    ncaseval = 0;
			    if (!in_switch()) {
				eprintf ("Improper CASE statement.\n");
				EYYERROR;
			    }
			}
		}
#line 3824 "y.tab.c"
    break;

  case 215: /* $@30: %empty  */
#line 1545 "grammar.y"
                                           {
			XINT  pcase;

			if (!errcnt) {
			    pcase = compile (CASE, ncaseval);

			    /* Fill in argument list. 
			     */
			    caseset (&(coderef(pcase)->c_args), ncaseval);
			    push (pcase);
			}
		}
#line 3841 "y.tab.c"
    break;

  case 216: /* case: Y_CASE $@29 const_expr_list ':' opnl $@30 xstmt  */
#line 1556 "grammar.y"
                        {
			/* Branch to end of switch block 
			 */
			if (!errcnt)
			    push (compile(GOTO, 0));
		}
#line 3852 "y.tab.c"
    break;

  case 217: /* $@31: %empty  */
#line 1564 "grammar.y"
                                   {
		      	/* Compile an operand to store the current PC.
			 */
			if (!errcnt) {
			    if (!in_switch()) {
				eprintf ("Improper DEFAULT statement.\n");
				EYYERROR;
			    }
			    push (compile(DEFAULT));
			}
		}
#line 3868 "y.tab.c"
    break;

  case 218: /* default: Y_DEFAULT ':' opnl $@31 xstmt  */
#line 1574 "grammar.y"
                        {
		      	/* Branch past jump table. 
			 */
			if (!errcnt)
			    push (compile(GOTO, 0));
		}
#line 3879 "y.tab.c"
    break;

  case 219: /* next: Y_NEXT  */
#line 1582 "grammar.y"
                       {
			/* All NEXT statements are backward references,
			 * so we simply store the addresses in an array.
			 */
			if (!errcnt) {
			    if (nestlevel)
				compile (GOTO, nextdest[nestlevel-1]-pc-3);
			    else {
				eprintf ( "NEXT outside of loop.\n");
				EYYERROR;
			    }
			}
		}
#line 3897 "y.tab.c"
    break;

  case 220: /* break: Y_BREAK  */
#line 1597 "grammar.y"
                        {
			/* Each BREAK is a forward reference.  For the
			 * first BREAK in each loop we compile a
			 * GOTO statement which will be the object of
			 * all BREAK statements within the loop.  When
			 * the loop is terminated the target of this
			 * GOTO will be set.
			 */
			int  dest;

			if (!errcnt) {
			    if (!nestlevel) {
				eprintf ("Break outside of loop.\n");
				EYYERROR;
			    } else if ((dest = brkdest[nestlevel-1]) != 0)
		    		compile (GOTO, dest-pc-3);
			    else {
				brkdest[nestlevel-1] = pc;
				compile (GOTO, 0);
			    }
			}
		}
#line 3924 "y.tab.c"
    break;

  case 221: /* return: Y_RETURN  */
#line 1621 "grammar.y"
                         {
			if (!errcnt)
			    compile (END);
		}
#line 3933 "y.tab.c"
    break;

  case 222: /* return: Y_RETURN expr  */
#line 1625 "grammar.y"
                              {
			/* Return values currently not implemented.
			 */
			eprintf ("Warning: return value ignored.\n");
			if (!errcnt)
			    compile (END);
		}
#line 3945 "y.tab.c"
    break;

  case 223: /* end_stmt: Y_END NL  */
#line 1637 "grammar.y"
                         {
			bracelevel -= PBRACE;
			if (bracelevel < 0) {
			    eprintf ("Too few left braces.\n");
			    EYYERROR;
			} else if (bracelevel > 0) {
			    eprintf ("Too few right braces.\n");
			    EYYERROR;
			}
		}
#line 3960 "y.tab.c"
    break;

  case 224: /* $@32: %empty  */
#line 1649 "grammar.y"
                                 {
			/* Put symbol in table in dictionary and
			 * process indirect references if present.
			 */
			struct label *l;

			if (!errcnt) {
			    l = getlabel (stkop(yyvsp[-2]));

			    if (l == NULL) {
				l = setlabel (stkop(yyvsp[-2]));
				l->l_loc = pc;
			    } else if (l->l_defined) {
			        eprintf ("Identical labels.\n");
				EYYERROR;
			    } else {
				/* Get this GOTO out of the
				 * indirect list so we can use
				 * the argument as the destination
				 */
				XINT  gotopc;
				gotopc = l->l_loc;
				unsetigoto (gotopc);

				/* Fix the indirect reference. 
				 */
				coderef(gotopc)->c_args = pc - gotopc - 3;
			    }
			    (l->l_defined)++;
			}
		}
#line 3996 "y.tab.c"
    break;

  case 226: /* goto: Y_GOTO Y_IDENT  */
#line 1683 "grammar.y"
                               {
			/* Get the address corresponding to the label.
			 */
			struct label *l;

			if (!errcnt) {
			    l = getlabel (stkop(yyvsp[0]));

			    if (l != NULL)
				compile (GOTO, l->l_loc - pc - 3);
			    else {
				/* Ready for indirect GOTO 
				 */
				l = setlabel (stkop(yyvsp[0]));
				l->l_loc = pc;
				setigoto (compile(GOTO, 0));
				l->l_defined = 0;
			    }
			}
		}
#line 4021 "y.tab.c"
    break;

  case 229: /* $@33: %empty  */
#line 1713 "grammar.y"
                            { 
			/* Save pc before compiling statement for loop back
			 */
			stmt_pc = pc;
			n_oarr = 0;
			i_oarr = 0;
			ifseen = NULL;
		}
#line 4034 "y.tab.c"
    break;

  case 230: /* xstmt: $@33 stmt  */
#line 1721 "grammar.y"
                     {
		      	/* If there was an open reference compile the
			 * loop increment and goback.
			 */
			XINT push_pc;

			if (!errcnt) {
			    if (n_oarr) {
				compile (INDXINCR, stmt_pc-pc-4, 2*n_oarr+1);

				/* We are going to store initialization
				 * info for the implicit loop here.
				 * It is loopincr's responsibility to 
				 * branch around it.  This data is what
				 * should be pointed to by the special
				 * PUSHINDEX compiled at the first open
				 * array reference.
				 */
				push_pc = pop();  /* Location of PUSHINDEX */
				coderef(push_pc)->c_args = pc - push_pc - 3;

				stack[pc++] = n_oarr;
				for (i_oarr=0; i_oarr<n_oarr; i_oarr++) {
				    stack[pc++] = oarr_beg[i_oarr];
				    stack[pc++] = oarr_end[i_oarr];
				}

				/* Clear n_oarr.  This must be done here
				 * because we may have the end of a compound
				 * statement following on the heels of the
				 * end of the simple statement with the
				 * implicit loop.
				 */
				n_oarr = 0;
				i_oarr = 0;
			    }
			}
		}
#line 4077 "y.tab.c"
    break;

  case 232: /* xstmt: error NL  */
#line 1760 "grammar.y"
                         {
		    /* This should get most errors in executable statements
		     * or in the local variable declarations in a script.
		     */
		    yyerrok;

		    /* Get rid of any fake braces.
		     */
		    bracelevel -= tbrace;

		    /* Discard everything and compile a null statement.
		     */
		    if (!errcnt) {
			do_params = YES;
			pc = currentask->t_bascode;
			if (parse_state != PARSE_PARAMS)
			    compile (END);

			topd = currentask->t_topd;
			topcs = currentask->t_topcs;

			/* Unlink any added parms.  Resetting of topd will
			 * already have reclaimed space.
			 */
			if (last_parm) {
			    last_parm->p_np = NULL;
			    currentask->t_pfp->pf_lastpp = last_parm;
			    last_parm = NULL;
			}
 		    }

		    /* Tell user about the syntax error, printing the 
		     * offending line and position if possible.
		     */
		    if (currentask->t_flags & T_SCRIPT) 
			eprintf ("** Syntax error, line %d\n",
			    currentask->t_scriptln);
		    else
			eprintf ("** Syntax error\n");
		    p_position();

		    if (!(currentask->t_flags & T_SCRIPT)) {
			/* If interactive, we're finished if not within braces.
			 */
			if (!bracelevel)
			    YYACCEPT;
		    }

		    /* Note that we do not call cl_error() here to abort, but
		     * continue on parsing the script for more syntax errors.
		     */
		    if (++errcnt > MAX_ERR)
			cl_error (E_UERR, "Too many syntax errors.");
		}
#line 4136 "y.tab.c"
    break;

  case 235: /* const_expr: Y_CONSTANT  */
#line 1820 "grammar.y"
                                   {
				if (!errcnt) {
				    push(stkop(yyvsp[0])) ; 
				    ncaseval++;
				}
			}
#line 4147 "y.tab.c"
    break;

  case 238: /* ref: param  */
#line 1840 "grammar.y"
                      {
			int  dim, d, i1, i2, mode;

			/*  In command arguments, when not in parentheses
			 *  we just pass the param as a string constant.
			 */
			if (!errcnt) {
			    lastref = NO;
			    if (!inarglist || parenlevel) {
				i_oarr = 0;
				index_cnt = 0;

				strncpy (curr_param, stkop(yyvsp[0])->o_val.v_s, 
					SZ_FNAME);

				/* If a '.' is found in the name we have a 
				 * reference to an external task, or to a 
				 * specific field.  In these cases we don't 
				 * want implicit looping.
				 */
				if (strchr (curr_param, '.') == NULL) {
				    if ((dim = get_dim (curr_param)) > 0) {
					lastref = YES;
			        	for (d = 0; d < dim; d++) {
					    getlimits (curr_param, d, &i1, &i2);
					    mode = make_imloop (i1, i2);
					    if (mode)
						compile (PUSHINDEX, -1);
					    else
						push (compile(PUSHINDEX, 0));	
					}
			    		n_oarr = dim;
				    }
				}
			    }
			}
		}
#line 4189 "y.tab.c"
    break;

  case 239: /* $@34: %empty  */
#line 1877 "grammar.y"
                      {
		    if (!errcnt) {
			strncpy (curr_param, stkop(yyvsp[0])->o_val.v_s, SZ_FNAME);
			index_cnt = 0;
		    }
		}
#line 4200 "y.tab.c"
    break;

  case 240: /* ref: param $@34 '[' index_list ']'  */
#line 1884 "grammar.y"
                {
		    if (i_oarr > 0  &&  n_oarr == 0)
			n_oarr = i_oarr;
		    i_oarr = 0;
		    lastref = YES;
		}
#line 4211 "y.tab.c"
    break;

  case 241: /* index_list: index  */
#line 1892 "grammar.y"
                      {
			index_cnt = 1;
		}
#line 4219 "y.tab.c"
    break;

  case 242: /* $@35: %empty  */
#line 1895 "grammar.y"
                      {
			index_cnt++;
		}
#line 4227 "y.tab.c"
    break;

  case 244: /* index: expr1  */
#line 1901 "grammar.y"
                      {
			if (!errcnt)
			    compile (PUSHINDEX, 0);
		}
#line 4236 "y.tab.c"
    break;

  case 245: /* index: ref  */
#line 1906 "grammar.y"
                { 
			if (!errcnt) {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			    compile (PUSHINDEX, 0);
			}
		}
#line 4247 "y.tab.c"
    break;

  case 246: /* index: '*'  */
#line 1912 "grammar.y"
                    {
			int  i1, i2, mode;

			if (!errcnt) {
			    if (strchr(curr_param, '.') != NULL) {
				eprintf (exlimits);
				EYYERROR;
			    }
			    if (getlimits (curr_param, index_cnt, &i1, &i2) 
				== ERR) {
				eprintf ("Implicit index error for %s.\n",
					curr_param);
				EYYERROR;
			    }
			    mode = make_imloop (i1, i2);
			    if (mode)
				compile (PUSHINDEX, mode);
			    else
				push (compile (PUSHINDEX, mode));
			}
		}
#line 4273 "y.tab.c"
    break;

  case 247: /* index: Y_CONSTANT  */
#line 1933 "grammar.y"
                           {
			/*  There is an ambiguity in the grammar between
			 *  sexagesimal constants, and array range references.
			 *  Since the sexagesimal constants are recognized
			 *  in the lexical analyzer we can't just change the
			 *  grammar.  The kludge around this is to have
			 *  makeop set a flag telling us that the last
			 *  constant it compiled COULD have been an index
			 *  range.  We check the flag here and if it is
			 *  set we convert back and compile an implicit loop
			 *  otherwise we just push the constant.
			 */
			int  i1, i2, mode;

			if (!errcnt) {
			    if (maybeindex) {
				sexa_to_index (stkop(yyvsp[0])->o_val.v_r, &i1, &i2);
				mode = make_imloop (i1, i2);
				if (mode)
				    compile (PUSHINDEX, mode);
				else
				    push (compile (PUSHINDEX, mode));
			    } else {
				compile (PUSHCONST, stkop(yyvsp[0]));
				compile (PUSHINDEX, 0);
			    }
			}
		}
#line 4306 "y.tab.c"
    break;

  case 248: /* intrins: Y_IDENT  */
#line 1967 "grammar.y"
                        {
		    yyval = yyvsp[0];
		}
#line 4314 "y.tab.c"
    break;

  case 249: /* param: Y_IDENT  */
#line 1972 "grammar.y"
                        {
		    yyval = yyvsp[0];
		}
#line 4322 "y.tab.c"
    break;

  case 250: /* tasknam: Y_IDENT  */
#line 1977 "grammar.y"
                        {
		    yyval = yyvsp[0];
		}
#line 4330 "y.tab.c"
    break;

  case 252: /* EOST: ';'  */
#line 1983 "grammar.y"
                    {
		    /* If statements are delimited by ';'s, do not execute
		     * until next newline EOST is received.
		     */
		    sawnl = 0;
		}
#line 4341 "y.tab.c"
    break;

  case 258: /* LP: '('  */
#line 2005 "grammar.y"
                        { parenlevel++; }
#line 4347 "y.tab.c"
    break;

  case 259: /* RP: ')'  */
#line 2008 "grammar.y"
                        { --parenlevel; }
#line 4353 "y.tab.c"
    break;

  case 260: /* NL: Y_NEWLINE  */
#line 2011 "grammar.y"
                           { sawnl = 1; }
#line 4359 "y.tab.c"
    break;


#line 4363 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2014 "grammar.y"


#include "lexyy.c"
#include "lexicon.c"
