/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "grammar.y"


#include <ctype.h>
#include <string.h>

#define import_spp
#define import_libc
#define import_stdio
#include <iraf.h>

#include "config.h"
#include "mem.h"
#include "operand.h"
#include "param.h"
#include "grammar.h"
#include "opcodes.h"
#include "clmodes.h"
#include "task.h"
#include "construct.h"
#include "errs.h"
#include "proto.h"


/* CL parser, written as a yacc grammar:
 *   build up an (rpn) instruction sequence begining at the base of the
 *   operand stack as the grammar is recognized.
 *
 * The parser may be called during parameter initialization (initiated by
 * the CALL meta-code instruction), and to parse the executable portion
 * (from the EXEC instruction).
 *
 * CONSTANT's are put on the dictionary by addconst() rather than the operand
 *   stack to avoid conflict with the code being created.  They are accessed
 *   by using the yylval of IDENT and CONSTANT as dictionary indices that
 *   point to struct operands.  This is facilitated with the stkop() macro.
 *   Make sure that topd and topcs are restored on return to discard these
 *   temporaries.
 * When building offsets for branches, such as BIFF and GOTO, allow
 *   for the advancement of the pc by the size of the instruction (in ints).
 *   See opcodes.c for the code executed by the branch instructions.
 */

extern	int cldebug;
#define	lint			/* turns off sccsid in Yacc parser	*/

/* shorthand way to get at operands in dictionary. x will be values returned
 * from addconst() by way of $n's from CONSTANT and IDENT tokens; see gram.c
 * and its uses in grammar.l. also see pushop() for a description of the stack.
 */
#define	stkop(x)	(reference (operand, (x)))

int	dobkg 		= 0;	/* set when want to do code in bkground	*/
int	npipes 		= 0;	/* number of pipes in a command		*/
XINT	pipe_pc		= 0;	/* pc of last ADDPIPE instruction	*/
int	posit 		= 0;	/* positional argument count		*/
int	inarglist 	= 0;	/* set when in argument list		*/
int	parenlevel 	= 0;	/* level of paren nesting in command	*/
int 	in_iferr 	= 0;	/* in an iferr block			*/
int	cl_level	= 0;	/* CL calling level			*/

int	index_cnt;		/* Index counter in array ref's		*/
char	curr_param[SZ_FNAME];	/* Parameter name of ref's		*/
char	curr_task[SZ_FNAME];	/* ltaskname of command 		*/
XINT	stmt_pc;		/* PC at beginning of current statement */
int	varlist;		/* Declaration is list directed.	*/
int	vartype;		/* Type of declaration.			*/
int	do_params;		/* Are param definitions legal here?	*/
int	errcnt;			/* Syntax error count.			*/
int	inited;			/* Was variable already initialized.	*/
struct	param *pp;		/* Pointer to param being compiled.	*/
int	n_aval;			/* Number of array init values.		*/
int	lastref;		/* Was last ref an array?		*/
int	for_expr;		/* Was there an expression in FOR?	*/
char	*ifseen;		/* Have we just processed an IF?	*/
char	*errmsg;		/* Syntax error message.		*/

/* context-sensitive switches. technique is ok, but beware of nesting!
 */
static	int absmode 	= 0;	/* set by first absolute mode arg in cmd*/
static	int newstdout 	= 0;	/* set if stdout redirected in arg	*/
static	int bracelevel 	= 0;	/* set while in s_list to inhibit &	*/
static	int tbrace 	= 0;	/* fake braces for declarations		*/
static	int dobrace 	= 0;	/* handling braces.			*/
static	int sawnl 	= 0;	/* set when EOST was \n, else 0		*/
static	int printstmt 	= 0;	/* set when parsing FPRINT statement	*/
static	int scanstmt 	= 0;	/* set when parsing SCAN statement	*/
static	int iferr_tok 	= 0;	/* iferr/ifnoerr token type seen	*/

/* printf-format error messages.
 */
char *arrdeferr   = "Error in array initialization for `%s'.";
char *badparm     = "Parameter definition of `%s' is illegal here.";
char *inval_arr   = "Invalid array type for `%s'.";
char *inv_index   = "Invalid index definition for `%s'.";
char *twoinits    = "Two initializations for parameter `%s'.";

char *exlimits    = "Explicit range required for loop in external param.";
char *illegalvar  = "Illegal variable declarations.";
char *locallist   = "Local list variables are not permitted.";
char *nestediferr = "Nested iferr not allowed in test or handler block.";
char *posfirst    = "All positional arguments must be first";


extern	char	cmdblk[SZ_CMDBLK+1];	/* Command buffer in history.c */
extern	char	*ip_cmdblk;		/* Pointer to current char in command.*/
extern	char	*err_cmdblk;		/* ip_cmdblk when error detected. */

/* arbitrary large number for bracelevel in a procedure script 
 */
#define MAX_ERR    10
#define EYYERROR  { err_cmdblk = ip_cmdblk; YYERROR; }


#line 185 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    Y_SCAN = 258,                  /* Y_SCAN  */
    Y_SCANF = 259,                 /* Y_SCANF  */
    Y_FSCAN = 260,                 /* Y_FSCAN  */
    Y_FSCANF = 261,                /* Y_FSCANF  */
    Y_OSESC = 262,                 /* Y_OSESC  */
    Y_APPEND = 263,                /* Y_APPEND  */
    Y_ALLAPPEND = 264,             /* Y_ALLAPPEND  */
    Y_ALLREDIR = 265,              /* Y_ALLREDIR  */
    Y_GSREDIR = 266,               /* Y_GSREDIR  */
    Y_ALLPIPE = 267,               /* Y_ALLPIPE  */
    D_D = 268,                     /* D_D  */
    D_PEEK = 269,                  /* D_PEEK  */
    Y_NEWLINE = 270,               /* Y_NEWLINE  */
    Y_CONSTANT = 271,              /* Y_CONSTANT  */
    Y_IDENT = 272,                 /* Y_IDENT  */
    Y_WHILE = 273,                 /* Y_WHILE  */
    Y_IF = 274,                    /* Y_IF  */
    Y_ELSE = 275,                  /* Y_ELSE  */
    Y_FOR = 276,                   /* Y_FOR  */
    Y_BREAK = 277,                 /* Y_BREAK  */
    Y_NEXT = 278,                  /* Y_NEXT  */
    Y_SWITCH = 279,                /* Y_SWITCH  */
    Y_CASE = 280,                  /* Y_CASE  */
    Y_DEFAULT = 281,               /* Y_DEFAULT  */
    Y_RETURN = 282,                /* Y_RETURN  */
    Y_GOTO = 283,                  /* Y_GOTO  */
    Y_PROCEDURE = 284,             /* Y_PROCEDURE  */
    Y_BEGIN = 285,                 /* Y_BEGIN  */
    Y_END = 286,                   /* Y_END  */
    Y_BOOL = 287,                  /* Y_BOOL  */
    Y_INT = 288,                   /* Y_INT  */
    Y_REAL = 289,                  /* Y_REAL  */
    Y_STRING = 290,                /* Y_STRING  */
    Y_FILE = 291,                  /* Y_FILE  */
    Y_STRUCT = 292,                /* Y_STRUCT  */
    Y_GCUR = 293,                  /* Y_GCUR  */
    Y_IMCUR = 294,                 /* Y_IMCUR  */
    Y_UKEY = 295,                  /* Y_UKEY  */
    Y_PSET = 296,                  /* Y_PSET  */
    Y_IFERR = 297,                 /* Y_IFERR  */
    Y_IFNOERR = 298,               /* Y_IFNOERR  */
    Y_THEN = 299,                  /* Y_THEN  */
    YOP_AOADD = 300,               /* YOP_AOADD  */
    YOP_AOSUB = 301,               /* YOP_AOSUB  */
    YOP_AOMUL = 302,               /* YOP_AOMUL  */
    YOP_AODIV = 303,               /* YOP_AODIV  */
    YOP_AOCAT = 304,               /* YOP_AOCAT  */
    YOP_OR = 305,                  /* YOP_OR  */
    YOP_AND = 306,                 /* YOP_AND  */
    YOP_EQ = 307,                  /* YOP_EQ  */
    YOP_NE = 308,                  /* YOP_NE  */
    YOP_LE = 309,                  /* YOP_LE  */
    YOP_GE = 310,                  /* YOP_GE  */
    YOP_CONCAT = 311,              /* YOP_CONCAT  */
    YOP_NOT = 312,                 /* YOP_NOT  */
    UMINUS = 313,                  /* UMINUS  */
    YOP_POW = 314                  /* YOP_POW  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define Y_SCAN 258
#define Y_SCANF 259
#define Y_FSCAN 260
#define Y_FSCANF 261
#define Y_OSESC 262
#define Y_APPEND 263
#define Y_ALLAPPEND 264
#define Y_ALLREDIR 265
#define Y_GSREDIR 266
#define Y_ALLPIPE 267
#define D_D 268
#define D_PEEK 269
#define Y_NEWLINE 270
#define Y_CONSTANT 271
#define Y_IDENT 272
#define Y_WHILE 273
#define Y_IF 274
#define Y_ELSE 275
#define Y_FOR 276
#define Y_BREAK 277
#define Y_NEXT 278
#define Y_SWITCH 279
#define Y_CASE 280
#define Y_DEFAULT 281
#define Y_RETURN 282
#define Y_GOTO 283
#define Y_PROCEDURE 284
#define Y_BEGIN 285
#define Y_END 286
#define Y_BOOL 287
#define Y_INT 288
#define Y_REAL 289
#define Y_STRING 290
#define Y_FILE 291
#define Y_STRUCT 292
#define Y_GCUR 293
#define Y_IMCUR 294
#define Y_UKEY 295
#define Y_PSET 296
#define Y_IFERR 297
#define Y_IFNOERR 298
#define Y_THEN 299
#define YOP_AOADD 300
#define YOP_AOSUB 301
#define YOP_AOMUL 302
#define YOP_AODIV 303
#define YOP_AOCAT 304
#define YOP_OR 305
#define YOP_AND 306
#define YOP_EQ 307
#define YOP_NE 308
#define YOP_LE 309
#define YOP_GE 310
#define YOP_CONCAT 311
#define YOP_NOT 312
#define UMINUS 313
#define YOP_POW 314

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Y_SCAN = 3,                     /* Y_SCAN  */
  YYSYMBOL_Y_SCANF = 4,                    /* Y_SCANF  */
  YYSYMBOL_Y_FSCAN = 5,                    /* Y_FSCAN  */
  YYSYMBOL_Y_FSCANF = 6,                   /* Y_FSCANF  */
  YYSYMBOL_Y_OSESC = 7,                    /* Y_OSESC  */
  YYSYMBOL_Y_APPEND = 8,                   /* Y_APPEND  */
  YYSYMBOL_Y_ALLAPPEND = 9,                /* Y_ALLAPPEND  */
  YYSYMBOL_Y_ALLREDIR = 10,                /* Y_ALLREDIR  */
  YYSYMBOL_Y_GSREDIR = 11,                 /* Y_GSREDIR  */
  YYSYMBOL_Y_ALLPIPE = 12,                 /* Y_ALLPIPE  */
  YYSYMBOL_D_D = 13,                       /* D_D  */
  YYSYMBOL_D_PEEK = 14,                    /* D_PEEK  */
  YYSYMBOL_Y_NEWLINE = 15,                 /* Y_NEWLINE  */
  YYSYMBOL_Y_CONSTANT = 16,                /* Y_CONSTANT  */
  YYSYMBOL_Y_IDENT = 17,                   /* Y_IDENT  */
  YYSYMBOL_Y_WHILE = 18,                   /* Y_WHILE  */
  YYSYMBOL_Y_IF = 19,                      /* Y_IF  */
  YYSYMBOL_Y_ELSE = 20,                    /* Y_ELSE  */
  YYSYMBOL_Y_FOR = 21,                     /* Y_FOR  */
  YYSYMBOL_Y_BREAK = 22,                   /* Y_BREAK  */
  YYSYMBOL_Y_NEXT = 23,                    /* Y_NEXT  */
  YYSYMBOL_Y_SWITCH = 24,                  /* Y_SWITCH  */
  YYSYMBOL_Y_CASE = 25,                    /* Y_CASE  */
  YYSYMBOL_Y_DEFAULT = 26,                 /* Y_DEFAULT  */
  YYSYMBOL_Y_RETURN = 27,                  /* Y_RETURN  */
  YYSYMBOL_Y_GOTO = 28,                    /* Y_GOTO  */
  YYSYMBOL_Y_PROCEDURE = 29,               /* Y_PROCEDURE  */
  YYSYMBOL_Y_BEGIN = 30,                   /* Y_BEGIN  */
  YYSYMBOL_Y_END = 31,                     /* Y_END  */
  YYSYMBOL_Y_BOOL = 32,                    /* Y_BOOL  */
  YYSYMBOL_Y_INT = 33,                     /* Y_INT  */
  YYSYMBOL_Y_REAL = 34,                    /* Y_REAL  */
  YYSYMBOL_Y_STRING = 35,                  /* Y_STRING  */
  YYSYMBOL_Y_FILE = 36,                    /* Y_FILE  */
  YYSYMBOL_Y_STRUCT = 37,                  /* Y_STRUCT  */
  YYSYMBOL_Y_GCUR = 38,                    /* Y_GCUR  */
  YYSYMBOL_Y_IMCUR = 39,                   /* Y_IMCUR  */
  YYSYMBOL_Y_UKEY = 40,                    /* Y_UKEY  */
  YYSYMBOL_Y_PSET = 41,                    /* Y_PSET  */
  YYSYMBOL_Y_IFERR = 42,                   /* Y_IFERR  */
  YYSYMBOL_Y_IFNOERR = 43,                 /* Y_IFNOERR  */
  YYSYMBOL_Y_THEN = 44,                    /* Y_THEN  */
  YYSYMBOL_45_ = 45,                       /* '='  */
  YYSYMBOL_YOP_AOADD = 46,                 /* YOP_AOADD  */
  YYSYMBOL_YOP_AOSUB = 47,                 /* YOP_AOSUB  */
  YYSYMBOL_YOP_AOMUL = 48,                 /* YOP_AOMUL  */
  YYSYMBOL_YOP_AODIV = 49,                 /* YOP_AODIV  */
  YYSYMBOL_YOP_AOCAT = 50,                 /* YOP_AOCAT  */
  YYSYMBOL_YOP_OR = 51,                    /* YOP_OR  */
  YYSYMBOL_YOP_AND = 52,                   /* YOP_AND  */
  YYSYMBOL_YOP_EQ = 53,                    /* YOP_EQ  */
  YYSYMBOL_YOP_NE = 54,                    /* YOP_NE  */
  YYSYMBOL_55_ = 55,                       /* '<'  */
  YYSYMBOL_56_ = 56,                       /* '>'  */
  YYSYMBOL_YOP_LE = 57,                    /* YOP_LE  */
  YYSYMBOL_YOP_GE = 58,                    /* YOP_GE  */
  YYSYMBOL_YOP_CONCAT = 59,                /* YOP_CONCAT  */
  YYSYMBOL_60_ = 60,                       /* '+'  */
  YYSYMBOL_61_ = 61,                       /* '-'  */
  YYSYMBOL_62_ = 62,                       /* '*'  */
  YYSYMBOL_63_ = 63,                       /* '/'  */
  YYSYMBOL_64_ = 64,                       /* '%'  */
  YYSYMBOL_YOP_NOT = 65,                   /* YOP_NOT  */
  YYSYMBOL_UMINUS = 66,                    /* UMINUS  */
  YYSYMBOL_YOP_POW = 67,                   /* YOP_POW  */
  YYSYMBOL_68_ = 68,                       /* '.'  */
  YYSYMBOL_69_ = 69,                       /* '~'  */
  YYSYMBOL_70_ = 70,                       /* '{'  */
  YYSYMBOL_71_ = 71,                       /* ';'  */
  YYSYMBOL_72_ = 72,                       /* '}'  */
  YYSYMBOL_73_ = 73,                       /* '['  */
  YYSYMBOL_74_ = 74,                       /* ']'  */
  YYSYMBOL_75_ = 75,                       /* ':'  */
  YYSYMBOL_76_ = 76,                       /* '|'  */
  YYSYMBOL_77_ = 77,                       /* ','  */
  YYSYMBOL_78_ = 78,                       /* '('  */
  YYSYMBOL_79_ = 79,                       /* ')'  */
  YYSYMBOL_YYACCEPT = 80,                  /* $accept  */
  YYSYMBOL_block = 81,                     /* block  */
  YYSYMBOL_82_1 = 82,                      /* $@1  */
  YYSYMBOL_debug = 83,                     /* debug  */
  YYSYMBOL_84_2 = 84,                      /* $@2  */
  YYSYMBOL_D_XXX = 85,                     /* D_XXX  */
  YYSYMBOL_script_params = 86,             /* script_params  */
  YYSYMBOL_script_body = 87,               /* script_body  */
  YYSYMBOL_88_3 = 88,                      /* $@3  */
  YYSYMBOL_proc_stmt = 89,                 /* proc_stmt  */
  YYSYMBOL_90_4 = 90,                      /* $@4  */
  YYSYMBOL_bparam_list = 91,               /* bparam_list  */
  YYSYMBOL_param_list = 92,                /* param_list  */
  YYSYMBOL_xparam_list = 93,               /* xparam_list  */
  YYSYMBOL_var_decls = 94,                 /* var_decls  */
  YYSYMBOL_var_decl_block = 95,            /* var_decl_block  */
  YYSYMBOL_var_decl_line = 96,             /* var_decl_line  */
  YYSYMBOL_var_decl_stmt = 97,             /* var_decl_stmt  */
  YYSYMBOL_98_5 = 98,                      /* $@5  */
  YYSYMBOL_typedefs = 99,                  /* typedefs  */
  YYSYMBOL_var_decl_list = 100,            /* var_decl_list  */
  YYSYMBOL_var_decl_plus = 101,            /* var_decl_plus  */
  YYSYMBOL_var_decl = 102,                 /* var_decl  */
  YYSYMBOL_103_6 = 103,                    /* $@6  */
  YYSYMBOL_var_def = 104,                  /* var_def  */
  YYSYMBOL_105_7 = 105,                    /* $@7  */
  YYSYMBOL_var_name = 106,                 /* var_name  */
  YYSYMBOL_init_index_list = 107,          /* init_index_list  */
  YYSYMBOL_init_index_range = 108,         /* init_index_range  */
  YYSYMBOL_init_list = 109,                /* init_list  */
  YYSYMBOL_init_elem = 110,                /* init_elem  */
  YYSYMBOL_const = 111,                    /* const  */
  YYSYMBOL_number = 112,                   /* number  */
  YYSYMBOL_sign = 113,                     /* sign  */
  YYSYMBOL_options_list = 114,             /* options_list  */
  YYSYMBOL_options = 115,                  /* options  */
  YYSYMBOL_option = 116,                   /* option  */
  YYSYMBOL_begin_stmt = 117,               /* begin_stmt  */
  YYSYMBOL_expr = 118,                     /* expr  */
  YYSYMBOL_expr0 = 119,                    /* expr0  */
  YYSYMBOL_expr1 = 120,                    /* expr1  */
  YYSYMBOL_121_8 = 121,                    /* $@8  */
  YYSYMBOL_122_9 = 122,                    /* $@9  */
  YYSYMBOL_123_10 = 123,                   /* $@10  */
  YYSYMBOL_124_11 = 124,                   /* $@11  */
  YYSYMBOL_125_12 = 125,                   /* $@12  */
  YYSYMBOL_intrinsx = 126,                 /* intrinsx  */
  YYSYMBOL_scanfmt = 127,                  /* scanfmt  */
  YYSYMBOL_scanarg = 128,                  /* scanarg  */
  YYSYMBOL_intrarg = 129,                  /* intrarg  */
  YYSYMBOL_stmt = 130,                     /* stmt  */
  YYSYMBOL_c_stmt = 131,                   /* c_stmt  */
  YYSYMBOL_c_blk = 132,                    /* c_blk  */
  YYSYMBOL_133_13 = 133,                   /* $@13  */
  YYSYMBOL_134_14 = 134,                   /* $@14  */
  YYSYMBOL_s_list = 135,                   /* s_list  */
  YYSYMBOL_assign = 136,                   /* assign  */
  YYSYMBOL_137_15 = 137,                   /* $@15  */
  YYSYMBOL_equals = 138,                   /* equals  */
  YYSYMBOL_assign_oper = 139,              /* assign_oper  */
  YYSYMBOL_cmdlist = 140,                  /* cmdlist  */
  YYSYMBOL_141_16 = 141,                   /* $@16  */
  YYSYMBOL_cmdpipe = 142,                  /* cmdpipe  */
  YYSYMBOL_143_17 = 143,                   /* $@17  */
  YYSYMBOL_pipe = 144,                     /* pipe  */
  YYSYMBOL_command = 145,                  /* command  */
  YYSYMBOL_146_18 = 146,                   /* $@18  */
  YYSYMBOL_147_19 = 147,                   /* $@19  */
  YYSYMBOL_args = 148,                     /* args  */
  YYSYMBOL_149_20 = 149,                   /* $@20  */
  YYSYMBOL_arglist = 150,                  /* arglist  */
  YYSYMBOL_arg = 151,                      /* arg  */
  YYSYMBOL_file = 152,                     /* file  */
  YYSYMBOL_immed = 153,                    /* immed  */
  YYSYMBOL_inspect = 154,                  /* inspect  */
  YYSYMBOL_osesc = 155,                    /* osesc  */
  YYSYMBOL_popstk = 156,                   /* popstk  */
  YYSYMBOL_iferr = 157,                    /* iferr  */
  YYSYMBOL_iferr_stat = 158,               /* iferr_stat  */
  YYSYMBOL_159_21 = 159,                   /* $@21  */
  YYSYMBOL_160_22 = 160,                   /* $@22  */
  YYSYMBOL_iferr_else = 161,               /* iferr_else  */
  YYSYMBOL_162_23 = 162,                   /* $@23  */
  YYSYMBOL_iferr_tok = 163,                /* iferr_tok  */
  YYSYMBOL_op_then = 164,                  /* op_then  */
  YYSYMBOL_if = 165,                       /* if  */
  YYSYMBOL_if_stat = 166,                  /* if_stat  */
  YYSYMBOL_167_24 = 167,                   /* $@24  */
  YYSYMBOL_ifelse = 168,                   /* ifelse  */
  YYSYMBOL_169_25 = 169,                   /* $@25  */
  YYSYMBOL_while = 170,                    /* while  */
  YYSYMBOL_171_26 = 171,                   /* $@26  */
  YYSYMBOL_172_27 = 172,                   /* $@27  */
  YYSYMBOL_for = 173,                      /* for  */
  YYSYMBOL_174_28 = 174,                   /* $@28  */
  YYSYMBOL_175_29 = 175,                   /* $@29  */
  YYSYMBOL_176_30 = 176,                   /* $@30  */
  YYSYMBOL_xassign = 177,                  /* xassign  */
  YYSYMBOL_xexpr = 178,                    /* xexpr  */
  YYSYMBOL_switch = 179,                   /* switch  */
  YYSYMBOL_180_31 = 180,                   /* $@31  */
  YYSYMBOL_case = 181,                     /* case  */
  YYSYMBOL_182_32 = 182,                   /* $@32  */
  YYSYMBOL_183_33 = 183,                   /* $@33  */
  YYSYMBOL_default = 184,                  /* default  */
  YYSYMBOL_185_34 = 185,                   /* $@34  */
  YYSYMBOL_next = 186,                     /* next  */
  YYSYMBOL_break = 187,                    /* break  */
  YYSYMBOL_return = 188,                   /* return  */
  YYSYMBOL_end_stmt = 189,                 /* end_stmt  */
  YYSYMBOL_label_stmt = 190,               /* label_stmt  */
  YYSYMBOL_191_35 = 191,                   /* $@35  */
  YYSYMBOL_goto = 192,                     /* goto  */
  YYSYMBOL_nullstmt = 193,                 /* nullstmt  */
  YYSYMBOL_xstmt = 194,                    /* xstmt  */
  YYSYMBOL_195_36 = 195,                   /* $@36  */
  YYSYMBOL_const_expr_list = 196,          /* const_expr_list  */
  YYSYMBOL_const_expr = 197,               /* const_expr  */
  YYSYMBOL_opnl = 198,                     /* opnl  */
  YYSYMBOL_ref = 199,                      /* ref  */
  YYSYMBOL_200_37 = 200,                   /* $@37  */
  YYSYMBOL_index_list = 201,               /* index_list  */
  YYSYMBOL_202_38 = 202,                   /* $@38  */
  YYSYMBOL_index = 203,                    /* index  */
  YYSYMBOL_intrins = 204,                  /* intrins  */
  YYSYMBOL_param = 205,                    /* param  */
  YYSYMBOL_tasknam = 206,                  /* tasknam  */
  YYSYMBOL_EOST = 207,                     /* EOST  */
  YYSYMBOL_DELIM = 208,                    /* DELIM  */
  YYSYMBOL_BARG = 209,                     /* BARG  */
  YYSYMBOL_EARG = 210,                     /* EARG  */
  YYSYMBOL_LP = 211,                       /* LP  */
  YYSYMBOL_RP = 212,                       /* RP  */
  YYSYMBOL_NL = 213                        /* NL  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   984

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  80
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  134
/* YYNRULES -- Number of rules.  */
#define YYNRULES  272
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  444

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   314


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    64,     2,     2,
      78,    79,    62,    60,    77,    61,    68,    63,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    75,    71,
      55,    45,    56,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    73,     2,    74,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    70,    76,    72,    69,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    57,
      58,    59,    65,    66,    67
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   143,   143,   168,   180,   180,   200,   211,   223,   264,
     265,   265,   275,   278,   287,   292,   302,   302,   328,   328,
     351,   354,   360,   363,   366,   371,   378,   379,   382,   383,
     386,   387,   388,   425,   425,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   474,   475,   478,   496,   514,
     518,   518,   526,   531,   531,   550,   554,   565,   569,   570,
     574,   597,   614,   615,   618,   626,   647,   648,   654,   668,
     669,   671,   681,   689,   692,   693,   696,   703,   711,   712,
     725,   726,   730,   738,   742,   746,   752,   754,   758,   762,
     766,   770,   774,   783,   787,   791,   795,   799,   803,   807,
     811,   815,   819,   823,   828,   828,   841,   841,   858,   858,
     872,   872,   893,   893,   910,   911,   919,   925,   932,   938,
     944,   952,   955,   959,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     984,   985,   986,   987,   988,   989,   995,   996,   999,  1001,
     999,  1006,  1007,  1013,  1018,  1029,  1029,  1041,  1046,  1047,
    1048,  1049,  1050,  1053,  1053,  1064,  1065,  1065,  1110,  1113,
    1118,  1142,  1118,  1151,  1151,  1162,  1165,  1166,  1170,  1180,
    1188,  1234,  1239,  1251,  1256,  1261,  1265,  1270,  1275,  1280,
    1285,  1291,  1296,  1307,  1312,  1319,  1326,  1332,  1342,  1352,
    1360,  1352,  1377,  1377,  1397,  1398,  1401,  1402,  1409,  1420,
    1420,  1453,  1453,  1476,  1483,  1476,  1521,  1525,  1541,  1521,
    1570,  1571,  1574,  1577,  1603,  1602,  1620,  1628,  1620,  1647,
    1647,  1665,  1680,  1704,  1708,  1720,  1732,  1732,  1766,  1788,
    1789,  1796,  1796,  1842,  1843,  1904,  1905,  1908,  1924,  1925,
    1928,  1965,  1965,  1980,  1983,  1983,  1989,  1993,  2000,  2021,
    2055,  2060,  2065,  2070,  2071,  2079,  2082,  2083,  2086,  2087,
    2093,  2096,  2099
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Y_SCAN", "Y_SCANF",
  "Y_FSCAN", "Y_FSCANF", "Y_OSESC", "Y_APPEND", "Y_ALLAPPEND",
  "Y_ALLREDIR", "Y_GSREDIR", "Y_ALLPIPE", "D_D", "D_PEEK", "Y_NEWLINE",
  "Y_CONSTANT", "Y_IDENT", "Y_WHILE", "Y_IF", "Y_ELSE", "Y_FOR", "Y_BREAK",
  "Y_NEXT", "Y_SWITCH", "Y_CASE", "Y_DEFAULT", "Y_RETURN", "Y_GOTO",
  "Y_PROCEDURE", "Y_BEGIN", "Y_END", "Y_BOOL", "Y_INT", "Y_REAL",
  "Y_STRING", "Y_FILE", "Y_STRUCT", "Y_GCUR", "Y_IMCUR", "Y_UKEY",
  "Y_PSET", "Y_IFERR", "Y_IFNOERR", "Y_THEN", "'='", "YOP_AOADD",
  "YOP_AOSUB", "YOP_AOMUL", "YOP_AODIV", "YOP_AOCAT", "YOP_OR", "YOP_AND",
  "YOP_EQ", "YOP_NE", "'<'", "'>'", "YOP_LE", "YOP_GE", "YOP_CONCAT",
  "'+'", "'-'", "'*'", "'/'", "'%'", "YOP_NOT", "UMINUS", "YOP_POW", "'.'",
  "'~'", "'{'", "';'", "'}'", "'['", "']'", "':'", "'|'", "','", "'('",
  "')'", "$accept", "block", "$@1", "debug", "$@2", "D_XXX",
  "script_params", "script_body", "$@3", "proc_stmt", "$@4", "bparam_list",
  "param_list", "xparam_list", "var_decls", "var_decl_block",
  "var_decl_line", "var_decl_stmt", "$@5", "typedefs", "var_decl_list",
  "var_decl_plus", "var_decl", "$@6", "var_def", "$@7", "var_name",
  "init_index_list", "init_index_range", "init_list", "init_elem", "const",
  "number", "sign", "options_list", "options", "option", "begin_stmt",
  "expr", "expr0", "expr1", "$@8", "$@9", "$@10", "$@11", "$@12",
  "intrinsx", "scanfmt", "scanarg", "intrarg", "stmt", "c_stmt", "c_blk",
  "$@13", "$@14", "s_list", "assign", "$@15", "equals", "assign_oper",
  "cmdlist", "$@16", "cmdpipe", "$@17", "pipe", "command", "$@18", "$@19",
  "args", "$@20", "arglist", "arg", "file", "immed", "inspect", "osesc",
  "popstk", "iferr", "iferr_stat", "$@21", "$@22", "iferr_else", "$@23",
  "iferr_tok", "op_then", "if", "if_stat", "$@24", "ifelse", "$@25",
  "while", "$@26", "$@27", "for", "$@28", "$@29", "$@30", "xassign",
  "xexpr", "switch", "$@31", "case", "$@32", "$@33", "default", "$@34",
  "next", "break", "return", "end_stmt", "label_stmt", "$@35", "goto",
  "nullstmt", "xstmt", "$@36", "const_expr_list", "const_expr", "opnl",
  "ref", "$@37", "index_list", "$@38", "index", "intrins", "param",
  "tasknam", "EOST", "DELIM", "BARG", "EARG", "LP", "RP", "NL", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-256)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-262)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     576,    -8,  -256,    -8,    -8,    18,  -256,  -256,   785,  -256,
    -256,  -256,     6,  -256,  -256,  -256,    13,    -8,  -256,  -256,
    -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,   -17,
     801,  -256,  -256,  -256,  -256,  -256,  -256,  -256,   -54,  -256,
       3,  -256,   742,    21,  -256,  -256,  -256,    86,    -8,  -256,
      21,     6,  -256,    -8,  -256,  -256,   836,  -256,     6,    21,
     -49,   -11,    38,    24,  -256,   687,  -256,  -256,    12,   -49,
    -256,  -256,  -256,   236,   -54,   -54,   -54,  -256,  -256,    -8,
    -256,    31,   513,    91,  -256,  -256,  -256,  -256,    -8,  -256,
    -256,    -8,    21,   513,    21,  -256,    21,    21,    21,    21,
    -256,    95,  -256,  -256,  -256,    96,  -256,  -256,  -256,  -256,
    -256,  -256,    21,    21,    21,  -256,    21,  -256,    81,    59,
    -256,    13,  -256,  -256,  -256,    86,     0,  -256,    61,    -8,
    -256,  -256,  -256,  -256,     6,    -8,  -256,   513,    -8,   -54,
       4,    -8,   -54,   -54,   -54,   -54,  -256,    66,  -256,  -256,
    -256,  -256,  -256,  -256,   513,   513,   886,  -256,  -256,   -54,
    -256,  -256,   513,  -256,  -256,  -256,  -256,  -256,   886,    27,
      28,  -256,  -256,  -256,  -256,  -256,  -256,  -256,    68,  -256,
    -256,  -256,  -256,  -256,   220,   513,    64,   -54,  -256,  -256,
     -54,   100,  -256,  -256,   -49,  -256,  -256,  -256,   135,   107,
     -49,  -256,    79,     4,  -256,  -256,  -256,   513,   857,     6,
      -8,  -256,  -256,   110,   -49,  -256,  -256,  -256,  -256,   170,
     121,   121,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,  -256,   857,    -8,
       2,    -8,  -256,    -8,  -256,  -256,  -256,  -256,  -256,   513,
      -3,    10,   408,  -256,  -256,     4,     4,     0,  -256,   117,
     173,   -49,   -44,  -256,   120,   742,   857,  -256,  -256,   128,
      81,   513,    -8,     4,   742,   183,   513,   183,   -49,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   513,   513,   513,   513,  -256,   631,    -8,    -8,  -256,
     742,   157,   742,   886,   -40,  -256,   -30,    40,   130,   138,
      46,    12,  -256,  -256,   -49,  -256,  -256,    79,  -256,     4,
       4,  -256,  -256,    -8,    -8,   513,   831,  -256,  -256,  -256,
     -49,    12,   886,   -49,    12,  -256,   902,   917,   481,   481,
     391,   391,   391,   391,   160,    90,    90,   121,   121,   121,
    -256,   886,   -39,   146,  -256,  -256,   190,  -256,  -256,    -8,
    -256,  -256,   -49,   513,   513,   513,   513,   513,   513,    33,
      12,   -49,  -256,    -4,    60,  -256,  -256,  -256,  -256,    -8,
     742,  -256,    12,   742,   183,  -256,   183,  -256,   513,   513,
    -256,  -256,  -256,  -256,   742,   408,   115,  -256,    17,  -256,
    -256,  -256,  -256,  -256,  -256,  -256,   494,   513,  -256,  -256,
     494,   742,  -256,   513,    -8,  -256,  -256,    12,   -49,   886,
    -256,  -256,  -256,   169,   201,   -49,  -256,   886,   154,  -256,
    -256,   183,    -8,   742,    12,  -256,  -256,  -256,     6,    12,
      -8,  -256,   836,  -256
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,    18,     0,     0,     4,     6,     7,     0,    16,
     272,     8,     0,    77,     3,     1,     9,     0,    35,    43,
      37,    36,    38,    44,    39,    40,    41,    42,   264,     0,
       0,    28,    31,    33,    30,   263,   151,   261,    20,    12,
       0,    14,     0,     0,    32,    15,    29,     0,   248,   270,
       0,    22,    13,     0,   243,     5,     0,    10,     0,     0,
      45,    47,    49,    52,    55,     0,   249,    19,     0,    23,
      24,   244,   196,   262,     0,     0,     0,   232,   231,   248,
     226,     0,   233,     0,   204,   205,   157,   148,   239,   242,
     124,   146,     0,   197,     0,   163,     0,     0,     0,     0,
     133,   198,   134,   199,   131,   208,   132,   135,   136,   137,
     138,   139,     0,     0,     0,   144,     0,   145,   155,   250,
     170,     9,    56,    34,   265,     0,     0,    50,     0,     0,
      17,   152,   271,    21,     0,   248,   213,     0,   248,     0,
       0,   248,     0,     0,     0,     0,    81,   261,   115,   116,
      82,    83,    84,    85,     0,     0,   234,    78,    80,     0,
      79,   114,     0,   238,   151,   240,   147,   125,     0,    78,
      79,   126,   165,   127,   128,   129,   130,   202,     0,   211,
     140,   141,   143,   142,     0,   195,     0,   266,    11,    46,
      66,     0,    69,    70,    72,    62,    64,    67,     0,     0,
      73,    74,     0,    57,   235,    25,   236,     0,     0,   221,
     248,    66,   247,     0,   245,   229,   104,   106,   108,     0,
     103,   102,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   112,     0,   248,
     164,   248,   200,   248,   158,   159,   160,   161,   162,     0,
      78,    79,     0,   171,   267,     0,     0,     0,    68,     0,
       0,    51,     0,    58,    60,     0,     0,   209,   220,     0,
     155,     0,   248,     0,     0,   118,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   121,    86,     0,   248,   248,   166,
       0,   206,     0,   156,    81,   258,    80,    79,     0,   253,
     178,     0,    76,    63,    71,    48,    75,     0,    54,     0,
       0,   237,   214,   248,   248,     0,   248,   227,   246,   230,
     119,     0,   117,     0,     0,   110,   100,   101,    98,    99,
      94,    95,    96,    97,    93,    87,    88,    89,    90,    92,
      91,   122,     0,     0,   169,   168,     0,   203,   207,   248,
     212,   252,     0,     0,     0,     0,     0,     0,     0,    78,
     268,   175,   176,    79,   250,   173,    65,    59,    61,   248,
       0,   216,     0,     0,   118,   105,   118,   109,     0,     0,
     113,   150,   262,   167,     0,     0,    78,   188,   250,   189,
     187,   190,   185,   186,   172,   269,   178,     0,   183,   184,
     178,     0,   210,   223,   248,   228,   120,     0,     0,   123,
     201,   255,   177,    78,    79,   174,   215,   222,     0,   224,
     107,   118,   248,     0,     0,   217,   225,   111,   221,     0,
     248,   218,     0,   219
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -256,  -256,  -256,   108,  -256,  -256,  -256,  -256,  -256,  -256,
    -256,  -256,  -256,  -256,  -256,  -256,   200,    23,  -256,  -256,
     111,  -256,  -256,  -256,  -256,  -256,  -256,  -256,   -84,    36,
    -248,  -137,  -256,  -256,  -256,   -16,   -18,   214,    43,    54,
    -246,  -256,  -256,  -256,  -256,  -256,  -256,  -141,  -255,  -256,
    -193,  -256,    74,  -256,  -256,    89,  -207,  -256,  -114,  -256,
    -256,  -256,  -256,  -256,  -256,  -101,  -256,  -256,  -256,  -256,
    -154,  -148,   -60,  -256,  -256,  -256,  -256,  -256,  -256,  -256,
    -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,
    -256,  -256,  -256,  -256,  -256,  -256,  -256,  -177,  -256,  -256,
    -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,  -256,
    -256,  -256,  -256,  -256,   -37,  -256,    -9,  -256,   -64,   -35,
    -256,  -122,  -256,  -256,  -256,   -12,  -256,   472,   -59,  -256,
    -256,    67,  -138,   380
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     5,    16,    42,   121,    43,     6,     7,    36,     8,
      12,    50,    68,    69,    29,    30,    31,    54,    47,    33,
      59,    60,    61,   202,    62,   128,    63,   262,   263,   194,
     195,   196,   197,   198,   199,   200,   201,     9,   168,   157,
     158,   275,   276,   277,   388,   294,   159,   333,   331,   352,
      89,    90,    91,   164,   353,    48,    92,   184,    93,   249,
      94,   172,   240,   356,   299,    95,   187,   310,   370,   410,
     371,   372,   397,    96,    97,    98,    99,   100,   101,   178,
     301,   102,   241,   103,   359,   104,   105,   323,   106,   243,
     107,   207,   379,   108,   413,   438,   442,   269,   428,   109,
     433,   110,   140,   383,   111,   274,   112,   113,   114,   130,
     115,   265,   116,   117,   131,    56,   213,   214,    65,   160,
     186,   308,   362,   309,   161,   119,   120,    34,   260,   253,
     404,   162,   133,    66
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      38,   125,   268,   212,   185,    55,   306,    10,  -180,   313,
     134,  -180,  -153,     3,   297,   139,   190,   191,    15,    52,
     211,   118,   334,    37,    49,  -154,    39,    40,   124,  -192,
     318,    32,  -192,   124,  -259,    64,    10,  -259,   124,    70,
     132,   407,  -193,  -194,  -256,  -179,   122,  -256,  -179,   142,
     143,   144,   145,    32,   363,   364,   365,   366,   170,   126,
     192,   193,   146,   147,   192,   193,   264,  -180,  -153,   313,
     267,   206,  -180,  -180,   209,  -180,  -153,   215,   298,   148,
     149,  -154,    41,   127,   150,   151,   152,   153,  -192,  -154,
    -251,   132,    28,  -192,  -192,   190,  -192,   -53,  -193,  -194,
     295,   367,   368,    37,  -179,    51,   141,   154,   163,  -179,
    -179,   155,  -179,    64,  -257,   177,   179,  -257,   311,   312,
     408,   409,   205,   124,    49,   156,    86,  -191,   322,   416,
    -191,   417,  -251,  -251,   203,   257,   212,   252,    87,   192,
     193,   136,   137,   138,  -260,   256,   271,   169,    58,   306,
     251,   258,   233,   234,   235,   273,   325,   236,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   376,   270,   296,   434,   300,   259,   302,
     208,  -181,   264,   378,  -181,   272,  -191,   278,   236,   315,
     191,  -191,  -191,   385,  -191,   320,   387,   220,   221,   324,
     330,   358,   317,   319,   361,   238,   210,   392,   327,   216,
     217,   218,   219,  -182,   390,  -254,  -182,   307,   391,   335,
     231,   232,   233,   234,   235,   432,   237,   236,   321,   188,
      46,   268,   405,   354,   355,   377,   189,   329,   261,   250,
    -181,   314,   316,    45,   414,  -181,  -181,   418,  -181,   443,
     266,   375,   242,   239,   254,   393,   425,   255,   422,   380,
     381,   439,   382,   357,   328,   360,   244,   245,   246,   247,
     248,   384,  -182,   421,   386,   373,     0,  -182,  -182,   430,
    -182,  -261,  -261,  -261,  -261,  -261,  -261,     0,     0,     0,
     251,     0,   303,   389,     0,   394,   437,     0,   374,     0,
       0,   440,     0,   395,   399,   400,   401,   402,   403,  -261,
       0,   135,   406,     0,   326,   411,     0,     0,     0,   332,
       0,     0,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,     0,
       0,     0,     0,   412,     0,     0,   415,     0,     0,     0,
     429,   398,   398,   398,   398,   398,   398,   420,     0,   431,
     307,     0,     0,     0,   369,     0,   406,     0,   435,     0,
       0,   373,   424,     0,   426,   373,   441,     0,     0,   250,
       0,    11,     0,    13,    14,     0,     0,     0,    35,     0,
       0,     0,     0,     0,   374,     0,   436,    44,   374,     0,
       0,     0,     0,   270,     0,     0,     0,   118,     0,     0,
      35,   142,   143,   144,   145,     0,     0,   396,   396,   396,
     396,   396,   396,    35,   304,   147,     0,     0,     0,     0,
      35,   332,   419,    71,     0,     0,     0,     0,     0,    35,
       0,   148,   149,     0,     0,     0,   150,   151,   152,   153,
     230,   231,   232,   233,   234,   235,   427,     0,   236,     0,
     369,   423,     0,     0,   369,     0,     0,     0,   165,   154,
     305,   166,    35,   155,    35,     0,    35,    35,    35,    35,
       0,     0,     0,     0,     0,     0,    49,     0,     0,     0,
       0,     0,    35,    35,    35,     0,    35,   142,   143,   144,
     145,     0,   363,   364,   365,   366,     0,     0,     0,   204,
     146,   147,     0,     0,     0,    57,   142,   143,   144,   145,
       0,     0,    67,     0,     0,     0,     0,   148,   149,   146,
     147,   123,   150,   151,   152,   153,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   148,   149,   236,   367,
     368,   150,   151,   152,   153,   154,     0,     0,     0,   155,
       0,     0,     0,     0,   167,     0,   171,     0,   173,   174,
     175,   176,    49,     0,   154,     0,    -2,     1,   155,     0,
       0,     0,     0,    -2,   180,   181,   182,     0,   183,    -2,
      -2,    49,     0,    -2,    -2,    -2,     0,    -2,    -2,    -2,
      -2,    -2,    -2,    -2,    -2,     2,     3,     0,    -2,    -2,
      -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,
       0,    -2,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,     0,     0,     0,  -241,     0,
       0,     0,     0,     0,     4,    -2,    -2,    -2,  -241,  -241,
    -241,     0,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
       0,     0,     0,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,  -241,  -241,     0,  -241,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,     0,     0,     0,  -241,     0,     0,     0,     0,     0,
       0,  -241,  -241,  -149,  -241,  -241,  -241,     0,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,     0,     0,   129,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,  -241,
    -241,     0,  -241,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,     0,     0,     0,  -241,
       0,     0,     0,     0,     0,     0,     0,  -241,  -241,  -241,
    -241,  -241,     0,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,     0,     0,     0,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,  -241,  -241,    17,  -241,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      10,     0,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -241,  -241,     0,   -26,    10,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,     0,     0,     0,
       0,   -27,     0,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    72,     0,     0,    10,     0,     0,     0,
       0,     0,     0,    73,    74,    75,    28,    76,    77,    78,
      79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,     0,    84,    85,
       0,    86,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,     0,     0,   236,     0,
       0,     0,     0,     0,     0,     0,    87,    88,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,     0,     0,   236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   132,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,     0,     0,   236,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,     0,     0,   236,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,     0,     0,   236
};

static const yytype_int16 yycheck[] =
{
      12,    60,   209,   140,   118,    42,   252,    15,    12,   257,
      69,    15,    15,    30,    12,    79,    16,    17,     0,    16,
      16,    56,   277,    17,    78,    15,    13,    14,    77,    12,
      74,     8,    15,    77,    74,    47,    15,    77,    77,    51,
      79,    45,    15,    15,    74,    12,    58,    77,    15,     3,
       4,     5,     6,    30,     8,     9,    10,    11,    93,    70,
      60,    61,    16,    17,    60,    61,   203,    71,    71,   317,
     208,   135,    76,    77,   138,    79,    79,   141,    76,    33,
      34,    71,    69,    45,    38,    39,    40,    41,    71,    79,
      73,    79,    71,    76,    77,    16,    79,    73,    71,    71,
     238,    55,    56,    17,    71,    38,    75,    61,    17,    76,
      77,    65,    79,   125,    74,    20,    20,    77,   255,   256,
      60,    61,   134,    77,    78,    82,    45,    12,   266,   384,
      15,   386,    73,    73,    73,   194,   273,    73,    70,    60,
      61,    74,    75,    76,    78,    45,   210,    93,    62,   395,
     185,    16,    62,    63,    64,   214,   270,    67,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   311,   209,   239,   431,   241,    71,   243,
     137,    12,   319,   320,    15,    75,    71,    17,    67,    72,
      17,    76,    77,   331,    79,    75,   334,   154,   155,    71,
      17,    44,   261,   262,    74,   162,   139,    17,   272,   142,
     143,   144,   145,    12,   352,    77,    15,   252,    72,   278,
      60,    61,    62,    63,    64,    71,   159,    67,   265,   121,
      30,   438,   370,   297,   298,   319,   125,   274,   202,   185,
      71,   257,   260,    29,   382,    76,    77,   388,    79,   442,
     207,   310,   178,   164,   187,   356,   410,   190,   406,   323,
     324,   438,   326,   300,   273,   302,    46,    47,    48,    49,
      50,   330,    71,   395,   333,   310,    -1,    76,    77,   417,
      79,    45,    46,    47,    48,    49,    50,    -1,    -1,    -1,
     325,    -1,   249,   352,    -1,   359,   434,    -1,   310,    -1,
      -1,   439,    -1,   362,   364,   365,   366,   367,   368,    73,
      -1,    75,   371,    -1,   271,   379,    -1,    -1,    -1,   276,
      -1,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,    -1,    -1,
      -1,    -1,    -1,   380,    -1,    -1,   383,    -1,    -1,    -1,
     414,   363,   364,   365,   366,   367,   368,   394,    -1,   418,
     395,    -1,    -1,    -1,   310,    -1,   425,    -1,   432,    -1,
      -1,   406,   407,    -1,   411,   410,   440,    -1,    -1,   325,
      -1,     1,    -1,     3,     4,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,   406,    -1,   433,    17,   410,    -1,
      -1,    -1,    -1,   438,    -1,    -1,    -1,   442,    -1,    -1,
      30,     3,     4,     5,     6,    -1,    -1,   363,   364,   365,
     366,   367,   368,    43,    16,    17,    -1,    -1,    -1,    -1,
      50,   388,   389,    53,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    33,    34,    -1,    -1,    -1,    38,    39,    40,    41,
      59,    60,    61,    62,    63,    64,   413,    -1,    67,    -1,
     406,   407,    -1,    -1,   410,    -1,    -1,    -1,    88,    61,
      62,    91,    92,    65,    94,    -1,    96,    97,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,   112,   113,   114,    -1,   116,     3,     4,     5,
       6,    -1,     8,     9,    10,    11,    -1,    -1,    -1,   129,
      16,    17,    -1,    -1,    -1,    43,     3,     4,     5,     6,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    33,    34,    16,
      17,    59,    38,    39,    40,    41,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    33,    34,    67,    55,
      56,    38,    39,    40,    41,    61,    -1,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    92,    -1,    94,    -1,    96,    97,
      98,    99,    78,    -1,    61,    -1,     0,     1,    65,    -1,
      -1,    -1,    -1,     7,   112,   113,   114,    -1,   116,    13,
      14,    78,    -1,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,     7,    -1,
      -1,    -1,    -1,    -1,    68,    69,    70,    71,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,     7,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    17,    18,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,     7,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,    17,
      18,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,     1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      15,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    71,    -1,    30,    15,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    -1,    -1,
      -1,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,     7,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    71,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    45,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    71,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    29,    30,    68,    81,    86,    87,    89,   117,
      15,   213,    90,   213,   213,     0,    82,     1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    71,    94,
      95,    96,    97,    99,   207,   213,    88,    17,   205,    13,
      14,    69,    83,    85,   213,   117,    96,    98,   135,    78,
      91,   211,    16,     1,    97,   194,   195,   207,    62,   100,
     101,   102,   104,   106,   205,   198,   213,   207,    92,    93,
     205,   213,     7,    17,    18,    19,    21,    22,    23,    24,
      25,    26,    27,    28,    42,    43,    45,    70,    71,   130,
     131,   132,   136,   138,   140,   145,   153,   154,   155,   156,
     157,   158,   161,   163,   165,   166,   168,   170,   173,   179,
     181,   184,   186,   187,   188,   190,   192,   193,   199,   205,
     206,    84,   205,   207,    77,   208,    70,    45,   105,    31,
     189,   194,    79,   212,   208,    75,   211,   211,   211,   198,
     182,    75,     3,     4,     5,     6,    16,    17,    33,    34,
      38,    39,    40,    41,    61,    65,   118,   119,   120,   126,
     199,   204,   211,    17,   133,   213,   213,   207,   118,   119,
     199,   207,   141,   207,   207,   207,   207,    20,   159,    20,
     207,   207,   207,   207,   137,   138,   200,   146,    83,   100,
      16,    17,    60,    61,   109,   110,   111,   112,   113,   114,
     115,   116,   103,    73,   213,   205,   198,   171,   118,   198,
     211,    16,   111,   196,   197,   198,   211,   211,   211,   211,
     118,   118,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    67,   211,   118,   135,
     142,   162,   132,   169,    46,    47,    48,    49,    50,   139,
     119,   199,    73,   209,   211,   211,    45,   208,    16,    71,
     208,   109,   107,   108,   111,   191,   118,   212,   136,   177,
     199,   198,    75,   208,   185,   121,   122,   123,    17,   198,
     198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   198,   198,   125,   212,   198,    12,    76,   144,
     198,   160,   198,   118,    16,    62,   120,   199,   201,   203,
     147,   111,   111,   110,   115,    72,   116,   208,    74,   208,
      75,   194,   212,   167,    71,   138,   118,   198,   196,   194,
      17,   128,   118,   127,   128,   208,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   129,   134,   198,   198,   143,   194,    44,   164,
     194,    74,   202,     8,     9,    10,    11,    55,    56,   119,
     148,   150,   151,   199,   205,   208,   212,   108,   111,   172,
     198,   198,   198,   183,   208,   212,   208,   212,   124,   208,
     212,    72,    17,   145,   198,   208,   119,   152,   205,   152,
     152,   152,   152,   152,   210,   212,   208,    45,    60,    61,
     149,   198,   194,   174,   212,   194,   128,   128,   127,   118,
     194,   201,   151,   119,   199,   150,   194,   118,   178,   198,
     212,   208,    71,   180,   128,   198,   194,   212,   175,   177,
     212,   198,   176,   130
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    80,    81,    81,    82,    81,    81,    81,    81,    83,
      84,    83,    85,    85,    85,    86,    88,    87,    90,    89,
      91,    91,    92,    92,    93,    93,    94,    94,    95,    95,
      96,    96,    96,    98,    97,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,   100,   100,   101,   101,   102,
     103,   102,   104,   105,   104,   106,   106,   107,   107,   107,
     108,   108,   109,   109,   110,   110,   111,   111,   112,   113,
     113,   114,   114,   114,   115,   115,   116,   117,   118,   118,
     119,   119,   119,   119,   119,   119,   120,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   120,   120,   120,   120,
     120,   120,   120,   120,   121,   120,   122,   120,   123,   120,
     124,   120,   125,   120,   126,   126,   126,   127,   128,   128,
     128,   129,   129,   129,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   131,   131,   133,   134,
     132,   135,   135,   136,   136,   137,   136,   138,   139,   139,
     139,   139,   139,   141,   140,   142,   143,   142,   144,   144,
     146,   147,   145,   149,   148,   148,   150,   150,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   152,   152,   153,   153,   154,   155,   156,   157,   159,
     160,   158,   162,   161,   163,   163,   164,   164,   165,   167,
     166,   169,   168,   171,   172,   170,   174,   175,   176,   173,
     177,   177,   178,   178,   180,   179,   182,   183,   181,   185,
     184,   186,   187,   188,   188,   189,   191,   190,   192,   193,
     193,   195,   194,   194,   194,   196,   196,   197,   198,   198,
     199,   200,   199,   201,   202,   201,   203,   203,   203,   203,
     204,   205,   206,   207,   207,   208,   209,   209,   210,   210,
     211,   212,   213
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     0,     4,     1,     1,     2,     0,
       0,     4,     1,     2,     1,     3,     0,     5,     0,     5,
       0,     3,     0,     1,     1,     3,     0,     1,     1,     2,
       1,     1,     2,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     5,     1,
       0,     4,     1,     0,     5,     1,     2,     0,     1,     3,
       1,     3,     1,     3,     1,     4,     1,     1,     2,     1,
       1,     3,     1,     1,     1,     3,     3,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     2,     2,     0,     5,     0,     7,     0,     5,
       0,     9,     0,     5,     1,     1,     1,     1,     0,     1,
       3,     0,     1,     3,     1,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     1,     2,     0,     0,
       6,     0,     3,     3,     3,     0,     4,     1,     1,     1,
       1,     1,     1,     0,     3,     0,     0,     4,     2,     2,
       0,     0,     6,     0,     3,     1,     1,     3,     0,     1,
       1,     3,     3,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     2,     2,     2,     1,     1,     1,     0,
       0,     7,     0,     5,     1,     1,     0,     1,     1,     0,
       7,     0,     5,     0,     0,     8,     0,     0,     0,    16,
       1,     0,     1,     0,     0,    10,     0,     0,     7,     0,
       5,     1,     1,     1,     2,     2,     0,     5,     2,     1,
       2,     0,     2,     1,     2,     1,     3,     1,     0,     1,
       1,     0,     5,     1,     0,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* block: %empty  */
#line 143 "grammar.y"
                            {
		    /* Done once on entry but after at least one call to
		     * yylex().  Good for initing parser flags.
		     * Note: this does not get called in procedure scripts.
		     */
		    if (cldebug)
			eprintf ("parse init (block)...\n");

		    errcnt     = 0;
		    err_cmdblk = 0;
		    dobkg      = 0;
		    inarglist  = 0;
		    parenlevel = 0;
		    bracelevel = 0;
		    tbrace     = 0;
		    dobrace    = 0;
		    in_iferr   = 0;
		    do_params  = YES;
		    last_parm  = NULL;
		    ifseen     = NULL;
		    label1     = NULL;
		    errmsg     = NULL;
		    parse_pfile= currentask->t_pfp;
		}
#line 2023 "y.tab.c"
    break;

  case 3: /* block: '.' NL  */
#line 168 "grammar.y"
                       {
		    /* Prepare to rerun whatever was compiled last.
		     * Does not work for the debug commands builtin here.
		     */
		    if (parse_state != PARSE_FREE) {
			errmsg = "Illegal parser state.";
			EYYERROR;
		    }
		    rerun();
		    YYACCEPT;
		}
#line 2039 "y.tab.c"
    break;

  case 4: /* $@1: %empty  */
#line 180 "grammar.y"
                      {
		    if (parse_state == PARSE_PARAMS) {
			errmsg = "Illegal parser state.";
			EYYERROR;
		    }
		}
#line 2050 "y.tab.c"
    break;

  case 5: /* block: block $@1 debug xstmt  */
#line 186 "grammar.y"
                            {
		    if (sawnl && bracelevel == 0) {
			if (!errcnt)
			    compile (END);
			if (ifseen) {
			    /* Simulate an unput of what has been read
			     * from the current line.
			     */
			    ip_cmdblk = ifseen;
			}
			YYACCEPT;
		    }
		}
#line 2068 "y.tab.c"
    break;

  case 6: /* block: script_params  */
#line 200 "grammar.y"
                              {
		    /* Parse the parameters in a script file.  This will
		     * normally be done on a call by pfileread().
		     */
		    if (parse_state != PARSE_PARAMS) {
			eprintf ("Illegal parser state.\n");
			errcnt++;
		    }
		    YYACCEPT;
		}
#line 2083 "y.tab.c"
    break;

  case 7: /* block: script_body  */
#line 211 "grammar.y"
                            {
		    /* Parse the executable statements in a script.
		     */
		    if (parse_state != PARSE_BODY) {
			eprintf ("Illegal parser state.\n");
			errcnt++;
		    }
		    if (!errcnt)
			compile (END);
		    YYACCEPT;
		}
#line 2099 "y.tab.c"
    break;

  case 8: /* block: error NL  */
#line 223 "grammar.y"
                         {
		    /* This catches errors that the two other error lines
		     * can't get, e.g. a missing `}' at the end of a script, 
		     * or errors occuring in interactive input.
		     */
		    yyerrok;

		    /* Discard everything and compile a null statement.
		     */
		    if (!errcnt) {
			do_params = YES;
			pc = currentask->t_bascode;
			if (parse_state != PARSE_PARAMS)
			    compile (END);

			topd = currentask->t_topd;
			topcs = currentask->t_topcs;

			/* Unlink any added parms.  Resetting of topd will
			 * already have reclaimed space.
			 */
			if (last_parm) {
			    last_parm->p_np = NULL;
			    currentask->t_pfp->pf_lastpp = last_parm;
			    last_parm = NULL;
			}
	 	    }

		    /* Print cmdblk and show position of error.
		     */
		    p_position();
		    if (currentask->t_flags & T_SCRIPT) 
			cl_error (E_UERR, "syntax error, line %d",
			    currentask->t_scriptln);
		    else
			cl_error (E_UERR, "syntax error");

		    YYACCEPT;
		}
#line 2143 "y.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 265 "grammar.y"
                           {
		    /* debug are those debugging functions that
		     * should be run directly and not through a
		     * builtin task due to stack or other changes,
		     * ie, don't change what we are trying to show.
		     */
		    printf ("\n");
		}
#line 2156 "y.tab.c"
    break;

  case 12: /* D_XXX: D_D  */
#line 275 "grammar.y"
                    {
		    d_d(); /* show dictionary/stack pointers */
		}
#line 2164 "y.tab.c"
    break;

  case 13: /* D_XXX: D_PEEK Y_CONSTANT  */
#line 278 "grammar.y"
                                  { /* show a dictionary location	*/
		    if (stkop(yyvsp[0])->o_type & OT_INT) {
			int	idx;
			idx = stkop(yyvsp[0])->o_val.v_i;
			eprintf ("%d:\t%d (0%o)\n", idx, stack[idx],
				stack[idx]);
		    } else
			eprintf ("usage: D_PEEK <d. index>\n");
		}
#line 2178 "y.tab.c"
    break;

  case 14: /* D_XXX: '~'  */
#line 287 "grammar.y"
                    {
		    d_stack (pc, 0, 0);		/* show compiled code	*/
		}
#line 2186 "y.tab.c"
    break;

  case 15: /* script_params: proc_stmt var_decls begin_stmt  */
#line 294 "grammar.y"
                           { 
			/* Check for required params.
			 */
			if (!errcnt)
			    proc_params(n_procpar);
		}
#line 2197 "y.tab.c"
    break;

  case 16: /* $@3: %empty  */
#line 302 "grammar.y"
                           {
			/* Initialize parser for procedure body.
			 */
			if (cldebug)
			    eprintf ("parse init (script_body)...\n");

			errcnt     = 0;
			err_cmdblk = 0;
			dobkg      = 0;
			inarglist  = 0;
			parenlevel = 0;
		        in_iferr   = 0;
			dobrace    = 0;
			bracelevel = PBRACE; /* disable lexmodes; force "end" */
			tbrace     = 0;
 			do_params  = NO;
			last_parm  = NULL;
			ifseen     = NULL;
			label1     = NULL;
			parse_pfile= currentask->t_pfp;
		}
#line 2223 "y.tab.c"
    break;

  case 18: /* $@4: %empty  */
#line 328 "grammar.y"
                            {  
			/* Initialize parser for procedure parameters.
			 */
			if (cldebug)
			    eprintf ("parse init (proc_stmt)...\n");

			errcnt     = 0;
			err_cmdblk = 0;
			dobkg      = 0;
			inarglist  = 0;
			parenlevel = 0;
			bracelevel = PBRACE;
			tbrace     = 0;
		        dobrace    = 0;
		        in_iferr   = 0;
			do_params  = YES;
		        last_parm  = NULL;
			label1     = NULL;
		}
#line 2247 "y.tab.c"
    break;

  case 20: /* bparam_list: %empty  */
#line 351 "grammar.y"
                {
		    n_procpar = 0;
		}
#line 2255 "y.tab.c"
    break;

  case 22: /* param_list: %empty  */
#line 360 "grammar.y"
                            {
		    n_procpar = 0;
		}
#line 2263 "y.tab.c"
    break;

  case 24: /* xparam_list: param  */
#line 366 "grammar.y"
                      { 
		    n_procpar = 1;
		    if (!errcnt)
			push (stkop(yyvsp[0]));
		}
#line 2273 "y.tab.c"
    break;

  case 25: /* xparam_list: xparam_list DELIM param  */
#line 371 "grammar.y"
                                        {
		    n_procpar++;
		    if (!errcnt)
			push (stkop(yyvsp[0]));
		}
#line 2283 "y.tab.c"
    break;

  case 32: /* var_decl_line: error NL  */
#line 388 "grammar.y"
                         {
		    /* This catches errors in the parameter declarations
		     * of a procedure script.
		     */
		    yyerrok;

		    /* Discard everything and compile a null statement.
		     */
		    if (!errcnt) {
			do_params = YES;
			pc = currentask->t_bascode;
			if (parse_state != PARSE_PARAMS)
			    compile (END);

			topd = currentask->t_topd;
			topcs = currentask->t_topcs;

			/* Unlink any added parms.  Resetting of topd will
			 * already have reclaimed space.
			 */
			if (last_parm) {
			    last_parm->p_np = NULL;
			    currentask->t_pfp->pf_lastpp = last_parm;
			    last_parm = NULL;
			}
	 	    }

		    /* Print cmdblk and show position of error.  We know
		     * we're parsing a procedure script, so print the line
		     * number too.
		     */
		    p_position();
		    cl_error (E_UERR, "syntax error, line %d", 
			currentask->t_scriptln);
		}
#line 2323 "y.tab.c"
    break;

  case 33: /* $@5: %empty  */
#line 425 "grammar.y"
                         {
	 	        /* For in-line definitions we don't want
			 * to freeze stuff on the dictionary, so
			 * only allow additions if the dictionary
			 * is the same as at the beginning of the task.
			 */
			if (!errcnt) {
			    if (parse_state != PARSE_PARAMS) {
				if (currentask->t_topd != topd)
				    cl_error (E_UERR, illegalvar);
				last_parm = currentask->t_pfp->pf_lastpp;
			    }
			}

		        /* Increment bracelevel temporarily to defeat command
			 * mode, in case this is an in-line declaration and
			 * lexmodes=yes.
			 */
			bracelevel += PBRACE;
			tbrace++;

		}
#line 2350 "y.tab.c"
    break;

  case 34: /* var_decl_stmt: typedefs $@5 var_decl_list EOST  */
#line 446 "grammar.y"
                                     {
		      	/* Update dictionary to include these definitions.
			 */
			if (!errcnt) {
			    if (parse_state != PARSE_PARAMS) {
				currentask->t_topd = topd;
				last_parm = 0;
			    }
			}

			/* Restore command mode */
			bracelevel -= PBRACE;
			tbrace--;
		}
#line 2369 "y.tab.c"
    break;

  case 35: /* typedefs: Y_BOOL  */
#line 462 "grammar.y"
                                { vartype = V_BOOL; }
#line 2375 "y.tab.c"
    break;

  case 36: /* typedefs: Y_STRING  */
#line 463 "grammar.y"
                                { vartype = V_STRING; }
#line 2381 "y.tab.c"
    break;

  case 37: /* typedefs: Y_REAL  */
#line 464 "grammar.y"
                                { vartype = V_REAL; }
#line 2387 "y.tab.c"
    break;

  case 38: /* typedefs: Y_FILE  */
#line 465 "grammar.y"
                                { vartype = V_FILE; }
#line 2393 "y.tab.c"
    break;

  case 39: /* typedefs: Y_GCUR  */
#line 466 "grammar.y"
                                { vartype = V_GCUR; }
#line 2399 "y.tab.c"
    break;

  case 40: /* typedefs: Y_IMCUR  */
#line 467 "grammar.y"
                                { vartype = V_IMCUR; }
#line 2405 "y.tab.c"
    break;

  case 41: /* typedefs: Y_UKEY  */
#line 468 "grammar.y"
                                { vartype = V_UKEY; }
#line 2411 "y.tab.c"
    break;

  case 42: /* typedefs: Y_PSET  */
#line 469 "grammar.y"
                                { vartype = V_PSET; }
#line 2417 "y.tab.c"
    break;

  case 43: /* typedefs: Y_INT  */
#line 470 "grammar.y"
                                { vartype = V_INT; }
#line 2423 "y.tab.c"
    break;

  case 44: /* typedefs: Y_STRUCT  */
#line 471 "grammar.y"
                                { vartype = V_STRUCT; }
#line 2429 "y.tab.c"
    break;

  case 47: /* var_decl_plus: var_decl  */
#line 478 "grammar.y"
                         {
			if (!errcnt) {
			    if (pp != NULL) {
				if (n_aval > 1)
				    pp->p_type |= PT_ARRAY;

				if (pp->p_type & PT_ARRAY)
				    do_arrayinit (pp, n_aval, index_cnt);
		      		else
		 		    do_scalarinit (pp, inited);
			    }
			}
		}
#line 2447 "y.tab.c"
    break;

  case 48: /* var_decl_plus: var_decl '{' options_list ';' '}'  */
#line 496 "grammar.y"
                                                   {
			if (!errcnt) {
			    if (pp != NULL) {
				if (!do_params)
				    cl_error (E_UERR, badparm, pp->p_name);

				if (n_aval > 1)
				    pp->p_type |= PT_ARRAY;

				if (pp->p_type & PT_ARRAY)
				    do_arrayinit (pp, n_aval, index_cnt);
		      		else
		 		    do_scalarinit (pp, n_aval);
			    }
			}
		}
#line 2468 "y.tab.c"
    break;

  case 49: /* var_decl: var_def  */
#line 514 "grammar.y"
                        {
			inited = NO;
			n_aval = 0;
		}
#line 2477 "y.tab.c"
    break;

  case 50: /* $@6: %empty  */
#line 518 "grammar.y"
                            {
			n_aval = 0;
		}
#line 2485 "y.tab.c"
    break;

  case 51: /* var_decl: var_def '=' $@6 init_list  */
#line 521 "grammar.y"
                          {
			inited = YES;
		}
#line 2493 "y.tab.c"
    break;

  case 52: /* var_def: var_name  */
#line 526 "grammar.y"
                         {
		    index_cnt = 0;
		    if (!errcnt)
			pp = initparam (stkop(yyvsp[0]), do_params, vartype, varlist);
		}
#line 2503 "y.tab.c"
    break;

  case 53: /* $@7: %empty  */
#line 531 "grammar.y"
                         {
		    int  itemp;

		    if (!errcnt) {
			pp = initparam (stkop(yyvsp[0]), do_params, vartype, varlist);

			if (pp != NULL) {
			    itemp = (pp->p_type & OT_BASIC) == pp->p_type;
			    itemp = itemp && !varlist;
			    if (itemp)
				pp->p_type |= PT_ARRAY;
			    else
				cl_error (E_UERR, inval_arr, pp->p_name);
			}
		    }
		}
#line 2524 "y.tab.c"
    break;

  case 55: /* var_name: param  */
#line 550 "grammar.y"
                      {
			varlist = NO;
			index_cnt = 0;
		}
#line 2533 "y.tab.c"
    break;

  case 56: /* var_name: '*' param  */
#line 554 "grammar.y"
                          {
			if (!do_params) {
			    errmsg = locallist;
			    EYYERROR;
			}
			varlist = YES;
			index_cnt = 0;
			yyval = yyvsp[0];
		}
#line 2547 "y.tab.c"
    break;

  case 60: /* init_index_range: const  */
#line 574 "grammar.y"
                      {
		    if (!errcnt) {
			if (pp != NULL) {
			    if (stkop(yyvsp[0])->o_type == OT_INT) {
				push (stkop(yyvsp[0])->o_val.v_i);
				push (1);
			    } else if (maybeindex) {
				/* Confusion between sexagesimal and index
				 * range.  Maybeindex is set only when operand
				 * is real.
			 	 */
				int  i1,i2;
				sexa_to_index (stkop(yyvsp[0])->o_val.v_r, &i1, &i2);
				push (i2-i1+1);
				push (i1);
			    } else {
				eprintf (inv_index, pp->p_name);
				EYYERROR;
			    }
			    index_cnt++;
			}
		    }
		}
#line 2575 "y.tab.c"
    break;

  case 61: /* init_index_range: const ':' const  */
#line 597 "grammar.y"
                                {
			if (!errcnt) {
			    if (pp != NULL) {
				if (stkop(yyvsp[-2])->o_type != OT_INT  ||
				    stkop(yyvsp[0])->o_type != OT_INT)
				    cl_error (E_UERR, inv_index, pp->p_name);
				else {
				    push (stkop(yyvsp[0])->o_val.v_i -
				          stkop(yyvsp[-2])->o_val.v_i + 1);
				    push (stkop(yyvsp[-2])->o_val.v_i);
			        }
			        index_cnt++;
			    }
			}
		}
#line 2595 "y.tab.c"
    break;

  case 64: /* init_elem: const  */
#line 618 "grammar.y"
                      {
			if (!errcnt) {
			    if (pp != NULL) {
				push (stkop(yyvsp[0]) );
				n_aval++;
			    }
			}
		}
#line 2608 "y.tab.c"
    break;

  case 65: /* init_elem: Y_CONSTANT LP const RP  */
#line 627 "grammar.y"
                {
			int   cnt;
			
			if (!errcnt)
			    if (pp != NULL) {
			    	if (stkop(yyvsp[-3])->o_type != OT_INT)
				    cl_error (E_UERR, arrdeferr, pp->p_name);

			        cnt = stkop(yyvsp[-3])->o_val.v_i;
			        if (cnt <= 0)
				    cl_error (E_UERR, arrdeferr, pp->p_name);

			        while (cnt-- > 0) {
				    push (stkop(yyvsp[-1]));
				    n_aval++;
			        }
			    }
		}
#line 2631 "y.tab.c"
    break;

  case 68: /* number: sign Y_CONSTANT  */
#line 654 "grammar.y"
                                {
		      	if (stkop(yyvsp[0])->o_type == OT_INT) {
			    stkop(yyvsp[0])->o_val.v_i *= yyvsp[-1];
			    yyval = yyvsp[0];
			} else if (stkop(yyvsp[0])->o_type == OT_REAL) {
			    stkop(yyvsp[0])->o_val.v_r *= yyvsp[-1];
			    yyval = yyvsp[0];
			} else {
			    errmsg = "Invalid constant in declaration.";
			    EYYERROR;
			}
		}
#line 2648 "y.tab.c"
    break;

  case 69: /* sign: '+'  */
#line 668 "grammar.y"
                        { yyval =  1; }
#line 2654 "y.tab.c"
    break;

  case 70: /* sign: '-'  */
#line 669 "grammar.y"
                        { yyval = -1; }
#line 2660 "y.tab.c"
    break;

  case 71: /* options_list: init_list DELIM options  */
#line 671 "grammar.y"
                                        {
			/* Check if we already had an initialization. 
			 */
		      	if (!errcnt) {
			    if (inited && pp != NULL) {
				eprintf (twoinits, pp->p_name);
				EYYERROR;
			    }
			}
		}
#line 2675 "y.tab.c"
    break;

  case 72: /* options_list: init_list  */
#line 681 "grammar.y"
                          {
		      	if (!errcnt) {
			    if (inited && pp != NULL) {
			        eprintf (twoinits, pp->p_name);
				EYYERROR;
			    }
			}
		}
#line 2688 "y.tab.c"
    break;

  case 76: /* option: Y_IDENT '=' const  */
#line 696 "grammar.y"
                                  {
			if (!errcnt)
			    if (pp != NULL)
			    	do_option (pp, stkop(yyvsp[-2]), stkop(yyvsp[0]));
		}
#line 2698 "y.tab.c"
    break;

  case 79: /* expr: ref  */
#line 712 "grammar.y"
                    {
		    if (!errcnt)
		        compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
		}
#line 2707 "y.tab.c"
    break;

  case 81: /* expr0: Y_CONSTANT  */
#line 726 "grammar.y"
                           {
		    if  (!errcnt)
		        compile (PUSHCONST, stkop(yyvsp[0]));
		}
#line 2716 "y.tab.c"
    break;

  case 82: /* expr0: Y_GCUR  */
#line 730 "grammar.y"
                       {
		    /* "gcur" is both a keyword and a CL global parameter,
		     * and must be built into the grammar here to permit
		     * reference of the parameter in expressions.
		     */
		    if (!errcnt)
			compile (PUSHPARAM, "gcur");
		}
#line 2729 "y.tab.c"
    break;

  case 83: /* expr0: Y_IMCUR  */
#line 738 "grammar.y"
                        {
		    if (!errcnt)
			compile (PUSHPARAM, "imcur");
		}
#line 2738 "y.tab.c"
    break;

  case 84: /* expr0: Y_UKEY  */
#line 742 "grammar.y"
                       {
		    if (!errcnt)
			compile (PUSHPARAM, "ukey");
		}
#line 2747 "y.tab.c"
    break;

  case 85: /* expr0: Y_PSET  */
#line 746 "grammar.y"
                       {
		    if (!errcnt)
			compile (PUSHPARAM, "pset");
		}
#line 2756 "y.tab.c"
    break;

  case 87: /* expr1: expr '+' opnl expr  */
#line 754 "grammar.y"
                                   {
		    if (!errcnt)
			compile (ADD);
		}
#line 2765 "y.tab.c"
    break;

  case 88: /* expr1: expr '-' opnl expr  */
#line 758 "grammar.y"
                                   {
		    if (!errcnt)
			compile (SUB);
		}
#line 2774 "y.tab.c"
    break;

  case 89: /* expr1: expr '*' opnl expr  */
#line 762 "grammar.y"
                                   {
		    if (!errcnt)
			compile (MUL);
		}
#line 2783 "y.tab.c"
    break;

  case 90: /* expr1: expr '/' opnl expr  */
#line 766 "grammar.y"
                                   {
		    if (!errcnt)
			compile (DIV);
		}
#line 2792 "y.tab.c"
    break;

  case 91: /* expr1: expr YOP_POW opnl expr  */
#line 770 "grammar.y"
                                       {
		    if (!errcnt)
			compile (POW);
		}
#line 2801 "y.tab.c"
    break;

  case 92: /* expr1: expr '%' opnl expr  */
#line 774 "grammar.y"
                                   {
		    struct	operand o;
		    if (!errcnt) {
			o.o_type = OT_INT;
			o.o_val.v_i = 2;
			compile (PUSHCONST, &o);
			compile (INTRINSIC, "mod");
		    }
		}
#line 2815 "y.tab.c"
    break;

  case 93: /* expr1: expr YOP_CONCAT opnl expr  */
#line 783 "grammar.y"
                                          {
		    if (!errcnt)
			compile (CONCAT);
		}
#line 2824 "y.tab.c"
    break;

  case 94: /* expr1: expr '<' opnl expr  */
#line 787 "grammar.y"
                                   {
		    if (!errcnt)
			compile (LT);
		}
#line 2833 "y.tab.c"
    break;

  case 95: /* expr1: expr '>' opnl expr  */
#line 791 "grammar.y"
                                   {
		    if (!errcnt)
			compile (GT);
		}
#line 2842 "y.tab.c"
    break;

  case 96: /* expr1: expr YOP_LE opnl expr  */
#line 795 "grammar.y"
                                      {
		    if (!errcnt)
			compile (LE);
		}
#line 2851 "y.tab.c"
    break;

  case 97: /* expr1: expr YOP_GE opnl expr  */
#line 799 "grammar.y"
                                      {
		    if (!errcnt)
			compile (GE);
		}
#line 2860 "y.tab.c"
    break;

  case 98: /* expr1: expr YOP_EQ opnl expr  */
#line 803 "grammar.y"
                                      {
		    if (!errcnt)
			compile (EQ);
		}
#line 2869 "y.tab.c"
    break;

  case 99: /* expr1: expr YOP_NE opnl expr  */
#line 807 "grammar.y"
                                      {
		    if (!errcnt)
			compile (NE);
		}
#line 2878 "y.tab.c"
    break;

  case 100: /* expr1: expr YOP_OR opnl expr  */
#line 811 "grammar.y"
                                      {
		    if (!errcnt)
			compile (OR);
		}
#line 2887 "y.tab.c"
    break;

  case 101: /* expr1: expr YOP_AND opnl expr  */
#line 815 "grammar.y"
                                       {
		    if (!errcnt)
			compile (AND);
		}
#line 2896 "y.tab.c"
    break;

  case 102: /* expr1: YOP_NOT expr  */
#line 819 "grammar.y"
                             {
		    if (!errcnt)
			compile (NOT);
		}
#line 2905 "y.tab.c"
    break;

  case 103: /* expr1: '-' expr  */
#line 823 "grammar.y"
                                      {
		    if (!errcnt)
			compile (CHSIGN);
		}
#line 2914 "y.tab.c"
    break;

  case 104: /* $@8: %empty  */
#line 828 "grammar.y"
                          {
		    /* Free format scan. */
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 2924 "y.tab.c"
    break;

  case 105: /* expr1: Y_SCAN LP $@8 scanarg RP  */
#line 832 "grammar.y"
                             {
		    if (!errcnt) {
			struct	operand o;
			o.o_type = OT_INT;
		        o.o_val.v_i = pop();	/* get total number of args*/
			compile (PUSHCONST, &o);
			compile (SCAN);
		    }
		}
#line 2938 "y.tab.c"
    break;

  case 106: /* $@9: %empty  */
#line 841 "grammar.y"
                           {
		    /* Formatted scan. */
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 2948 "y.tab.c"
    break;

  case 107: /* expr1: Y_SCANF LP $@9 scanfmt DELIM scanarg RP  */
#line 845 "grammar.y"
                                           {
		    if (!errcnt) {
			struct	operand o;

			/* Compile number of arguments. */
			o.o_type = OT_INT;
		        o.o_val.v_i = pop();
			compile (PUSHCONST, &o);

			compile (SCANF);
		    }
		}
#line 2965 "y.tab.c"
    break;

  case 108: /* $@10: %empty  */
#line 858 "grammar.y"
                           {
		    /* Free format scan from a parameter.  */
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 2975 "y.tab.c"
    break;

  case 109: /* expr1: Y_FSCAN LP $@10 scanarg RP  */
#line 862 "grammar.y"
                             {
		    if (!errcnt) {
			struct	operand o;
			o.o_type = OT_INT;
			o.o_val.v_i = pop();	/* get total number of args*/
			compile (PUSHCONST, &o);
			compile (FSCAN);
		    }
		}
#line 2989 "y.tab.c"
    break;

  case 110: /* $@11: %empty  */
#line 872 "grammar.y"
                                          {
		    /* Formatted scan from a parameter.
		     * fscanf (param, format, arg1, ...)
		     */
		    if (!errcnt) {
			compile (PUSHCONST, stkop (yyvsp[-1]));
		        push (1);	/* use control stack to count args */
		    }
		}
#line 3003 "y.tab.c"
    break;

  case 111: /* expr1: Y_FSCANF LP Y_IDENT DELIM $@11 scanfmt DELIM scanarg RP  */
#line 880 "grammar.y"
                                           {
		    if (!errcnt) {
			struct	operand o;

			/* Compile number of arguments. */
			o.o_type = OT_INT;
			o.o_val.v_i = pop();
			compile (PUSHCONST, &o);

			compile (FSCANF);
		    }
		}
#line 3020 "y.tab.c"
    break;

  case 112: /* $@12: %empty  */
#line 893 "grammar.y"
                            {
		    if (!errcnt)
			push (0);	/* use control stack to count args */
		}
#line 3029 "y.tab.c"
    break;

  case 113: /* expr1: intrinsx LP $@12 intrarg RP  */
#line 896 "grammar.y"
                             {
		    if (!errcnt) {
			struct	operand o;
			o.o_type = OT_INT;
			o.o_val.v_i = pop();
			compile (PUSHCONST, &o);
			compile (INTRINSIC, stkop(yyvsp[-4])->o_val.v_s);
		    }
		}
#line 3043 "y.tab.c"
    break;

  case 115: /* intrinsx: Y_INT  */
#line 911 "grammar.y"
                      {
			/* The YACC value of this must match normal intrinsics
			 * so we must generate an operand with the proper
			 * string. 
			 */
			if (!errcnt)
			    yyval = addconst ("int", OT_STRING);
		}
#line 3056 "y.tab.c"
    break;

  case 116: /* intrinsx: Y_REAL  */
#line 919 "grammar.y"
                       {
			if (!errcnt)
			    yyval = addconst ("real", OT_STRING);
		}
#line 3065 "y.tab.c"
    break;

  case 117: /* scanfmt: expr  */
#line 925 "grammar.y"
                     {
		    if (!errcnt) {
		        push (pop() + 1);		/* inc num args	*/
		    }
		}
#line 3075 "y.tab.c"
    break;

  case 119: /* scanarg: Y_IDENT  */
#line 938 "grammar.y"
                        {
                    if (!errcnt) {
                        compile (PUSHCONST, stkop (yyvsp[0]));
                        push (pop() + 1);               /* inc num args */
                    }
		}
#line 3086 "y.tab.c"
    break;

  case 120: /* scanarg: Y_IDENT DELIM scanarg  */
#line 944 "grammar.y"
                                      {
                    if (!errcnt) {
                        compile (PUSHCONST, stkop (yyvsp[-2]));
                        push (pop() + 1);               /* inc num args */
                    }
		}
#line 3097 "y.tab.c"
    break;

  case 122: /* intrarg: expr  */
#line 955 "grammar.y"
                     {
		    if (!errcnt)
			push (pop() + 1);		/* inc num args	*/
		}
#line 3106 "y.tab.c"
    break;

  case 123: /* intrarg: intrarg DELIM expr  */
#line 959 "grammar.y"
                                   {
		    if (!errcnt)
			push (pop() + 1);		/* inc num args	*/
		}
#line 3115 "y.tab.c"
    break;

  case 148: /* $@13: %empty  */
#line 999 "grammar.y"
                    {
		    bracelevel++;
		}
#line 3123 "y.tab.c"
    break;

  case 149: /* $@14: %empty  */
#line 1001 "grammar.y"
                              {
		    --bracelevel;
		}
#line 3131 "y.tab.c"
    break;

  case 153: /* assign: ref equals expr0  */
#line 1013 "grammar.y"
                                 {
			--parenlevel;
 			if (!errcnt)
		      	    compile (ASSIGN, stkop(yyvsp[-2])->o_val.v_s);
		}
#line 3141 "y.tab.c"
    break;

  case 154: /* assign: ref equals ref  */
#line 1018 "grammar.y"
                               {
			/* Old code pushed a constant rather than a param
			 * when not within braces.  This doesn't seem
			 * to be what most people want.
			 */
			--parenlevel;
			if (!errcnt) {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
		            compile (ASSIGN, stkop(yyvsp[-2])->o_val.v_s);
		    	}
		}
#line 3157 "y.tab.c"
    break;

  case 155: /* $@15: %empty  */
#line 1029 "grammar.y"
                    {
			parenlevel++;
		}
#line 3165 "y.tab.c"
    break;

  case 156: /* assign: ref $@15 assign_oper expr  */
#line 1032 "grammar.y"
                                 {
		      	--parenlevel;
			if (!errcnt)
		  	    compile (yyvsp[-1], stkop(yyvsp[-3])->o_val.v_s);
		}
#line 3175 "y.tab.c"
    break;

  case 157: /* equals: '='  */
#line 1041 "grammar.y"
                    {
			parenlevel++;
		}
#line 3183 "y.tab.c"
    break;

  case 158: /* assign_oper: YOP_AOADD  */
#line 1046 "grammar.y"
                                { yyval = ADDASSIGN; }
#line 3189 "y.tab.c"
    break;

  case 159: /* assign_oper: YOP_AOSUB  */
#line 1047 "grammar.y"
                                { yyval = SUBASSIGN; }
#line 3195 "y.tab.c"
    break;

  case 160: /* assign_oper: YOP_AOMUL  */
#line 1048 "grammar.y"
                                { yyval = MULASSIGN; }
#line 3201 "y.tab.c"
    break;

  case 161: /* assign_oper: YOP_AODIV  */
#line 1049 "grammar.y"
                                { yyval = DIVASSIGN; }
#line 3207 "y.tab.c"
    break;

  case 162: /* assign_oper: YOP_AOCAT  */
#line 1050 "grammar.y"
                                { yyval = CATASSIGN; }
#line 3213 "y.tab.c"
    break;

  case 163: /* $@16: %empty  */
#line 1053 "grammar.y"
                        {
		    npipes = 0;
		}
#line 3221 "y.tab.c"
    break;

  case 164: /* cmdlist: command $@16 cmdpipe  */
#line 1055 "grammar.y"
                          {
		    if (!errcnt) {
			compile (EXEC);
			if (npipes > 0)
			    compile (RMPIPES, npipes);
		    }
		}
#line 3233 "y.tab.c"
    break;

  case 166: /* $@17: %empty  */
#line 1065 "grammar.y"
                             {
		    /* Pipefiles must be allocated at run time using a stack
		     * to permit pipe commands within loops, and to permit
		     * scripts called in a pipe to themselves contain pipe
		     * commands.  ADDPIPE allocates a new pipefile on the
		     * pipe stack and pushes its name on the operand stack.
		     * GETPIPE pushes the pipefile at the top of the pipe
		     * stack onto the operand stack.  RMPIPES removes N pipes
		     * from the pipe stack, and deletes the physical pipefiles.
		     */

		    if (!newstdout) {
			/* When the runtime code creates the pipe it needs to
			 * know the identity of the two tasks sharing the pipe
			 * to determine what type of pipe to create (text or
			 * binary).  Save the pc of the ADDPIPE instruction
			 * so that we can backpatch it below with a pointer to
			 * the name of the second task in the pipe (ADDPIPE
			 * will be called during startup of the first task
			 * hence will know its name).
			 */
			pipe_pc = compile (ADDPIPE, NULL);

			if (yyvsp[0] == 1)
			    compile (REDIR);
			else
			    compile (ALLREDIR);
			compile (EXEC);

		    } else {
			eprintf ("multiple redirection\n");
			YYERROR;
		    }

		}
#line 3273 "y.tab.c"
    break;

  case 167: /* cmdpipe: cmdpipe pipe $@17 command  */
#line 1099 "grammar.y"
                          {
		    /* Compile the GETPIPE instruction with the name of the
		     * second task in the current pipe, and backpatch the
		     * matching ADDPIPE instruction with the PC of the GETPIPE.
		     */
		    (coderef(pipe_pc))->c_args = compile (GETPIPE, curr_task);
		    compile (REDIRIN);
		    npipes++;		/* Overflow checking is in ADDPIPE */
		}
#line 3287 "y.tab.c"
    break;

  case 168: /* pipe: '|' opnl  */
#line 1110 "grammar.y"
                         {
		    yyval = 1;
		}
#line 3295 "y.tab.c"
    break;

  case 169: /* pipe: Y_ALLPIPE opnl  */
#line 1113 "grammar.y"
                               {
		    yyval = 2;
		}
#line 3303 "y.tab.c"
    break;

  case 170: /* $@18: %empty  */
#line 1118 "grammar.y"
                        {
		    char    *ltname;

		    ltname = stkop(yyvsp[0])->o_val.v_s;
		    compile (CALL, ltname);
		    strcpy (curr_task, ltname);

		    /* The FPRINT task is special; the first arg
		     * is the destination and must be compiled as
		     * a string constant no matter what.  Set flag
		     * so that 'arg' compiles PUSHCONST.
		     */
		    printstmt = (strcmp (ltname, "fprint") == 0);

		    /* Ditto with SCAN; all the arguments are call by
		     * reference and must be compiled as string constants.
		     */
		    scanstmt = (strcmp (ltname, "scan") == 0 ||
				strcmp (ltname, "scanf") == 0);

		    absmode = 0;
		    posit = 0;
		    newstdout = 0;
		    parenlevel = 0;
		}
#line 3333 "y.tab.c"
    break;

  case 171: /* $@19: %empty  */
#line 1142 "grammar.y"
                       {
		    inarglist = 1;
		}
#line 3341 "y.tab.c"
    break;

  case 172: /* command: tasknam $@18 BARG $@19 args EARG  */
#line 1144 "grammar.y"
                            {
		    inarglist = 0;
		    parenlevel = 0;
		    scanstmt = 0;
		}
#line 3351 "y.tab.c"
    break;

  case 173: /* $@20: %empty  */
#line 1151 "grammar.y"
                      {
		    /* (,x) equates to nargs == 2.  Call posargset with
		     * negative dummy argument to bump nargs.
		     */
		    if (!errcnt) {
			compile (POSARGSET, -1);
			posit++;
			printstmt = 0;
			scanstmt = 0;
		    }
		}
#line 3367 "y.tab.c"
    break;

  case 178: /* arg: %empty  */
#line 1170 "grammar.y"
                {
		    if (!errcnt) {
			if (posit > 0) {		/* not first time */
			    compile (POSARGSET, -posit);
			    printstmt = 0;
			    scanstmt = 0;
			}
			posit++;
		    }
		}
#line 3382 "y.tab.c"
    break;

  case 179: /* arg: expr0  */
#line 1180 "grammar.y"
                      {
		    if (absmode) {
			errmsg = posfirst;
			EYYERROR;
		    } else
			if (!errcnt)
			    compile (POSARGSET, posit++);
		}
#line 3395 "y.tab.c"
    break;

  case 180: /* arg: ref  */
#line 1188 "grammar.y"
                    {
		    if (absmode) {
			errmsg = posfirst;
			EYYERROR;
		    } else if (!errcnt) {
			if (scanstmt) {
			    char    pname[SZ_FNAME];
			    char    *pk, *t, *p, *f;
			    struct  pfile *pfp;
			    struct  operand o;

			    /* If no task name specified check the pfile for
			     * the task containing the scan statement for the
			     * named parameter.
			     */
			    breakout (stkop(yyvsp[0])->o_val.v_s, &pk, &t, &p, &f);
			    pfp = currentask->t_pfp;
			    if (*pk == '\0' && *t == '\0' &&
				pfp && paramfind(pfp,p,0,1)) {

				sprintf (pname, "%s.%s",
				    currentask->t_ltp->lt_lname, p);
				if (*f) {
				    strcat (pname, ".");
				    strcat (pname, f);
				}
			    } else
				strcpy (pname, stkop(yyvsp[0])->o_val.v_s);

			    o = *(stkop(yyvsp[0]));
			    o.o_val.v_s = pname;
			    compile (PUSHCONST, &o);
			    compile (INDIRPOSSET, posit++);

			} else if (parenlevel == 0 || printstmt) {
			    compile (PUSHCONST, stkop(yyvsp[0]));
			    compile (INDIRPOSSET, posit++);
			    /* only first arg of fprint stmt is special. */
			    printstmt = 0;

			} else {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			    compile (POSARGSET, posit++);
			}
		    }
		}
#line 3446 "y.tab.c"
    break;

  case 181: /* arg: ref '=' expr0  */
#line 1234 "grammar.y"
                              {
		    absmode++;
		    if (!errcnt)
			compile (ABSARGSET, stkop(yyvsp[-2])->o_val.v_s); 
		}
#line 3456 "y.tab.c"
    break;

  case 182: /* arg: ref '=' ref  */
#line 1239 "grammar.y"
                            {
		    absmode++;
		    if (!errcnt) {
			if (parenlevel == 0) {
			    compile (PUSHCONST, stkop(yyvsp[0]));
			    compile (INDIRABSSET, stkop(yyvsp[-2])->o_val.v_s); 
			} else {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			    compile (ABSARGSET, stkop(yyvsp[-2])->o_val.v_s);
			}
		    }
		}
#line 3473 "y.tab.c"
    break;

  case 183: /* arg: param '+'  */
#line 1251 "grammar.y"
                          {
		    absmode++;
		    if (!errcnt)
			compile (SWON, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3483 "y.tab.c"
    break;

  case 184: /* arg: param '-'  */
#line 1256 "grammar.y"
                          {
		    absmode++;
		    if (!errcnt)
			compile (SWOFF, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3493 "y.tab.c"
    break;

  case 185: /* arg: '<' file  */
#line 1261 "grammar.y"
                         {
		    if (!errcnt)
			compile (REDIRIN);
		}
#line 3502 "y.tab.c"
    break;

  case 186: /* arg: '>' file  */
#line 1265 "grammar.y"
                         {
		    newstdout++;
		    if (!errcnt)
			compile (REDIR);
		}
#line 3512 "y.tab.c"
    break;

  case 187: /* arg: Y_ALLREDIR file  */
#line 1270 "grammar.y"
                                {
		    newstdout++;
		    if (!errcnt)
			compile (ALLREDIR);
		}
#line 3522 "y.tab.c"
    break;

  case 188: /* arg: Y_APPEND file  */
#line 1275 "grammar.y"
                              {
		    newstdout++;
		    if (!errcnt)
			compile (APPENDOUT);
		}
#line 3532 "y.tab.c"
    break;

  case 189: /* arg: Y_ALLAPPEND file  */
#line 1280 "grammar.y"
                                 {
		    newstdout++;
		    if (!errcnt)
			compile (ALLAPPEND);
		}
#line 3542 "y.tab.c"
    break;

  case 190: /* arg: Y_GSREDIR file  */
#line 1285 "grammar.y"
                               {
		    if (!errcnt)
			compile (GSREDIR, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3551 "y.tab.c"
    break;

  case 191: /* file: expr0  */
#line 1291 "grammar.y"
                      {
		    absmode++;
		    /* constant already pushed by expr0.
		     */
		}
#line 3561 "y.tab.c"
    break;

  case 192: /* file: param  */
#line 1296 "grammar.y"
                      {
		    absmode++;
		    if (!errcnt) {
			if (parenlevel == 0)
			    compile (PUSHCONST, stkop(yyvsp[0]));
			else
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			}
		}
#line 3575 "y.tab.c"
    break;

  case 193: /* immed: equals expr0  */
#line 1307 "grammar.y"
                             {
			--parenlevel;
			if (!errcnt)
			    compile (IMMED);
		}
#line 3585 "y.tab.c"
    break;

  case 194: /* immed: equals ref  */
#line 1312 "grammar.y"
                           {
		      	--parenlevel;
			if (!errcnt)
			    compile (INSPECT, stkop(yyvsp[0])->o_val.v_s);
		}
#line 3595 "y.tab.c"
    break;

  case 195: /* inspect: ref equals  */
#line 1319 "grammar.y"
                           {
			--parenlevel;
			if (!errcnt)
			    compile (INSPECT, stkop(yyvsp[-1])->o_val.v_s);
		}
#line 3605 "y.tab.c"
    break;

  case 196: /* osesc: Y_OSESC  */
#line 1326 "grammar.y"
                        {
		    if (!errcnt)
			compile (OSESC, stkop(yyvsp[0])->o_val.v_s);
		}
#line 3614 "y.tab.c"
    break;

  case 197: /* popstk: equals  */
#line 1332 "grammar.y"
                       {
		    --parenlevel;
		    if (!errcnt)
			compile (IMMED);
		}
#line 3624 "y.tab.c"
    break;

  case 198: /* iferr: iferr_stat  */
#line 1342 "grammar.y"
                           {
		    /* pop BIFF addr and set branch to just after statement */
		    if (!errcnt) {
		        XINT   biffaddr = pop();
		    	coderef (biffaddr)->c_args = pc - biffaddr - SZ_CE;
		    }
		    in_iferr = 0;
		}
#line 3637 "y.tab.c"
    break;

  case 199: /* $@21: %empty  */
#line 1352 "grammar.y"
                          {
		    if (++in_iferr > 1) { 
			errmsg = nestediferr; 
			EYYERROR; 
		    } 
		    compile (CALL, "_errpsh");
		    compile (EXEC);

		}
#line 3651 "y.tab.c"
    break;

  case 200: /* $@22: %empty  */
#line 1360 "grammar.y"
                        {
		    if (!errcnt) {
			struct	operand o;

			o.o_type = OT_INT;
			o.o_val.v_i = 0;
			compile (PUSHCONST, &o);       /* if (_errpop() != 0) */
			compile (INTRINSIC, "_errpop");
			compile (PUSHCONST, &o);
			compile (((iferr_tok == 0) ? NE : EQ));
			push (compile (BIFF, 0));
		    }
		}
#line 3669 "y.tab.c"
    break;

  case 201: /* iferr_stat: iferr_tok $@21 c_blk $@22 op_then opnl xstmt  */
#line 1372 "grammar.y"
                                     {
		    in_iferr--;
		}
#line 3677 "y.tab.c"
    break;

  case 202: /* $@23: %empty  */
#line 1377 "grammar.y"
                                  {
		    if (!errcnt) {
			/* Pop and save BIFF address, compile and push addr 
			 * of GOTO, and set BIFF branch to just after GOTO.
			 */
			XINT  biffaddr = pop();
			push (compile (GOTO, 0));
			coderef (biffaddr)->c_args = pc - biffaddr - SZ_CE;
		    }

		}
#line 3693 "y.tab.c"
    break;

  case 203: /* iferr_else: iferr_stat Y_ELSE $@23 opnl xstmt  */
#line 1387 "grammar.y"
                             {
		    if (!errcnt) {
			/* Pop GOTO addr and set branch to just after statement
			 */
		    	XINT  gotoaddr = pop();
			coderef (gotoaddr)->c_args = pc - gotoaddr - SZ_CE;
		    }
		}
#line 3706 "y.tab.c"
    break;

  case 204: /* iferr_tok: Y_IFERR  */
#line 1397 "grammar.y"
                          { iferr_tok = 0; }
#line 3712 "y.tab.c"
    break;

  case 205: /* iferr_tok: Y_IFNOERR  */
#line 1398 "grammar.y"
                          { iferr_tok = 1; }
#line 3718 "y.tab.c"
    break;

  case 208: /* if: if_stat  */
#line 1409 "grammar.y"
                        {
		    /* pop BIFF addr and set branch to just after statement
		     */
		    XINT   biffaddr;
		    if (!errcnt) {
			biffaddr = pop();
		    	coderef (biffaddr)->c_args = pc - biffaddr - SZ_CE;
		    }
		}
#line 3732 "y.tab.c"
    break;

  case 209: /* $@24: %empty  */
#line 1420 "grammar.y"
                                {
			/* save BIFF addr so branch can be filled in 
			 */
			if (!errcnt)
			    push (compile (BIFF, 0));
		}
#line 3743 "y.tab.c"
    break;

  case 210: /* if_stat: Y_IF LP expr RP $@24 opnl xstmt  */
#line 1425 "grammar.y"
                             {
			/* The shift/reduce conflict in the IF-IF/ELSE
			 * construct can cause errors in compilation
			 * because the IF statement can also be a
			 * terminal symbol, i.e. it may be all that
			 * is parsed in one call to the parser.
			 * The parser must look ahead one token
			 * to find if there is an else statement
			 * following.  If there is no following
			 * token an EOF may be detected prematurely.
			 * When the IF statement is being parsed not
			 * inside any braces, then when the next token
			 * is not an ELSE care must be taken that this
			 * token is seen on a subsequent invocation
			 * of the parser.  The `ifseen' flag is
			 * used within the support for the lexical
			 * analyzer located in `history.c'.
			 */
			if (cldebug) 
			    eprintf ("ytab: setting ifseen=yes\n");

			if (currentask->t_flags & T_INTERACTIVE)
			    ifseen = ip_cmdblk;
			else
			    ifseen = cmdblk;
		}
#line 3774 "y.tab.c"
    break;

  case 211: /* $@25: %empty  */
#line 1453 "grammar.y"
                               {
		    XINT  biffaddr;

		    ifseen = NULL;
		    if (!errcnt) {
			/* Pop and save BIFF address, compile and push addr 
			 * of GOTO, and set BIFF branch to just after GOTO.
			 */
			biffaddr = pop();
			push (compile (GOTO, 0));
			coderef (biffaddr)->c_args = pc - biffaddr - SZ_CE;
		    }
		}
#line 3792 "y.tab.c"
    break;

  case 212: /* ifelse: if_stat Y_ELSE $@25 opnl xstmt  */
#line 1465 "grammar.y"
                             {
		    XINT  gotoaddr;
		    if (!errcnt) {
			/* Pop GOTO addr and set branch to just after statement
			 */
			gotoaddr = pop();
			coderef (gotoaddr)->c_args = pc - gotoaddr - SZ_CE;
		    }
		}
#line 3806 "y.tab.c"
    break;

  case 213: /* $@26: %empty  */
#line 1476 "grammar.y"
                           {
		    /* Save starting addr of while expression.
		     */
		    if (!errcnt) {
			push (pc);
			loopincr();
		    }
		}
#line 3819 "y.tab.c"
    break;

  case 214: /* $@27: %empty  */
#line 1483 "grammar.y"
                          {
		    /* Save BIFF addr so branch can be filled in.
		     */
		    if (!errcnt)
			push (compile (BIFF, 0));
		}
#line 3830 "y.tab.c"
    break;

  case 215: /* while: Y_WHILE LP $@26 expr RP $@27 opnl xstmt  */
#line 1488 "grammar.y"
                             {
		    XINT  biffaddr;

		    if (!errcnt) {
			/* Pop and save addr of BIFF instruction.	   */
			biffaddr = pop();
			/* Pop addr of expression and build a goto there.  */
			compile (GOTO, pop() - pc - SZ_CE);
			/* Now can set BIFF branch to just after statement.*/
			coderef (biffaddr)->c_args = pc - biffaddr - SZ_CE;
			loopdecr();
		    }
		}
#line 3848 "y.tab.c"
    break;

  case 216: /* $@28: %empty  */
#line 1521 "grammar.y"
                                               {
			if (!errcnt)
			    push(pc);				/* Loop1: */
		}
#line 3857 "y.tab.c"
    break;

  case 217: /* $@29: %empty  */
#line 1525 "grammar.y"
                               {
			if (!errcnt) {
			    if (for_expr)
				ppush (compile(BIFF, 0));	/* if (!e2) */

			    /* Add SZ_CE to skip following GOTO. 
			     */
			    ppush (pc+SZ_CE);			/* Loop2: */
			    ppush (compile(GOTO,0));		/* goto Loop3 */

			    /* Save current location as the destination
			     * for NEXT statements.
			     */
			    loopincr();
			}
		}
#line 3878 "y.tab.c"
    break;

  case 218: /* $@30: %empty  */
#line 1541 "grammar.y"
                                {
			XINT  stmtaddr;

			if (!errcnt) {
			    stmtaddr = pop();
			    compile (GOTO, stmtaddr-pc-SZ_CE); 	/* Goto loop1 */
			    stmtaddr = pop();
			    coderef(stmtaddr)->c_args = pc - stmtaddr - SZ_CE;
			}
		}
#line 3893 "y.tab.c"
    break;

  case 219: /* for: Y_FOR LP opnl xassign ';' opnl $@28 xexpr ';' opnl $@29 xassign RP opnl $@30 stmt  */
#line 1551 "grammar.y"
                     {
			XINT  stmtaddr;

			if (!errcnt) {
			    stmtaddr = pop();
			    compile (GOTO, stmtaddr-pc-SZ_CE); /* goto loop2 */

			    if (for_expr) {
				stmtaddr = pop();
				coderef(stmtaddr)->c_args = pc-stmtaddr-SZ_CE;
			    }
			    loopdecr();
			}
		}
#line 3912 "y.tab.c"
    break;

  case 222: /* xexpr: expr  */
#line 1574 "grammar.y"
                     {
			for_expr = YES;
		}
#line 3920 "y.tab.c"
    break;

  case 223: /* xexpr: %empty  */
#line 1577 "grammar.y"
                            {
			for_expr = NO;
		}
#line 3928 "y.tab.c"
    break;

  case 224: /* $@31: %empty  */
#line 1603 "grammar.y"
                {
			if (!errcnt) {
			    push (compile(SWITCH));

			    /* Compile GOTO which will branch past end of
			     * switch.  This is needed if there is no DEFAULT.
			     */
			    compile (GOTO, 0);
			}
		}
#line 3943 "y.tab.c"
    break;

  case 225: /* switch: Y_SWITCH opnl LP opnl expr opnl RP opnl $@31 xstmt  */
#line 1612 "grammar.y"
                        {
			/* Set up jumptable and pop space on stack.
			 */
			if (!errcnt)
			    setswitch();
		}
#line 3954 "y.tab.c"
    break;

  case 226: /* $@32: %empty  */
#line 1620 "grammar.y"
                       {
			if (!errcnt) {
			    ncaseval = 0;
			    if (!in_switch()) {
				errmsg = "Improper CASE statement.";
				EYYERROR;
			    }
			}
		}
#line 3968 "y.tab.c"
    break;

  case 227: /* $@33: %empty  */
#line 1628 "grammar.y"
                                           {
			XINT  pcase;

			if (!errcnt) {
			    pcase = compile (CASE, ncaseval);

			    /* Fill in argument list. 
			     */
			    caseset (&(coderef(pcase)->c_args), ncaseval);
			    push (pcase);
			}
		}
#line 3985 "y.tab.c"
    break;

  case 228: /* case: Y_CASE $@32 const_expr_list ':' opnl $@33 xstmt  */
#line 1639 "grammar.y"
                        {
			/* Branch to end of switch block 
			 */
			if (!errcnt)
			    push (compile(GOTO, 0));
		}
#line 3996 "y.tab.c"
    break;

  case 229: /* $@34: %empty  */
#line 1647 "grammar.y"
                                   {
		      	/* Compile an operand to store the current PC.
			 */
			if (!errcnt) {
			    if (!in_switch()) {
				errmsg = "Improper DEFAULT statement.";
				EYYERROR;
			    }
			    push (compile(DEFAULT));
			}
		}
#line 4012 "y.tab.c"
    break;

  case 230: /* default: Y_DEFAULT ':' opnl $@34 xstmt  */
#line 1657 "grammar.y"
                        {
		      	/* Branch past jump table. 
			 */
			if (!errcnt)
			    push (compile(GOTO, 0));
		}
#line 4023 "y.tab.c"
    break;

  case 231: /* next: Y_NEXT  */
#line 1665 "grammar.y"
                       {
			/* All NEXT statements are backward references,
			 * so we simply store the addresses in an array.
			 */
			if (!errcnt) {
			    if (nestlevel)
				compile (GOTO, nextdest[nestlevel-1]-pc-SZ_CE);
			    else {
				errmsg = "NEXT outside of loop.";
				EYYERROR;
			    }
			}
		}
#line 4041 "y.tab.c"
    break;

  case 232: /* break: Y_BREAK  */
#line 1680 "grammar.y"
                        {
			/* Each BREAK is a forward reference.  For the
			 * first BREAK in each loop we compile a
			 * GOTO statement which will be the object of
			 * all BREAK statements within the loop.  When
			 * the loop is terminated the target of this
			 * GOTO will be set.
			 */
			int  dest;

			if (!errcnt) {
			    if (!nestlevel) {
				errmsg = "Break outside of loop.";
				EYYERROR;
			    } else if ((dest = brkdest[nestlevel-1]) != 0)
		    		compile (GOTO, dest-pc-SZ_CE);
			    else {
				brkdest[nestlevel-1] = pc;
				compile (GOTO, 0);
			    }
			}
		}
#line 4068 "y.tab.c"
    break;

  case 233: /* return: Y_RETURN  */
#line 1704 "grammar.y"
                         {
			if (!errcnt)
			    compile (END);
		}
#line 4077 "y.tab.c"
    break;

  case 234: /* return: Y_RETURN expr  */
#line 1708 "grammar.y"
                              {
			/* Return values currently not implemented.
			 */
			eprintf ("Warning: return value ignored.\n");
			if (!errcnt)
			    compile (END);
		}
#line 4089 "y.tab.c"
    break;

  case 235: /* end_stmt: Y_END NL  */
#line 1720 "grammar.y"
                         {
			bracelevel -= PBRACE;
			if (bracelevel < 0) {
			    errmsg = "Too few left braces.";
			    EYYERROR;
			} else if (bracelevel > 0) {
			    errmsg = "Too few right braces.";
			    EYYERROR;
			}
		}
#line 4104 "y.tab.c"
    break;

  case 236: /* $@35: %empty  */
#line 1732 "grammar.y"
                                 {
			/* Put symbol in table in dictionary and
			 * process indirect references if present.
			 */
			struct label *l;

			if (!errcnt) {
			    l = getlabel (stkop(yyvsp[-2]));

			    if (l == NULL) {
				l = setlabel (stkop(yyvsp[-2]));
				l->l_loc = pc;
			    } else if (l->l_defined) {
			        errmsg = "Identical labels.";
				EYYERROR;
			    } else {
				/* Get this GOTO out of the
				 * indirect list so we can use
				 * the argument as the destination
				 */
				XINT  gotopc;
				gotopc = l->l_loc;
				unsetigoto (gotopc);

				/* Fix the indirect reference. 
				 */
				coderef(gotopc)->c_args = pc - gotopc - SZ_CE;
			    }
			    (l->l_defined)++;
			}
		}
#line 4140 "y.tab.c"
    break;

  case 238: /* goto: Y_GOTO Y_IDENT  */
#line 1766 "grammar.y"
                               {
			/* Get the address corresponding to the label.
			 */
			struct label *l;

			if (!errcnt) {
			    l = getlabel (stkop(yyvsp[0]));

			    if (l != NULL)
				compile (GOTO, l->l_loc - pc - SZ_CE);
			    else {
				/* Ready for indirect GOTO 
				 */
				l = setlabel (stkop(yyvsp[0]));
				l->l_loc = pc;
				setigoto (compile(GOTO, 0));
				l->l_defined = 0;
			    }
			}
		}
#line 4165 "y.tab.c"
    break;

  case 241: /* $@36: %empty  */
#line 1796 "grammar.y"
                            { 
			/* Save pc before compiling statement for loop back
			 */
			stmt_pc = pc;
			n_oarr = 0;
			i_oarr = 0;
			ifseen = NULL;
		}
#line 4178 "y.tab.c"
    break;

  case 242: /* xstmt: $@36 stmt  */
#line 1804 "grammar.y"
                     {
		      	/* If there was an open reference compile the
			 * loop increment and goback.
			 */
			XINT push_pc;

			if (!errcnt) {
			    if (n_oarr) {
				compile (INDXINCR, stmt_pc-pc-4, 2*n_oarr+1);

				/* We are going to store initialization
				 * info for the implicit loop here.
				 * It is loopincr's responsibility to 
				 * branch around it.  This data is what
				 * should be pointed to by the special
				 * PUSHINDEX compiled at the first open
				 * array reference.
				 */
				push_pc = pop();  /* Location of PUSHINDEX */
				coderef(push_pc)->c_args = pc - push_pc - SZ_CE;

				stack[pc++] = n_oarr;
				for (i_oarr=0; i_oarr<n_oarr; i_oarr++) {
				    stack[pc++] = oarr_beg[i_oarr];
				    stack[pc++] = oarr_end[i_oarr];
				}

				/* Clear n_oarr.  This must be done here
				 * because we may have the end of a compound
				 * statement following on the heels of the
				 * end of the simple statement with the
				 * implicit loop.
				 */
				n_oarr = 0;
				i_oarr = 0;
			    }
			}
		}
#line 4221 "y.tab.c"
    break;

  case 244: /* xstmt: error NL  */
#line 1843 "grammar.y"
                         {
		    /* This should get most errors in executable statements
		     * or in the local variable declarations in a script.
		     */
		    yyerrok;

		    /* Get rid of any fake braces.
		     */
		    bracelevel -= tbrace;

		    /* Discard everything and compile a null statement.
		     */
		    if (!errcnt) {
			do_params = YES;
			pc = currentask->t_bascode;
			if (parse_state != PARSE_PARAMS)
			    compile (END);

			topd = currentask->t_topd;
			topcs = currentask->t_topcs;

			/* Unlink any added parms.  Resetting of topd will
			 * already have reclaimed space.
			 */
			if (last_parm) {
			    last_parm->p_np = NULL;
			    currentask->t_pfp->pf_lastpp = last_parm;
			    last_parm = NULL;
			}
 		    }

		    /* Tell user about the syntax error, printing the 
		     * offending line and position if possible.
		     */
		    if (currentask->t_flags & T_SCRIPT) {
		        if (errmsg != NULL) {
			    eprintf ("** Syntax error, line %d: %s\n",
			        currentask->t_scriptln, errmsg);
			} else {
			    eprintf ("** Syntax error, line %d\n",
			        currentask->t_scriptln);
			}
		    } else
			eprintf ("** Syntax error\n");
		    p_position();

		    if (!(currentask->t_flags & T_SCRIPT)) {
			/* If interactive, we're finished if not within braces.
			 */
			if (!bracelevel)
			    YYACCEPT;
		    }

		    /* Note that we do not call cl_error() here to abort, but
		     * continue on parsing the script for more syntax errors.
		     */
		    if (++errcnt > MAX_ERR)
			cl_error (E_UERR, "Too many syntax errors.");
		}
#line 4285 "y.tab.c"
    break;

  case 247: /* const_expr: const  */
#line 1908 "grammar.y"
                              {
				if (!errcnt) {
				    push(stkop(yyvsp[0])) ; 
				    ncaseval++;
				}
			}
#line 4296 "y.tab.c"
    break;

  case 250: /* ref: param  */
#line 1928 "grammar.y"
                      {
			int  dim, d, i1, i2, mode;

			/*  In command arguments, when not in parentheses
			 *  we just pass the param as a string constant.
			 */
			if (!errcnt) {
			    lastref = NO;
			    if (!inarglist || parenlevel) {
				i_oarr = 0;
				index_cnt = 0;

				strncpy (curr_param, stkop(yyvsp[0])->o_val.v_s, 
					SZ_FNAME);

				/* If a '.' is found in the name we have a 
				 * reference to an external task, or to a 
				 * specific field.  In these cases we don't 
				 * want implicit looping.
				 */
				if (index (curr_param, '.') == NULL) {
				    if ((dim = get_dim (curr_param)) > 0) {
					lastref = YES;
			        	for (d = 0; d < dim; d++) {
					    getlimits (curr_param, d, &i1, &i2);
					    mode = make_imloop (i1, i2);
					    if (mode)
						compile (PUSHINDEX, -1);
					    else
						push (compile(PUSHINDEX, 0));	
					}
			    		n_oarr = dim;
				    }
				}
			    }
			}
		}
#line 4338 "y.tab.c"
    break;

  case 251: /* $@37: %empty  */
#line 1965 "grammar.y"
                      {
		    if (!errcnt) {
			strncpy (curr_param, stkop(yyvsp[0])->o_val.v_s, SZ_FNAME);
			index_cnt = 0;
		    }
		}
#line 4349 "y.tab.c"
    break;

  case 252: /* ref: param $@37 '[' index_list ']'  */
#line 1972 "grammar.y"
                {
		    if (i_oarr > 0  &&  n_oarr == 0)
			n_oarr = i_oarr;
		    i_oarr = 0;
		    lastref = YES;
		}
#line 4360 "y.tab.c"
    break;

  case 253: /* index_list: index  */
#line 1980 "grammar.y"
                      {
			index_cnt = 1;
		}
#line 4368 "y.tab.c"
    break;

  case 254: /* $@38: %empty  */
#line 1983 "grammar.y"
                      {
			index_cnt++;
		}
#line 4376 "y.tab.c"
    break;

  case 256: /* index: expr1  */
#line 1989 "grammar.y"
                      {
			if (!errcnt)
			    compile (PUSHINDEX, 0);
		}
#line 4385 "y.tab.c"
    break;

  case 257: /* index: ref  */
#line 1994 "grammar.y"
                { 
			if (!errcnt) {
			    compile (PUSHPARAM, stkop(yyvsp[0])->o_val.v_s);
			    compile (PUSHINDEX, 0);
			}
		}
#line 4396 "y.tab.c"
    break;

  case 258: /* index: '*'  */
#line 2000 "grammar.y"
                    {
			int  i1, i2, mode;

			if (!errcnt) {
			    if (strchr(curr_param, '.') != NULL) {
				errmsg = exlimits;
				EYYERROR;
			    }
			    if (getlimits (curr_param, index_cnt, &i1, &i2) 
				== ERR) {
				eprintf ("Implicit index error for %s.\n",
					curr_param);
				EYYERROR;
			    }
			    mode = make_imloop (i1, i2);
			    if (mode)
				compile (PUSHINDEX, mode);
			    else
				push (compile (PUSHINDEX, mode));
			}
		}
#line 4422 "y.tab.c"
    break;

  case 259: /* index: Y_CONSTANT  */
#line 2021 "grammar.y"
                           {
			/*  There is an ambiguity in the grammar between
			 *  sexagesimal constants, and array range references.
			 *  Since the sexagesimal constants are recognized
			 *  in the lexical analyzer we can't just change the
			 *  grammar.  The kludge around this is to have
			 *  makeop set a flag telling us that the last
			 *  constant it compiled COULD have been an index
			 *  range.  We check the flag here and if it is
			 *  set we convert back and compile an implicit loop
			 *  otherwise we just push the constant.
			 */
			int  i1, i2, mode;

			if (!errcnt) {
			    if (maybeindex) {
				sexa_to_index (stkop(yyvsp[0])->o_val.v_r, &i1, &i2);
				mode = make_imloop (i1, i2);
				if (mode)
				    compile (PUSHINDEX, mode);
				else
				    push (compile (PUSHINDEX, mode));
			    } else {
				compile (PUSHCONST, stkop(yyvsp[0]));
				compile (PUSHINDEX, 0);
			    }
			}
		}
#line 4455 "y.tab.c"
    break;

  case 260: /* intrins: Y_IDENT  */
#line 2055 "grammar.y"
                        {
		    yyval = yyvsp[0];
		}
#line 4463 "y.tab.c"
    break;

  case 261: /* param: Y_IDENT  */
#line 2060 "grammar.y"
                        {
		    yyval = yyvsp[0];
		}
#line 4471 "y.tab.c"
    break;

  case 262: /* tasknam: Y_IDENT  */
#line 2065 "grammar.y"
                        {
		    yyval = yyvsp[0];
		}
#line 4479 "y.tab.c"
    break;

  case 264: /* EOST: ';'  */
#line 2071 "grammar.y"
                    {
		    /* If statements are delimited by ';'s, do not execute
		     * until next newline EOST is received.
		     */
		    sawnl = 0;
		}
#line 4490 "y.tab.c"
    break;

  case 270: /* LP: '('  */
#line 2093 "grammar.y"
                        { parenlevel++; }
#line 4496 "y.tab.c"
    break;

  case 271: /* RP: ')'  */
#line 2096 "grammar.y"
                        { --parenlevel; }
#line 4502 "y.tab.c"
    break;

  case 272: /* NL: Y_NEWLINE  */
#line 2099 "grammar.y"
                           { sawnl = 1; }
#line 4508 "y.tab.c"
    break;


#line 4512 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2102 "grammar.y"


#include "lexyy.c"
#include "lexicon.c"
